<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (!defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))) . '/includes/404.php';
}

/**
 * Reminding_admin
 *
 * Восстановление пароля в административной части
 */
class Reminding_admin extends Model
{
	/**
	 * @var array сгенерированные в моделе данные, передаваемые в шаблон
	 */
	protected $result;

	/**
	 * @var object основной объект системы
	 */
	protected $diafan;

    /**
     * Конструктор класса
     *
     * @param Initadmin $diafan
     * @return \Reminding_admin
     */
	public function __construct(&$diafan)
	{
		$this->diafan = &$diafan;
		include_once ABSOLUTE_PATH . 'includes/function.php';
		include_once ABSOLUTE_PATH . 'includes/ajax.php';
		include_once ABSOLUTE_PATH . 'modules/reminding/reminding.ajax.php';
		$ajax = new Reminding_ajax( $diafan );
		if ($ajax->ajax_request())
		{
			exit;
		}
	}

	/**
	 * Генерирует данные для формы восстановления пароля
	 *
	 * @return array
	 */
	public function form()
	{
		if ($this->diafan->_user->id)
		{
			$this->result["error"] = _LANG_YOU_ARE_REGISTRED;
			return $this->result;
		}

		$this->result["captcha"] = $this->diafan->_captcha->get("reminding", $this->get_error("reminding", "code"));

		$this->result["action"] = BASE_PATH_HREF . $_GET["rewrite"] . '/';
		$this->result["error"] = $this->get_error("reminding");
		$this->result["error_name"] = $this->get_error("reminding", 'name');
		$this->result["error_mail"] = $this->get_error("reminding", 'mail');
		return $this->result;
	}

	/**
	 * Выводит контент модуля
	 *
	 * @return boolean
	 */
	public function show_module()
	{
		$this->diafan->_tpl->get('form', 'reminding', $this->result);

		return TRUE;
	}
}