<?php

/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */
if (!defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))) . '/includes/404.php';
}

/**
 * Frame_admin
 *
 * Список элементов
 */
class Frame_admin extends Theme_admin
{

	public $diafan;

	/**
	 * @var array настройки отображения
	 */
	public $config_module;

	/**
	 * @var integer|string язык поля, обозначающего активность
	 */
	public $lang_act;

	/**
	 * @var array список дополнительных полей, выводимых в списке
	 */
	public $config_other_row;

	/**
	 * @var string SQL-условия для списка
	 */
	protected $where;

	/**
	 * @var integer порядковый номер элемента, с которого начинается вывод элементов
	 */
	private $polog = 0;

	/**
	 * @var array переводимые поля
	 */
	public $language_names = array ();

	/**
	 * @var array родители текущего раскрытого элемента
	 */
	public $parent_parents = array ();

	/**
	 * @var integer количество элементов, показанных на странице
	 */
	protected $nastr = 30;

	/**
	 * @var string GET переменные, участвующие в навигации для постраничного вывода
	 */
	protected $get_nav;

	/**
	 * @var string ссылка на текущую страницу, используемая в постраничной навигации
	 */
	private $navlink;

	/**
	 * @var string ссылка на текущую страницу, используемая при раскрытии/закрытии дерева
	 */
	private $enterlink;

	/**
	 * @var integer общее количество елементов
	 */
	protected $count;

	/**
	 * @var integer количество ссылок постраничной навигации, показанных на одной страние
	 */
	//protected $navnastr = 10;

    /**
     * Конструктор класса
     *
     * @param Initadmin $diafan
     * @return \Frame_admin
     */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;
	}

	public function ajax_expand()
	{
		// Прошел ли пользователь проверку идентификационного хэша
		if (!$this->diafan->_user->checked)
		{
			echo "{error:'HASH'}";
			exit;
		}

		$_POST['parent_id'] = (int)preg_replace("/\D/", '', $_POST['parent_id']);
		$_POST['level'] = (int)preg_replace("/\D/", '', $_POST['level']);

		ob_start();
		$this->list_row($_POST['parent_id'], $_POST['level']);
		$res['html']=ob_get_contents();
		ob_end_clean();

		$res['hash']=$this->diafan->_user->get_hash();


		include_once ABSOLUTE_PATH . 'plugins/json.php';
		echo to_json($res);
	}


	/**
	 * Формирует список элементов
	 *
	 * @param integer $id родитель
	 * @param integer $r подрядковый номер
	 * @return boolean TRUE
	 */
	public function list_row($id = 0, $level = '')
	{
		$this->prepare_variables($id);

		$links = $this->prepare_paginator($id);
		$result = $this->sql_query($id);
		$this->count = DB::num_rows($result);

		if (empty( $level ))
		{
			$level = '1';
		}

		echo '<ul class="list' . ( $this->config_module['order'] ? ' move' : '' ) . '">';

		while ($row = DB::fetch_array($result))
		{
			echo '<li class="level_' . $level . '" row_id="' . $row['id'] . '"' . ( $this->config_module['parent'] ? ' parent_id="' . $row['parent_id'] . '"' : '' ) . '>
			<a name="' . $row['id'] . '">
		    <div class="table_wrap' . ( ( $this->config_module['act'] && !$row['act'] ) ? ' no_act' : '' ) . '">
		    <table width="100%" class="rows">
		    <tr>' . $this->get_move() . $this->group_actions_input($row, $level) . $this->get_plus($row) . $this->get_parent_name($row) . $this->get_date($row) . $this->get_image($row["id"]) . '<td class="name">' . $this->get_base_link($row) . $this->get_menu($row['id']);

			if ($this->table == "site" && $row["addmodule"] && file_exists(ABSOLUTE_PATH.'adm/img/icons/'.$row["addmodule"].'.gif'))
			{
				echo '<img src="'.BASE_PATH.'adm/img/icons/'.$row["addmodule"].'.gif" align="absmiddle" title="'._ADMIN_MODULE.'" alt="'._ADMIN_MODULE.'" class="module_icons">';
			}
			echo '</td>';

			$this->get_fast_rows($row);
			$this->get_other_rows($row);

			echo $this->get_actions($row) . '</tr>
			</table></div></a>';
			//выводит вложенные элементы
			if (!empty( $this->config_module["parent"] ) && in_array($row["id"], $this->parent_parents))
			{
				$c = $this->count;
				$this->list_row($row["id"], $level + 1);
				$this->count = $c;
			}
			echo  '</li>';
		}

		echo '</ul>';
		if (!empty( $links ) && $level == '1')
		{
			echo  $this->diafan->_tpl->get('get_admin', 'paginator', $links);
		}
		if ($level == '1' && $this->count > 3)
		{
			$this->group_action_panel();
		}

		return TRUE;
	}

	private function get_date($row)
	{
		$html = ( $this->config_module["date"] ? '<td class="date">' . date("d.m.Y", $row["created"]) . '</td>' : '' ) . ( $this->config_module["datetime"] ? '<td class="datetime">' . date("d.m.Y H:i", $row["created"]) . '</td>' : '' );

		return $html;
	}

	/**
	 * Определяет свойства класса
	 *
	 * @param integer $id родитель
	 * @return boolean true
	 */
	private function prepare_variables($id)
	{
		$this->name .= in_array($this->name, $this->language_names) ? _LANG : '';

		$this->k = 1;
		$this->lang_act = in_array("act", $this->language_names) ? _LANG : '';

		if ($this->config_other_row)
		{
			foreach ($this->config_other_row as $key => $value)
			{
				$this->config_other_row[$key] .= in_array($value, $this->language_names) ? _LANG : '';
			}
		}

		if ($this->config_module["parent"] && $this->diafan->parent && empty( $this->parent_parents ))
		{
			$this->parent_parents = $this->diafan->get_parents($this->diafan->parent, $this->table);
			$this->parent_parents[] = $this->diafan->parent;
		}
		return TRUE;
	}

	/**
	 * Выводит изображение элемента в списке
	 *
	 * @param integer $id номер элемета
	 * @param string $link основная ссылка
	 * @return string
	 */
	public function get_image($id)
	{
		$image = '';
		if ($this->config_module["image"])
		{
			$row = DB::fetch_array(DB::query("SELECT id, name FROM {images} WHERE element_id=%d AND module_name='%s' AND trash='0' ORDER BY sort ASC LIMIT 1", $id, $this->table));
			if ($row && file_exists(ABSOLUTE_PATH . USERFILES . "/" . $this->table . "/small/" . $row["name"]))
			{
				$image = '<td class="img"><img src="http://' . BASE_URL . '/' . USERFILES . '/' . $this->table . "/small/" . $row["name"] . '" border="0" alt=""></td>';
			}
		}

		return $image;
	}

	/**
	 * Выводит название раздела/категории в списке
	 *
	 * @param array $row информация о текущем элменте списка
	 * @return string
	 */
	protected function get_parent_name($row)
	{
		$text = '';
		if ($this->config_module["element_site"] && !$this->diafan->site && $this->not_empty_site)
		{
			if (!isset( $this->cache["site"][$row["site_id"]]["name"] ))
			{
				$this->cache["site"][$row["site_id"]]["name"] = DB::query_result("SELECT name FROM {site} WHERE id=%d AND trash='0'", $row["site_id"]);
			}
			$text = '<td class="parent_name">' . $this->cache["site"][$row["site_id"]]["name"] . '</td>';
		}
		if ($this->config_module["element_multiple"])
		{
			$cats = array ();
			$result = DB::query("SELECT s.[name] FROM {" . $this->diafan->module . "_category_rel} as c INNER JOIN {" . $this->diafan->module . "_category} as s ON s.id=c.cat_id" . " WHERE element_id='%d'", $row["id"]);
			while ($row_cat = DB::fetch_array($result))
			{
				$cats[] = $row_cat["name"];
			}
			$text .= '<td class="cat_name">' . implode(', ', $cats) . '</td>';
		}
		return $text;
	}

	private function get_fast_rows($row)
	{
		if (!empty( $this->fast_edit_rows ))
		{


			$rows = array ();
			foreach ($this->fast_edit_rows as $value)
			{
				$func = 'fast_row_' . preg_replace('/[^a-z_]+/', '', $value);
				if (method_exists($this, $func))
				{
					$this->$func($row);
				}
				else
				{
					$rows[] = $value;
				}
			}

			if (empty( $rows ))
			{
				return FALSE;
			}

			$sql = DB::query('SELECT ' . implode(',', $rows) . ' FROM {' . $this->table . '} WHERE id="%d" LIMIT 1', $row['id']);
			while ($rows = DB::fetch_array($sql))
			{
				foreach ($rows as $k => $v)
				{
					echo '</td><td class="fast_edit">';
					$name = crc32($k);
					$type = $this->get_variable($k);
					switch ($type)
					{

						case 'numtext':
							echo '<input type="text" row_id="' . $row['id'] . '" name="' . $name . '" value="' . $v . '" class="inpnum">';
							break;
						case 'floattext':
							echo '<input type="text" row_id="' . $row['id'] . '" name="' . $name . '" value="' . number_format($v, 2, ',', '') . '" class="inpnum">';
							break;
						case 'editor':
						case 'textarea':
							echo ' <textarea name="' . $name . '" row_id="' . $row['id'] . '" cols="40" rows="3">' . str_replace(array ( '<',
								'>', '"' ), array ( '&lt;', '&gt;', '&quot;' ), $v) . '</textarea>';
							break;
					}
					echo '</td>';
				}
			}
		}
		return FALSE;
	}

	/**
	 * Выводит дополнительную информацию для элемента в списке
	 *
	 * @param array $row информация о текущем элменте списка
	 * @return boolean TRUE
	 */
	private function get_other_rows($row)
	{
		if ($this->config_other_row)
		{
			foreach ($this->config_other_row as $value)
			{
				$func = 'other_row_' . preg_replace('/[^a-z_]+/', '', $value);
				if (method_exists($this, $func))
				{
					echo $this->$func($row);
				}
				else
				{

					echo '<td class="comment">
					<div>
						<span></span>
						<table><tbody><tr><td>
							' . ( !empty( $row[$value] ) ? $this->diafan->short_text($row[$value]) : '' ) . '
						</td></tr></tbody></table>
					</div></td>';

				}
			}
		}
		return TRUE;
	}

	/**
	 * Выводит ссылку на добавление элемента
	 *
	 * @param string $text текст ссылки "Добавить элемент"
	 * @return boolean TRUE
	 */
	protected function addnew_init($text)
	{
		echo '
		<div class="add_new">
			<a href="' . URL;
		if ($this->config_module['element_site'] && strpos(URL, 'site') === FALSE && !empty( $this->diafan->site ))
		{
			echo 'site' . $this->diafan->site . '/';
		}
		echo 'addnew1/" title="' . $text . '">' . $text . '</a>
		</div>';
		return TRUE;
	}

	public function get_move()
	{
		$img = '';
		if ($this->config_module['order'])
		{
			$img = '<td class="move"><img src="' . BASE_PATH . 'adm/img/drag.png" alt="' . _ADMIN_DRAG . '"></td>';
		}
		return $img;
	}

	/**
	 * Выводит пометку "Отображается в меню"
	 *
	 * @param integer $id номер текущего элемента
	 * @return boolean TRUE
	 */
	private function get_menu($id)
	{
		$text = '';
		if ($this->config_module["menu"])
		{
			if ($this->diafan->module == 'site')
			{
				$name_menu = 'site_id';
			}
			elseif ($this->config_module["category"])
			{
				$name_menu = 'module_cat_id';
			}
			else
			{
				$name_menu = 'element_id';
			}
			$is_menu = 0;
			if (DB::query_result("SELECT COUNT(*) FROM {menu} WHERE module_name='%h' AND " . $name_menu . "=%d AND trash='0' AND [act]='1'", $this->diafan->module, $id))
			{
				$text = ' <span title="' . _ADMIN_MENU . '">(м)</span>';
				if ($this->diafan->module == 'site')
				{
					$is_menu = 1;
				}
			}
			if ($this->diafan->module == 'site')
			{
				DB::query("UPDATE {site} SET is_menu='%d' WHERE id=%d", $is_menu, $id);
			}
		}
		return $text;
	}

	private function group_actions_input($row, $level)
	{
		if ($level == '1' && $this->count <= 3)
		{
			return null;
		}

		$input = '';

		$flag = 0;
		if (( $this->table != "users" || $this->diafan->_user->id != $row["id"] ) && ( $this->table != "trash" || !$row["parent_id"] ) && ( $this->table != "language" || $row["id"] != 1 ))
		{
			$flag = 1;
		}

		if (( ( $this->config_module["del"] && !$this->diafan->admin_roles('del') ) && $flag ) || ( $this->config_module["act"] && !$this->diafan->admin_roles('act') && $flag )
		)
		{
			$input = '<input type="checkbox" name="ids[]" value="' . $row["id"] . '">';
		}


		return '<td class="checkbox">' . $input . '</td>';
	}

	private function group_action_panel()
	{
		$dop = '';

		$html = '<div class="group_action'.(!$this->config_module['order']?' no_move':'').'">
	    <form method="post" class="ajax">
	    <input type="hidden" name="ajax" value="0">
	    
		<table><tr>
		<td><input type="checkbox" id="select_all"></td> 
		<td><span class="select_all">'._ADMIN_CHECK_ALL.'</span></td>
		<td><select name="action">';

		if ($this->config_module["act"] && !$this->diafan->admin_roles('act'))
		{
			$html .= "<option value='block'>" . _ADMIN_UNBLOCK . "</option><option value='unblock'>" . _ADMIN_BLOCK . "</option>";
		}

		if ($this->config_module["del"] && !$this->diafan->admin_roles('del'))
		{
			$html .= '<option value="' . ( $this->config_module["trash"] ? 'trash' : 'delete' ) . '" confirm="' . ( $this->config_module["trash"] ? _ADMIN_CONFIRM_TRASH : _ADMIN_CONFIRM_DELETE ) . '">' . _LANG_DELETE . '</option>';
		}

		if ($this->config_module["menu"] && !$this->diafan->admin_roles('edit'))
		{
			$html .= '<option value="group_menu" module="menu">' . _ADMIN_MENU . '</option>';

			$result = DB::query("SELECT id, name FROM {menu_category} WHERE trash='0' ORDER BY id ASC");
			$dop .= "<div class='dop_group_menu hide'>";
			$dop .= '<input type="hidden" name="table" value="'.$this->table.'">';
			while ($row = DB::fetch_array($result))
			{
				$dop .= '<input type="checkbox" name="menu_cat_ids[]" value="'.$row["id"].'"> ' . $row["name"] . '<br>';
			}
			$dop .= "</div>";

		}


		$cat = $this->show_filter();
		if (!empty( $cat ))
		{
			$dop = "<div class='dop_element hide'>" . str_replace(' class="redirect" ', '', $cat) . '</div>';
			$html .= '<option value="element">'._ADMIN_MOVE_TO_CATEGORY.'</option>';
		}


		$html .= '</select></td><td><input type="submit" id="group_actions" value="Применить" class="button"></td></tr>
<tr class="dop_rows"><td colspan="3">' . $dop . '</td><td></td></tr>
</table>
		</form></div>';

		echo $html;
	}

	public function get_actions($row)
	{
		static $num_actions;

		if ($this->config_module["menu"] && $row["act"])
		{
			if ($this->diafan->module == "site")
			{
				$row["view_link"] = $this->diafan->_route->link($row["id"]);
			}
			elseif ($this->config_module["category"])
			{
				$row["view_link"] = $this->diafan->_route->link($row["site_id"], $this->diafan->module, $row["id"]);
			}
			else
			{
				if (!$this->config_module["element"])
				{
					$row["cat_id"] = 0;
				}
				$row["view_link"] = $this->diafan->_route->link($row["site_id"], $this->diafan->module, $row["cat_id"], $row["id"]);
			}
		}

		$actions = array ();
		//add
		if ($this->config_module["parent"] && !$this->diafan->admin_roles('edit') && $this->table != "trash" && ( !$this->config_module["view"] || !$row["block"] ) && ( $this->config_module["act"] && $row["act"] ))
		{
			$actions[] = '<td class="action_icon"><a href="' . path_module($this->diafan, 0, 1) . 'parent' . $row["id"] . '/' . 'addnew' . $row["id"] . '/" title="' . _ADMIN_ADD_SUBPAGE . '"><img src="' . BASE_PATH . 'adm/img/add.png" alt="' . _ADMIN_ADD_SUBPAGE . '"></a></td>';
		}

		//act
		if ($this->config_module["act"] && !$this->diafan->admin_roles('edit') && ( $this->table != "users" || $row["id"] != $this->diafan->_user->id ))
		{
			$actions[] = '<td class="action_icon"><a href="javascript:void(0);" title="' . ( $row["act"] ? _ADMIN_BLOCK : _ADMIN_UNBLOCK ) . '" action="' . ( $row["act"] ? 'un' : '' ) . 'block">' . '<img src="' . BASE_PATH . 'adm/img/on.png" alt="' . ( $row["act"] ? _ADMIN_BLOCK : _ADMIN_UNBLOCK ) . '"></a></td>';
		}

		//del|trash
		if ($this->config_module["del"] && ( $this->table != "trash" || !$row["parent_id"] ) && !$this->diafan->admin_roles('del') && ( $this->table != "language" || $row["id"] != 1 ) && ( $this->table != "menu_category" || $row["id"] != 1 ) && ( $this->table != "users" || $this->diafan->_user->id != $row["id"] ))
		{
			$actions[] = '<td class="action_icon"><a href="#" title="' . _LANG_DELETE . '"' . ' confirm="' . ( $this->config_module["trash"] ? ( !empty( $row["count_children"] ) ? _ADMIN_CONFIRM_TRASH_PARENT : _ADMIN_CONFIRM_TRASH ) : ( !empty( $row["count_children"] ) ? _ADMIN_CONFIRM_DELETE_PARENT : _ADMIN_CONFIRM_DELETE ) ) . '" action="' . ( $this->config_module["trash"] ? 'trash' : 'delete' ) . '">' . '<img src="' . BASE_PATH . 'adm/img/delete.png" alt="' . _LANG_DELETE . '"></a></td>';
		}


		if ($this->config_module["menu"] && $row["act"] && ( !$this->config_module["view"] || !$row["block"] ))
		{
			$actions [] = '<td class="action_icon"><a href="' . BASE_PATH . _SHORTNAME . $row["view_link"] . '" title="' . _ADMIN_SHOW_PAGE_SITE . '" target="_blank">' . '<img src="' . BASE_PATH . 'adm/img/view.png" alt="' . _ADMIN_SHOW_PAGE_SITE . '"></a></td>';
		}

		$count=count($actions);


		$new='';
		if($count >= $num_actions) { $num_actions=$count; }
		else
		{
			//$new=array_fill(0,$num_actions-$count,'<td class="action_icon"></td>');
			//$new=implode('<td style="width: 2px;"><span></span></td>', $new);
			$new=str_repeat('<td style="width: 2px;"></td><td class="action_icon"></td>',$num_actions-$count);
		}


		return $new.($count?'<td class="action_separator"><span></span></td>' . implode('<td class="action_separator"><span></span></td>', $actions):'');
	}

	/**
	 * Формирует основную ссылку для элемента в списке
	 *
	 * @param array $row информация о текущем элменте списка
	 * @return string
	 */
	public  function get_base_link($row)
	{
		$name = $this->diafan->short_text($row["name"]);
		if (empty( $name ))
		{
			$name = $row['id'];
		}
		if ($this->diafan->module == "trash")
		{
			return $name;
		}


		$link = '<a href="';
		if ($this->config_module["view"] && $row["addmodule"] && file_exists(ABSOLUTE_PATH . 'modules/' . $row["addmodule"] . '/admin/' . $row["addmodule"] . '.admin.php'))
		{
			$link .= BASE_PATH_HREF . $row["addmodule"] . '/site' . $row["id"] . '/';
		}
		elseif ($this->config_module["link_to_element"])
		{
			$link .= $this->diafan->_route->current_admin_link(array ( "page", "parent" )) . 'cat' . $row["id"] . '/';
		}
		elseif ($this->config_module["element_site"] && !$this->diafan->admin_roles('edit'))
		{
			$link .= $this->diafan->_route->current_admin_link('site') . 'site' . $row['site_id'] . '/edit' . $row["id"] . '/" title="' . _LANG_EDIT . ' (' . $row["id"] . ')';
		}
		elseif (!$this->diafan->admin_roles('edit'))
		{

			$link .= $this->diafan->_route->current_admin_link() . 'edit' . $row["id"] . '/" title="' . _LANG_EDIT . ' (' . $row["id"] . ')';
		}
		else
		{
			$link .= '#';
		}
		$link .= '"';
		if ($this->config_module["act"] && !$row["act"])
		{
			$link .= ' class="noplus"';
		}
		$link .= '>' . $name . '</a>';
		return $link;
	}

	private function get_plus($row)
	{
		if (!$this->config_module['parent'])
		{
			return null;
		}

		$act = '';
		if ($this->config_module['act'] && !$row['act'])
		{
			$act = '_no_act';
		}

		$html = '';

		if ($row["count_children"])
		{

			if (in_array($row["id"], $this->parent_parents))
			{
				$html = '<a href="#" rel="' . $row['id'] . '" class="plus turn" title="' . _ADMIN_CURTAIL . '"><img src="' . BASE_PATH . 'adm/img/item_minus' . $act . '.png" alt="' . _ADMIN_CURTAIL . '"></a>';
			}
			else
			{
				$html = '<a href="#parent' . $row['id'] . '" rel="' . $row['id'] . '" class="plus expand" title="' . _ADMIN_UNWRAP . '"><img src="' . BASE_PATH . 'adm/img/item_plus' . $act . '.png" alt="' . _ADMIN_UNWRAP . '"></a>';
			}


		}

		return '<td class="item_plus_minus">' . $html . '</td>';
	}

	/**
	 * Формирует SQL-запрос для списка элементов
	 *
	 * @param integer $id родитель
	 * @return resource
	 */
	private function sql_query($id)
	{
		return DB::query("SELECT e.id, e." . $this->name . " AS name" .
			( $this->config_module["act"] ? ', e.act' . $this->lang_act . ' AS act' : '' ) .
			( $this->config_module["parent"] ? ', e.parent_id, e.count_children' : '' ) .
			( $this->config_other_row ? ', e.' . implode(', e.', $this->config_other_row) : '' ) .
			( $this->config_module["date"] || $this->config_module["datetime"] ? ', e.created' : '' ) .
			( $this->config_module["view"] ? ', e.addmodule, e.block' : '' ) .
			( $this->config_module["element_site"] ? ', e.site_id' : '' ) .
			( $this->config_module["element_multiple"] ? ', e.cat_id' : '' ) .
			( $this->config_module["order"] ? ', e.sort' : '' ) . " FROM {" . $this->table . "} as e" . (
		$this->config_module["element_multiple"] && $this->diafan->cat ?
			" INNER JOIN {" . $this->table . "_category_rel} AS c ON e.id=c.element_id" .
				" AND e.id=c.element_id AND c.cat_id='" . $this->diafan->cat . "'" : '' ) . " WHERE 1=1" .
			( $this->config_module["parent"] ? " AND e.parent_id='" . $id . "'" : '' ) . (
		$this->config_module["element"] && !$this->config_module["element_multiple"] && $this->diafan->cat ?
			" AND e.cat_id='" . $this->diafan->cat . "'" : '' ) . (
		$this->config_module["element_site"] && $this->diafan->site ?
			" AND e.site_id='" . $this->diafan->site . "'" : '' ) . ( $this->where ? " " . $this->where : '' ) .
			( $this->table == 'site' ? " AND e.id<>1 AND e.block='0'" : '' ) .
			( $this->config_module["trash"] ? " AND e.trash='0'" : '' ) .
			( $this->config_module["element_multiple"] && $this->diafan->cat ? " GROUP BY e.id" : '' ) . " ORDER BY " .
			( $this->config_module["prior"] ? 'e.prior DESC, ' : '' ) .
			( $this->config_module["date"] || $this->config_module["datetime"] ? 'e.created DESC, ' : '' ) .
			( $this->config_module["act"] ? 'e.act' . $this->lang_act . ' DESC, ' : '' ) .
			( $this->table == 'site' ? " e.is_menu DESC, e.block ASC, " : '' ) .
			( $this->config_module["order"] ? 'e.sort ASC, e.id ASC' : 'e.id DESC' ) . ' LIMIT ' . $this->polog . ', ' .
			$this->nastr);
	}

	/**
	 * Формирует постраничную навигацию
	 *
	 * @return array
	 */
	private function prepare_paginator($id)
	{
		if ($this->nastr)
		{
			$this->diafan->_paginator->nastr = $this->nastr;
		}
		if (!$id || !$this->config_module["parent"])
		{
			$this->diafan->_paginator->page = $this->diafan->page;
			$this->diafan->_paginator->navlink = ( $this->diafan->rewrite ? $this->diafan->rewrite . '/' : '' ) . ( $this->diafan->site ? 'site' . $this->diafan->site . '/' : '' ) . ( $this->diafan->cat ? 'cat' . $this->diafan->cat . '/' : '' );
			$this->enterlink = $this->diafan->_paginator->navlink . 'parent%d/' . ( $this->diafan->_paginator->page ? 'page' . $this->diafan->_paginator->page . '/' : '' ) . '?';
			$this->diafan->_paginator->get_nav = $this->get_nav;
			$this->navlink .= $this->diafan->_paginator->navlink . 'parent%d/' . ( $this->diafan->_paginator->page ? 'page' . $this->diafan->_paginator->page . '/' : '' ) . ( $this->get_nav ? $this->get_nav . '&' : '?' );
		}
		elseif ($this->config_module["parent"])
		{
			$this->diafan->_paginator->page = !empty( $_GET["page" . $id] ) ? intval($_GET["page" . $id]) : 0;
			$this->diafan->_paginator->urlpage = 'page' . $id . '=%d';
			$this->enterlink = $this->enterlink . ( $this->diafan->_paginator->page ? 'page' . $id . '=' . $this->diafan->_paginator->page : '' ) . '&';
			$this->diafan->_paginator->navlink = sprintf($this->navlink, $id);
			$this->diafan->_paginator->get_nav = '';
			$this->navlink .= $this->diafan->_paginator->page ? 'page' . $id . '=' . $this->diafan->_paginator->page . '&' : '';
		}

		$this->nen = DB::query_result("SELECT COUNT(DISTINCT e.id) FROM {" . $this->table . "} as e" . ( $this->config_module["element_multiple"] && $this->diafan->cat ? " INNER JOIN {" . $this->table . "_category_rel} AS c ON e.id=c.element_id" . " AND e.id=c.element_id AND c.cat_id='" . $this->diafan->cat . "'" : '' ) . " WHERE 1=1" . ( $this->config_module["parent"] ? " AND e.parent_id='" . $id . "'" : '' ) . ( $this->config_module["element"] && !$this->config_module["element_multiple"] && $this->diafan->cat ? " AND e.cat_id='" . $this->diafan->cat . "'" : '' ) . ( $this->config_module["element_site"] && $this->diafan->site ? " and e.site_id='" . $this->diafan->site . "'" : '' ) . ( $this->where ? " " . $this->where : '' ) . ( $this->table == 'site' ? " AND e.id<>1" : '' ) . ( $this->config_module["trash"] ? " AND e.trash='0'" : '' ));
		$this->diafan->_paginator->nen = $this->nen;

		$links = $this->diafan->_paginator->get();
		$this->polog = $this->diafan->_paginator->polog;
		$this->nastr = $this->diafan->_paginator->nastr;

		return $links;
	}

}