<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include(dirname(dirname(dirname(__FILE__))).'/includes/404.php');
}

/**
 * Banners_admin
 *
 * Редактирование баннеров
 */
class Banners_admin extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file = 'banners';

	/**
	 * @var string таблица в базе данных
	 */
	public $table = 'banners';

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;

		//поля в базе данных для редактирования
		$this->variable_table = array(
			'main'=>
			array (
				'name' => 'text',
				'act' => 'checkbox',
				'view' => 'disabled',
				'click' => 'disabled',
				'hr1' => 'hr',
				'file' => 'function',
				'link' => 'text',
				'hr2' => 'hr',
				'date' => 'function',
				'check_number' => 'checkbox',
				'show_number' => 'numtext',
				'check_user' => 'checkbox',
				'show_user' => 'numtext',
				'hr3' => 'hr',
				'section' => 'select',
				'site_ids' => 'function',
			),
			'other_rows'=>
			array (
				'number' => 'function',
				'cat_id' => 'function',
			)
		);

		//переводимые поля
		$this->language_names = array(
			'name',
            'act'
		);
		
		$this->config_module = array(
			'act'              => 1, //показать/скрыть
			'del'              => 1, //удалить
			'element'          => $this->diafan->configmodules("cat", "banners", $this->diafan->site) ? 1 : 0, //используются группы
			'search_name'      => 1, //искать по названию
			'trash'            => 1,  //использовать корзину
            'category_flat' => 1  // категори не содержат вложенности
		);
        
        
		//выводить в списке содержание полей:
		$this->config_other_row = array(
			'view',
            'click'
		);   

		$this->select_arr["section"] = array(
			"0" => _ADMIN_BANNERS_SHOW_0,
			"2" => _ADMIN_BANNERS_SHOW_1,
			"3" => _ADMIN_BANNERS_SHOW_2,
			"1" => _ADMIN_BANNERS_SHOW_3
		);                  
	}

	/**
	 * Выводит список баннеров
	 * @return boolean true
	 */
	public function show_module()
	{		
		if ($this->config_module['element'] && ! $this->not_empty_categories)
		{
			echo '<div class="error">'.sprintf(_ADMIN_BANNERS_EMPTY_CATEGORIES, '<a href="'.BASE_PATH_HREF.'banners/config/">', '</a>','<a href="'.BASE_PATH_HREF.'banners/category/'.($this->diafan->site ? 'site'.$this->diafan->site.'/' : '').'">', '</a>').'</div>';
		}
		else
		{
			$this->addnew_init(_ADMIN_BANNERS_ADD);
		}
		
			$this->list_row();
		

		return TRUE;
	}

	/**
	 * Выводит количество просмотров баннера
	 * 
	 * @return string
	 */
	protected function other_row_view($row)
	{
		return '<td class="element_id">'._ADMIN_BANNERS_VIEW_LIST.': '.$row["view"].'</td>';
	}

	/**
	 * Выводит количество кликов баннера
	 * 
	 * @return string
	 */
	protected function other_row_click($row)
	{
		return '<td class="element_id">'._ADMIN_BANNERS_CLICK_LIST.': '.$row["click"].'</td>';
	}
        
    /**
	 * Редактирование поля "Ограничить количество показов"
	 * @return boolean true
	 */
	protected function edit_check_number_module()
	{	
        $check = DB::query_result("SELECT check_number FROM {banners} WHERE id=%d", $this->diafan->edit);
		echo '
		<tr>
		<td align="right">'.$this->variable_names().'</td>
		<td>				
		<input type="checkbox" name="check_number" class="show_tr_click_checkbox" value="1" rel="#show_number" '.(!empty($check) ? 'checked="checked"' : '').'>	
		</td>
		</tr>';

		return TRUE;
	
	}
    
    /**
	 * Редактирование поля "Ограничить количество показов посетителю в сутки"
	 * @return boolean true
	 */
	protected function edit_check_user_module()
	{	
		$check = DB::query_result("SELECT check_user FROM {banners} WHERE id=%d", $this->diafan->edit);
		echo '
		<tr>
			<td align="right">'.$this->variable_names().'</td>
			<td>				
				<input type="checkbox" name="check_user" class="show_tr_click_checkbox" value="1" rel="#show_user" '.(!empty($check) ? 'checked="checked"' : '').'>	
			</td>
		</tr>';

		return TRUE;
	
	}
        
    /**
	* Редактирование поля "Файл"
	* @return boolean true
	*/
	protected function edit_file_module()
	{
		$file_type = 1;
		echo '
		<tr>
			<td align="right">'._ADMIN_BANNERS_TYPE.'</td>
			<td>';				
			$result = DB::query("SELECT id, type, name, file, html, width, height, alt, title FROM {banners} WHERE id='%d'", $this->diafan->edit);
			while ($row = DB::fetch_array($result))
			{
				$file_type = $row['type'];
				$file_name =  $row['file'];  
				$html =  $row['html'];
				$width = $row['width'];
				$height = $row['height'];
				$alt = $row['alt'];
				$title = $row['title'];
			}

		echo '
		<input type="radio" name="type" value="1"'.($file_type == 1 ? ' checked' : '').'> '._ADMIN_BANNERS_TYPE_IMAGE.'
		<input type="radio" name="type" value="2"'.($file_type == 2 ? ' checked' : '').'> '._ADMIN_BANNERS_TYPE_FLASH.'
		<input type="radio" name="type" value="3"'.($file_type == 3 ? ' checked' : '').'> '._ADMIN_BANNERS_TYPE_BLOCK.'

		<div class="type1'.($file_type == 1 ? '' : ' hide').'"><input type="file" name="attachment_img" size="40"><br>'.($file_type == 1 && !empty($file_name) ? $file_name : '').'
		<div style="padding: 8px 0 0 0;"><input type="text" class="inptext" name="alt" size="10" value="'.(!empty($alt) ? $alt : '').'"> alt</div>
		<div style="padding: 8px 0 0 0;"><input type="text" class="inptext" name="title" size="10" value="'.(!empty($title) ? $title : '').'"> title</div>'
		.'</div>
			
		<div class="type2'.($file_type == 2 ? '' : ' hide').'"><input type="file" name="attachment_swf" size="40"><br>'.($file_type == 2 && !empty($file_name) ? $file_name : '').'
		<div style="padding: 8px 0 0 0;"><input type="text" class="inpnum" name="width" size="3" value="'.(!empty($width) ? $width : '').'">
		x <input type="text" class="inpnum" name="height" size="3" value="'.(!empty($height) ? $height : '').'"> ('
		._ADMIN_BANNERS_SWF_WIDTH.' x '._ADMIN_BANNERS_SWF_HEIGHT.')</div></div>

		<div class="type3'.($file_type == 3 ? '' : ' hide').'"><textarea rows="5" cols="60" name="html">'.(!empty($html) ? $html : '').'</textarea></div>
                </td>
		</tr>';

		return TRUE;
	
	}
        
	/**
	 * Редактирование поля "Расположение"
	 * 
	 * @return boolean
	 */
	protected function edit_site_ids_module()
	{
		$show_in_site_id = array();
		$result = DB::query("SELECT site_id FROM {banners_site_rel} WHERE element_id=%d", $this->diafan->edit);
		while ($row = DB::fetch_array($result))
		{
			$show_in_site_id[] = $row["site_id"];
		}
		echo '
		<tr valign="top" id="site_ids">
		<td align="right">'.$this->variable_names().'</td>
		<td>
		<script type="text/javascript" src="' . BASE_PATH . 'modules/banners/admin/banners.admin.js"></script>
		<select multiple name="'.$this->key.'[]">';
		
		$result = DB::query("SELECT id, name, parent_id FROM {site} WHERE trash='0' AND act='1' AND block='0' ORDER BY id ASC");
		while ($row = DB::fetch_array($result))
		{
			$cats[$row["parent_id"]][] = $row;
		}
		echo $this->get_options($cats, $cats[0], $show_in_site_id).'
				</select>
				'.$this->show_help_row().'
			</td>
		</tr>';
		return TRUE;
	}
        
	/**
	 * Редактирование поля "Период показа"
	 * @return boolean true
	 */
	protected function edit_date_module()
	{
		if (! $this->show_datepicker)
		{
			$this->show_datepicker = TRUE;
		}
		echo '
		<tr>
			<td class="td_first">
				'.$this->variable_names().'
			</td>
			<td>
				<input type="text" name="date_start" size="20" value="'
				.(! empty($this->values["date_start"]) ? date("d.m.Y H:i", $this->values["date_start"]) : '')
				.'" class="timecalendar">
				-
				<input type="text" name="date_finish" size="20" value="'
				.(! empty($this->values["date_finish"]) ? date("d.m.Y H:i", $this->values["date_finish"]) : '')
				.'" class="timecalendar">
				'.$this->show_help_row().'
			</td>
		</tr>';

		return TRUE;
	}
        
	/**
	 * Сохранение поля "Период показа"
	 * @return boolean true
	 */
	protected function save_date_module()
	{
		$date_start = ! empty($_POST["date_start"]) ? $this->diafan->unixdate($_POST["date_start"]) : 0;
		$date_finish = ! empty($_POST["date_finish"]) ? $this->diafan->unixdate($_POST["date_finish"]) : 0;
		if ($date_finish && $date_finish < $date_start)
		{
			$date = $date_finish;
			$date_finish = $date_start;
			$date_start = $date;
		}

		$this->query[] = "date_start='%d'";
		$this->value[] = $date_start;

		$this->query[] = "date_finish='%d'";
		$this->value[] = $date_finish;

		return TRUE;
	}
        
        /**
	 * Сохранение поля "Файл"
	 * @return boolean true
	 */
	protected function save_file_module()
	{
               
            if($_POST['type'] == 1)
            {  
                if (!empty($_FILES["attachment_img"]['name']))
                {
                    $extension_array = array('jpg', 'jpeg', 'gif','png');

                    $new_name = strtolower($this->diafan->translit($_FILES["attachment_img"]['name']));
                    $extension = substr(strrchr($new_name, '.'), 1); 
                    if (!in_array($extension, $extension_array))                
                        return _ADMIN_NO_UPLOAD_FILE; 

                    $new_name = substr($new_name, 0, - (strlen($extension) + 1)).'_'.$this->diafan->save.'.'.$extension;



                    $file_name = DB::query_result("SELECT file FROM {banners} WHERE id=%d", $this->diafan->save);

                    if (!empty($file_name))
                    {
                        if (file_exists(ABSOLUTE_PATH.USERFILES.'/'.$this->table.'/'.$file_name))
                        {
                            unlink(ABSOLUTE_PATH.USERFILES.'/'.$this->table.'/'.$file_name);
                        }
                    }

                    if (! copy($_FILES["attachment_img"]['tmp_name'], ABSOLUTE_PATH.USERFILES."/".$this->table."/".$new_name))
                            return _ADMIN_NO_UPLOAD_FILE;
                    
                    $this->query[] = "file='%s'";
                    $this->value[] = $new_name;
                    
                    $this->query[] = "type='%d'";
                    $this->value[] = 1;
                
                    $this->query[] = "html='%s'";
                    $this->value[] = '';
                    
                    $this->query[] = "width='%d'";
                    $this->value[] = '';            
                
                    $this->query[] = "height='%d'";
                    $this->value[] = '';
                }
                                
                $this->query[] = "alt='%s'";
		$this->value[] = $_POST['alt'];
                
                $this->query[] = "title='%s'";
		$this->value[] = $_POST['title'];       
            }
            
            if($_POST['type'] == 2)
            {
                if( !empty($_FILES["attachment_swf"]['name']))
                {
                    $extension_array = array('swf');
                    $new_name = strtolower($this->diafan->translit($_FILES["attachment_swf"]['name']));
                    $extension = substr(strrchr($new_name, '.'), 1); 
                    if (!in_array($extension, $extension_array))                
                        return _ADMIN_NO_UPLOAD_FILE;                

                    $new_name = substr($new_name, 0, - (strlen($extension) + 1)).'_'.$this->diafan->save.'.'.$extension;



                    $file_name = DB::query_result("SELECT file FROM {banners} WHERE id=%d", $this->diafan->save);

                    if (!empty($file_name))
                    {
                        if (file_exists(ABSOLUTE_PATH.USERFILES.'/'.$this->table.'/'.$file_name))
                        {
                            unlink(ABSOLUTE_PATH.USERFILES.'/'.$this->table.'/'.$file_name);
                        }
                    }

                    if (! copy($_FILES["attachment_swf"]['tmp_name'], ABSOLUTE_PATH.USERFILES."/".$this->table."/".$new_name))
                            return _ADMIN_NO_UPLOAD_FILE;
                    
                    $this->query[] = "file='%s'";
                    $this->value[] = $new_name;                    
                    
                    $this->query[] = "type='%d'";
                    $this->value[] = 2;

                    $this->query[] = "html='%s'";
                    $this->value[] = '';
                    
                    $this->query[] = "alt='%s'";
                    $this->value[] = '';
                
                    $this->query[] = "title='%s'";
                    $this->value[] = '';
                }
                                
                $this->query[] = "width='%d'";
                $this->value[] = $_POST['width'];            
                
                $this->query[] = "height='%d'";
                $this->value[] = $_POST['height'];        
            }
            
            if($_POST['type'] == 3)
            {
                if (!empty($_POST['html']))
                {
                    $file_name = DB::query_result("SELECT file FROM {banners} WHERE id=%d", $this->diafan->save);

                    if (!empty($file_name))
                    {
                        if (file_exists(ABSOLUTE_PATH.USERFILES.'/'.$this->table.'/'.$file_name))
                        {
                            unlink(ABSOLUTE_PATH.USERFILES.'/'.$this->table.'/'.$file_name);
                        }
                    }
                    
                    $this->query[] = "type='%d'";
                    $this->value[] = 3;

                    $this->query[] = "html='%s'";
                    $this->value[] = $_POST['html'];
                    
                    $this->query[] = "file='%s'";
                    $this->value[] = '';
                    
                    $this->query[] = "alt='%s'";
                    $this->value[] = '';
                
                    $this->query[] = "title='%s'";
                    $this->value[] = '';
                    
                    $this->query[] = "width='%d'";
                    $this->value[] = '';            
                
                    $this->query[] = "height='%d'";
                    $this->value[] = '';                    
                }
            }
            
            return TRUE;
        }
        
    protected function save_site_ids_module()
    {           
        if(!empty($_POST['site_ids']))
        {
            DB::query("DELETE FROM {banners_site_rel} WHERE element_id=%d", $this->diafan->save);

            foreach ($_POST['site_ids'] as $row)
            {
                DB::query("INSERT INTO {banners_site_rel} (element_id, site_id) VALUES (%d, %d)",
                        $this->diafan->save, $row);
            }
        }
        return TRUE;
    }
}