<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(dirname(dirname(__FILE__))))).'/includes/404.php';
}

/*
 * Формирует данные для формы платежной системы "QIWI"
 */
class Cart_payment_qiwi_model
{
    /**
     * @var object основной объект системы
     */
    private $diafan;

    /**
     * Конструктор класса
     * 
     * @return void
     */
    public function __construct(Core &$diafan)
    {
		$this->diafan = &$diafan;
    }

	/**
     * Формирует данные для формы платежной системы "QIWI"
     * 
     * @return void
     */
	public function get($params)
	{
		// запрос на подтверждение счета
		if (!empty($_POST["qiwi_id"]) OR (! empty($_GET["order"]) AND $_GET["order"] <> 1)) 
		{
			$cart_rew = DB::query_result("SELECT rewrite FROM {rewrite} WHERE module_name='site' AND trash='0' AND site_id IN"
										." (SELECT id FROM {site} WHERE addmodule='cart AND act='1' AND trash='0' AND block='0')");
			$order_id = $_POST["qiwi_id"]; //номер счет, статус которого интересует

			if (! empty($_GET["order"]) AND $_GET["order"] <> 1)
			{
				//номер счета, который пришел с киви
				$order_id = $_GET["order"];
			}
			
			//запрашиваем сумму счета, который хочет подтвердить пользователь, заодно выясняем, есть ли вообще такой неоплаченный счет в системе
			$pay = DB::fetch_array(DB::query("SELECT o.id, o.summ FROM {shop_order} AS o"
					." INNER JOIN {shop_pay_history} AS p ON p.order_id=o.id"
					." WHERE o.id=%d AND p.payment='qiwi' AND p.status='request_pay'",
					$order_id));

			// если неоплаченный счет есть, начинаем спрашивать на сайте киви его статус
			if ($pay["summ"] > 0)
			{
				//сформировали запрос XML
				$xml='<?xml version="1.0" encoding="utf-8"?>
<request>
    <protocol-version>4.00</protocol-version>
    <request-type>33</request-type>
    <extra name="password">'.$params["qiwi_password"].'</extra>
    <terminal-id>'.$params["qiwi_id"].'</terminal-id>
    <bills-list>
    <bill txn-id="'.$order_id.'"/>
    </bills-list>
</request>'; 
				$ch = curl_init(); 
				curl_setopt($ch, CURLOPT_URL, "http://ishop.qiwi.ru/xml");
				curl_setopt($ch, CURLOPT_HEADER, 0); 
				curl_setopt($ch, CURLOPT_RETURNTRANSFER,1); 
				curl_setopt($ch, CURLOPT_POST,1); 
				curl_setopt($ch, CURLOPT_POSTFIELDS, $xml); 
				//ответ от киви
				$answer = curl_exec($ch);
				//если есть строка со статусом 60 (т.е. счет оплачен), и сумма равна выставленной изначально, то зачисляем деньги пользователю
				if (strpos($answer, 'status ="60"') AND strpos($answer, 'sum="'.$pay["summ"]))
				{
					$this->diafan->_shop->order_pay($order_id);
					$this->diafan->redirect('http://'.$_SERVER["HTTP_HOST"].'/'.(REVATIVE_PATH ? REVATIVE_PATH.'/' : '').$cart_rew.'/step3/');
					exit;
				}
			}
			$this->diafan->redirect('http://'.$_SERVER["HTTP_HOST"].'/'.(REVATIVE_PATH ? REVATIVE_PATH.'/' : '').$cart_rew.'/step4/');
			exit;
		}
		if (! empty($_GET["order"]) && $_GET["order"] == 1)
		{
			$result["from_qiwi"] = true;
		}
		$result["text"]     = $params['text'];
		$result["summ"]     = $params['summ'];
		$result["desc"]     = $params["desc_order"];
		$result["order_id"] = $params["order_id"];
		$result["qiwi_id"]  = $params["qiwi_id"];
		return $result;
	}
}