<?php

/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */
if (!defined('DIAFAN')) {
    include dirname(dirname(dirname(__FILE__))) . '/includes/404.php';
}

/**
 * Шаблон вывода таблицы с товарами в корзине
 */

//шапка таблицы
$text = '<table class="cart">
	<tr>
		<th class="cart_first_th"></th>
		<th>' . $this->_('NAME_GOOD') . '</th>
		<th>' . $this->_('COUNT') . '</th>
		<th>' . $this->_('PRICE') . ', ' . $result["currency"] . '</th>
		<th>' . $this->_('SUM') . ', ' . $result["currency"] . '</th>
		'.(empty($result["hide_form"]) ? '<th class="cart_last_th">' . $this->_('DELETE') . '</th>' : '').'
	</tr>';
//товары
if (! empty($result["rows"]))
{
	foreach ($result["rows"] as $row)
	{
		$text .= '
		<tr>
			<td class="cart_img">';
		if (!empty($row["img"]))
		{
			$text .= '<a href="' . BASE_PATH_HREF . $row["link"] . '"><img src="' . $row["img"]["src"] . '" width="' . $row["img"]["width"] . '" height="' . $row["img"]["height"] . '" alt="' . $row["img"]["alt"] . '" title="' . $row["img"]["title"] . '"></a> ';
		}
		$text .= '</td>
			<td class="cart_name"><a href="' . BASE_PATH_HREF . $row["link"] . '">' . $row["name"] . (!empty($row["article"]) ? '<br/>' . _LANG_ARTICLE . ': ' . $row["article"] : '') . '</a></td>
			<td class="cart_count">'.(empty($result["hide_form"]) ? '<input type="text" value="' . $row["count"] . '" name="editshop' . $row["id"] . '" class="inpnum" size="2">' : $row["count"]).'</td>
			<td class="cart_price">' . $row["price"] . '</td>
			<td class="cart_summ">' . $row["summ"] . '</td>
			'.(empty($result["hide_form"]) ? '<td class="cart_delete"><input type="checkbox" name="del' . $row["id"] . '" value="1"></td>' : '').'
		</tr>';
	}

	//итоговая строка для товаров
	$text .= '
		<tr class="cart_last_tr">
			<td class="cart_total" colspan="2">' . $this->_('GOODS_TOTAL') . '</td>
			<td class="cart_count">' . $result["count"] . '</td>
			<td>&nbsp;</td>
			<td class="cart_summ">' . $result["summ_goods"] . '</td>
			'.(empty($result["hide_form"]) ? '<td class="cart_last_td">&nbsp;</td>' : '').'
		</tr>';

	//дополнительно
	if (! empty($result["additional_cost"])) 
	{
		$text .= '<tr><th colspan="5">'.$this->_('ADDITIONALLY').'</th>
		<th class="cart_last_th">' . $this->_('ADD') . '</th></tr>';
		foreach($result["additional_cost"] as $row)
		{
			if(! empty($result["hide_form"]) && ! in_array($row["id"], $result["cart_additional_cost"]) && ! $row["required"])
				continue;

			if ($row['amount'])
			{
				$row['text'] .= '<br>'._ADMIN_SHOPDELIVERY_AMOUNT.' '.$row['amount'].' '.$result["currency"];
			}
			$text .= '
			<tr>
				<td colspan="3">
					<div class="cart_additional_cost_name">'.$row["name"].'</div>
					'.(empty($result["hide_form"]) ? '<div class="cart_additional_cost_text">'.$row['text'].'</div>' : '').'
				</td>
				<td>'.($row['percent'] ? $row['percent'].'%' : $row["price"]).'</td>
				<td>'.$row["summ"].'</td>
				'.(empty($result["hide_form"]) ? '<td>' : '');
			if(! $row["required"] && empty($result["hide_form"]))
			{
				$text .= '<input name="additional_cost_ids[]" value="'.$row['id'].'" type="checkbox" '.(in_array($row["id"], $result["cart_additional_cost"]) ? ' checked' : '').'>';
			}
			$text  .= (empty($result["hide_form"]) ? '</td>' : '').'
			</tr>';
		}
	}

	//способы доставки
	if (! empty($result["delivery"])) 
	{
		$text .= '<tr><th colspan="5">'.$this->_('DELIVERY').'</th>
		<th class="cart_last_th">' . $this->_('SELECT') . '</th></tr>';
		foreach($result["delivery"] as $row)
		{
			if(! empty($result["hide_form"]) && $row["id"] != $result["cart_delivery"])
				continue;

			if ($row['amount'] && empty($result["hide_form"]))
			{
				$row['text'] .= '<br>'._ADMIN_SHOPDELIVERY_AMOUNT.' '.$row['amount'].' '.$result["currency"];
			}
			$text .= '
			<tr>
				<td colspan="4">
					<div class="cart_delivery_name">'.$row["name"].'</div>
					'.(empty($result["hide_form"]) ? '<div class="cart_delivery_text">'.$row['text'].'</div>' : '').'
				</td>
				<td>'.$row["price"].'</td>
				'.(empty($result["hide_form"]) ? '<td><input name="delivery_id" value="'.$row['id'].'" type="radio" '.($row["id"] == $result["cart_delivery"] ? ' checked' : '').'></td>' : '').'
			</tr>';
		}
	}
}


//итоговая строка таблицы
$text .= '
	<tr class="cart_last_tr">
		<td class="cart_total" colspan="2">' . $this->_('GOODS_TOTAL') . '</td>
		<td>&nbsp;</td>
		<td>&nbsp;</td>
		<td class="cart_summ">' . $result["summ"] . '</td>
		'.(empty($result["hide_form"]) ? '<td class="cart_last_td">&nbsp;</td>' : '').'
	</tr>
</table>';

return $text;