<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Comments_admin_edit
 * 
 * Редактирование полей, связанных с работой модуля "Комментарии"
 */
class Comments_admin_edit
{
	/**
	 * Редактирование поля "Комментарии"
	 * 
	 * @return boolean
	 */
	public static function edit($th)
	{
		if (! $th->diafan->configmodules("comments") && ! $th->config_module['category']
		   || ! $th->diafan->configmodules("comments_cat") && $th->config_module['category']
		   || $th->diafan->addnew
		)
		{
			return false;
		}

		echo '
		<tr id="comments">
			<td class="td_first"></td>
			<td>'
			.(DB::query_result("SELECT COUNT(id) FROM {comments} WHERE (module_name='%h' or module_name='') AND element_id='%d' AND trash='0'", $th->table, $th->diafan->edit)
			  ? '<a href="'.BASE_PATH_HREF.'comments/?rew='.$th->table.$th->diafan->edit.'" target="_blank">'._LANG_COMMENTS.'</a>'
			  : _ADMIN_COMMENTS_NOT_MESSAGE
			).$th->show_help_row().'
			</td>
		</tr>';
		return true;
	}

	/**
	 * Редактирование поля "Подключить комментарии" для конфигурации модуля
	 * 
	 * @return boolean true
	 */
	public static function edit_config($th)
	{
		$fileds = array('comments', 'comments_cat');
		foreach ($fileds as $filed)
		{
			if (empty($th->values[$filed]))
			{
				$th->values[$filed] = $th->diafan->configmodules($filed);
			}
		}
		$th->show_tr_click_checkbox['cat'][] = 'comments_cat';

		$com = DB::query_result("SELECT COUNT(id) FROM {adminsite} WHERE act='1' AND rewrite='comments'");
		echo '
		<tr id="comments">
			<td class="td_first">'.$th->variable_names("comments").'</td>
			<td>
				<input type="checkbox" name="comments"'
				.($com ? ' value="1"':' value="0" onclick="javascript:alert(\''._ADMIN_NO_COMMENTS_CONFIG.'\');return false;"')
				.($th->values["comments"] == 1 && $com ? " checked" : '')
				.'>'
				.$th->show_help_row("comments").'
			</td>
		</tr>';
		$category = false;
		if (! empty($th->variable_table["cat"]))
		{
			$category = true;
			?>
			<script language="javascript" type="text/javascript">
				$(document).ready(function(){
					$('input[name=cat]').attr("rel", $('input[name=cat]').attr("rel") + ',#comments_cat');
				});
			</script>
			<?php
		}
		elseif (! empty($th->config_module["tab_card"]))
		{
			foreach ($th->variable_table as $v)
			{
				if (! empty($v["cat"]))
				{
					$category = true;
				}
			}
		}
		if ($category)
		{
			echo '
			<tr'.(! $th->values["cat"] ? ' class="hide"' : '').' id="comments_cat">
				<td class="td_first">'.$th->variable_names("comments_cat").'</td>
				<td>
					<input type="checkbox" name="comments_cat"'
					.($com ? ' value="1"' : ' value="0" onclick="javascript:alert(\''._ADMIN_NO_COMMENTS_CONFIG.'\');return false;"')
					.($th->values["comments_cat"] == 1 && $com ? " checked" : '')
					.'>'
					.$th->show_help_row("comments_cat").'
				</td>
			</tr>';
		}
		return true;
	}
}
