<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Config_admin
 *
 * Настройка параметров сайта
 */
class Config_admin extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file = 'config';

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;

		foreach ($this->diafan->language_all as $l => $langarr)
		{
			define('_ADMIN_CONFIG_TITLE_'.$langarr[0], _ADMIN_CONFIG_TITLE.($langarr[1] ? ' ('.$langarr[1].')' : ''));
			$this->variable_table['base']['title_'.$langarr[0]] = 'text';
		}

		//поля в базе данных для редактирования
                
		$this->variable_table['base']['hr1']               = 'hr';
		$this->variable_table['base']['db_host']           = 'text';
		$this->variable_table['base']['db_name']           = 'text';
		$this->variable_table['base']['db_user']           = 'text';
		$this->variable_table['base']['db_pass']           = 'text';
		$this->variable_table['base']['db_prefix']         = 'text';
		$this->variable_table['base']['db_charset']        = 'disabled';

		$this->variable_table['base']['hr2']               = 'hr';
		$this->variable_table['base']['email']             = 'text';
		$this->variable_table['base']['userfiles']         = 'text';
		$this->variable_table['base']['language']          = 'disabled';
		$this->variable_table['base']['admin_folder']      = 'text';
		$this->variable_table['base']['useradmin']         = 'checkbox';

		$this->variable_table['base']['hr3']               = 'hr';
		$this->variable_table['base']['route_method']      = 'select';
		$this->variable_table['base']['route_google_api_key'] = 'text';
		$this->variable_table['base']['route_translit_from']  = 'textarea';
		$this->variable_table['base']['route_translit_to']    = 'textarea';
		$this->variable_table['base']['route_end']         = 'text';
		$this->variable_table['base']['route_auto_module'] = 'checkbox';

		$this->variable_table['base']['hr4']               = 'hr';
		$this->variable_table['base']['ftp_host']          = 'text';
		$this->variable_table['base']['ftp_login']         = 'text';
		$this->variable_table['base']['ftp_password']      = 'text';
		$this->variable_table['base']['ftp_dir']           = 'text';

		$this->variable_table['base']['hr5']                  = 'hr';
		$this->variable_table['base']['smtp_mail']            = 'checkbox';
		$this->variable_table['base']['smtp_host']            = 'text';
		$this->variable_table['base']['smtp_login']           = 'text';
		$this->variable_table['base']['smtp_password']        = 'text';
		$this->variable_table['base']['smtp_port']            = 'text';

		$this->variable_table['base']['hr6']                  = 'hr';
		$this->variable_table['base']['cache_memcached']      = 'checkbox';
		$this->variable_table['base']['cache_memcached_host'] = 'text';
		$this->variable_table['base']['cache_memcached_port'] = 'text';

		$this->variable_table['base']['hr7']                  = 'hr';
		$this->variable_table['base']['timezone']             = 'text';
		
		$this->variable_table['mod_developer_tab'] = array(
			'mod_developer'              => 'checkbox',
            'mod_developer_tech'         => 'checkbox',
			'mod_developer_cache'        => 'checkbox',
			'mod_developer_delete_cache' => 'checkbox',
			'mod_developer_profiling'    => 'checkbox'
		);

		$this->config_module = array(
			'no_out'   => 1, //не отображать кнопки Сохранить и выйти, Выйти без сохранения
			'tab_card' => 1
		);

		$this->show_tr_click_checkbox = array(
			'smtp_mail' => array(
				'smtp_host',
				'smtp_login',
				'smtp_password',
				'smtp_port'
			),
			'cache_memcached' => array(
				'cache_memcached_host',
				'cache_memcached_port'
			)
		);

		$this->select_arr["route_method"] = array(
			1 => _ADMIN_CONFIG_ROUTE_METHOD_1,
			2 => _ADMIN_CONFIG_ROUTE_METHOD_2,
			3 => _ADMIN_CONFIG_ROUTE_METHOD_3
		);

		$this->diafan->edit = 1;
	}

	/**
	 * Выводит форму редактирования параметров сайта
	 * @return boolean TRUE
	 */
	public function edit_module()
	{
		if (file_exists(ABSOLUTE_PATH.'config.php') &&  ! is_writable(ABSOLUTE_PATH.'config.php'))
		{
			echo '<div class="error">'._ADMIN_CONFIGFILE_NO_PERMISSION.'</div>';
		}
		echo '<script type="text/javascript" src="'.BASE_PATH.'modules/config/admin/config.admin.js"></script>';
		parent::edit_module();

		return TRUE;
	}

	/**
	 * Задает значения полей для формы
	 * 
	 * @return array
	 */
	protected function get_values()
	{
		$url = parse_url(DB_URL);

		$translit_array = explode('````', DB::query_result("SELECT value FROM {config} WHERE module_name='route' AND name='translit_array'"), 2);
		$array = array(
			'db_host'                    => urldecode($url['host']),
			'db_user'                    => urldecode($url['user']),
			'db_pass'                    => isset($url['pass']) ? urldecode($url['pass']) : '',
			'db_name'                    => substr(urldecode($url['path']), 1),
			'db_prefix'                  => DB_PREFIX,
			'email'                      => EMAIL_CONFIG,
			'db_charset'                 => DB_CHARSET,
			'userfiles'                  => USERFILES,
			'language'                   => LANGUAGE_BASE,
			'admin_folder'               => ADMIN_FOLDER,
			'useradmin'                  => USERADMIN,
			'mod_developer'              => MOD_DEVELOPER,
            'mod_developer_tech'         => MOD_DEVELOPER_TECH,
			'mod_developer_profiling'    => MOD_DEVELOPER_PROFILING,
			'mod_developer_cache'        => MOD_DEVELOPER_CACHE,
			'mod_developer_delete_cache' => FALSE,

			'route_method'               => DB::query_result("SELECT value FROM {config} WHERE module_name='route' AND name='method'"),
			'route_translit_from'        => $translit_array[0],
			'route_translit_to'          => ! empty($translit_array[1]) ? $translit_array[1] : '',
			'route_google_api_key'       => DB::query_result("SELECT value FROM {config} WHERE module_name='route' AND name='google_api_key'"),
			'route_end'                  => ROUTE_END,
			'route_auto_module'          => ROUTE_AUTO_MODULE,

			'ftp_host'                   => FTP_HOST,
			'ftp_login'                  => FTP_LOGIN,
			'ftp_password'               => FTP_PASSWORD,
			'ftp_dir'                    => FTP_DIR,
			
			'smtp_mail'                  => SMTP_MAIL,
			'smtp_host'                  => SMTP_HOST,
			'smtp_login'                 => SMTP_LOGIN,
			'smtp_password'              => SMTP_PASSWORD,
			'smtp_port'                  => SMTP_PORT,

			'cache_memcached'            => CACHE_MEMCACHED,
			'cache_memcached_host'       => CACHE_MEMCACHED_HOST,
			'cache_memcached_port'       => CACHE_MEMCACHED_PORT,

			'timezone'                   => defined('TIMEZONE') ? TIMEZONE : ''
		);

		foreach ($this->diafan->language_all as $l => $langarr)
		{
			$array['title_'.$langarr[0]] = (defined('TIT'.$langarr[0]) ? constant('TIT'.$langarr[0]) : '');
		}

		return $array;
		
	}

	/**
	 * Сохраняет файл конфигурации
	 * 
	 * @return boolean
	 */
	public function save_module()
	{
		// Прошел ли пользователь проверку идентификационного хэша
		if (! $this->diafan->_user->checked)
		{
			$this->diafan->redirect(URL);
			return FALSE;
		}

		//проверка прав на сохранение
		if ($this->diafan->admin_roles('edit'))
		{
			$this->diafan->redirect(URL);
			return FALSE;
		}

		$url = parse_url(DB_URL);
		$diafan_user = urldecode($url['user']);
		if (isset($url['pass']))
		{
			$diafan_pass = urldecode($url['pass']);
		}
		else
		{
			$diafan_pass = '';
		}
		$diafan_host = urldecode($url['host']);
		$diafan_dbname = substr(urldecode($url['path']), 1);

		$dir_url_path = '';

		if ($_SERVER['REQUEST_URI'] != "/".ADMIN_FOLDER."/config/save1/")
		{
			$dir_url_path = str_replace("/".ADMIN_FOLDER."/config/save1/", "", $_SERVER['REQUEST_URI']);
		}

		$admin_folder = substr($this->diafan->get_param($_POST, "admin_folder", ADMIN_FOLDER, 1), 0, 20);

		Customization::inc('includes/validate.php');
		
		$sheme = extension_loaded('mysqli') ? 'mysqli' : 'mysql';

		$new_values = array(
				'DB_URL' => $sheme.'://'.str_replace('"', '&quot;', $this->diafan->get_param($_POST, "db_user", $diafan_user, 1))
				            .($_POST["db_pass"] ? ":".str_replace('"', '&quot;', $this->diafan->get_param($_POST, "db_pass_update", $diafan_pass, 1)) : '')
				            ."@".str_replace('"', '&quot;', $this->diafan->get_param($_POST, "db_host", $diafan_host, 1))
				            ."/".str_replace('"', '&quot;', $this->diafan->get_param($_POST, "db_name", $diafan_dbname, 1)),
				'DB_PREFIX' => str_replace('"','&quot;', $this->diafan->get_param($_POST, "db_prefix", DB_PREFIX, 1)),
				'EMAIL_CONFIG' => (! Validate::mail($_POST["email"]) ? str_replace('"','&quot;', $this->diafan->get_param($_POST, "email", EMAIL_CONFIG, 1)) : ''),
				'USERFILES' => $this->diafan->get_param($_POST, "userfiles", USERFILES, 1),
				'ADMIN_FOLDER' => $admin_folder,
				'USERADMIN' => (! empty($_POST["useradmin"]) ? TRUE : FALSE),
				'MOD_DEVELOPER' => (! empty($_POST["mod_developer"]) ? TRUE : FALSE),
                'MOD_DEVELOPER_TECH' => (! empty($_POST["mod_developer_tech"]) ? TRUE : FALSE),
				'MOD_DEVELOPER_CACHE' => (! empty($_POST["mod_developer_cache"]) ? TRUE : FALSE),
				'MOD_DEVELOPER_PROFILING' => (! empty($_POST["mod_developer_profiling"]) ? TRUE : FALSE),
				'FTP_HOST' => $this->diafan->get_param($_POST, "ftp_host", FTP_HOST, 1),
				'FTP_DIR' => $this->diafan->get_param($_POST, "ftp_dir", FTP_DIR, 1),
				'FTP_LOGIN' => $this->diafan->get_param($_POST, "ftp_login", FTP_LOGIN, 1),
				'FTP_PASSWORD' => $this->diafan->get_param($_POST, "ftp_password", FTP_PASSWORD, 1),
				'SMTP_MAIL' => (! empty($_POST["smtp_mail"]) ? TRUE : FALSE),
				'SMTP_HOST' => $this->diafan->get_param($_POST, "smtp_host", "", 1),
				'SMTP_LOGIN' => $this->diafan->get_param($_POST, "smtp_login", "", 1),
				'SMTP_PASSWORD' => $this->diafan->get_param($_POST, "smtp_password", "", 1),
				'SMTP_PORT' => $this->diafan->get_param($_POST, "smtp_port", "", 1),
				'CACHE_MEMCACHED' => (! empty($_POST["cache_memcached"]) ? TRUE : FALSE),
				'CACHE_MEMCACHED_HOST' => $this->diafan->get_param($_POST, "cache_memcached_host", "", 1),
				'CACHE_MEMCACHED_PORT' => $this->diafan->get_param($_POST, "cache_memcached_port", "", 1),
				'TIMEZONE' => $this->diafan->get_param($_POST, "timezone", "", 1),
				'ROUTE_END' => $this->diafan->get_param($_POST, "route_end", "", 1),
				'ROUTE_AUTO_MODULE' => (! empty($_POST["route_auto_module"]) ? TRUE : FALSE)
			);
		foreach ($this->diafan->language_all as $l => $langarr)
		{
			$new_values['TIT'.$langarr[0]] = str_replace('"', '', htmlspecialchars(stripslashes($this->diafan->get_param($_POST, "title_".$langarr[0], '', 1))));
		}
		$route_method = DB::fetch_array(DB::query("SELECT id, value FROM {config} WHERE module_name='route' AND name='method'"));
		if(! $route_method)
		{
			DB::query("INSERT INTO {config} (module_name, name, value) VALUES ('route', 'method', '%d')", $_POST["route_method"]);
		}
		elseif($route_method["value"] != $_POST["route_method"])
		{
			DB::query("UPDATE {config} SET value='%d' WHERE module_name='route' AND name='method'", $_POST["route_method"]);
		}

		$route_translit_array = DB::fetch_array(DB::query("SELECT id, value FROM {config} WHERE module_name='route' AND name='translit_array'"));
		if(! $route_translit_array)
		{
			DB::query("INSERT INTO {config} (module_name, name, value) VALUES ('route', 'translit_array', '%h')", $_POST["route_translit_from"]."````".$_POST["route_translit_to"]);
		}
		elseif($route_translit_array["value"] != $_POST["route_translit_from"]."````".$_POST["route_translit_to"])
		{
			DB::query("UPDATE {config} SET value='%h' WHERE module_name='route' AND name='translit_array'", $_POST["route_translit_from"]."````".$_POST["route_translit_to"]);
		}

		$route_google_api_key = DB::fetch_array(DB::query("SELECT id, value FROM {config} WHERE module_name='route' AND name='google_api_key'"));
		if(! $route_google_api_key)
		{
			DB::query("INSERT INTO {config} (module_name, name, value) VALUES ('route', 'google_api_key', '%h')", $_POST["route_google_api_key"]);
		}
		elseif($route_google_api_key["value"] != $_POST["route_google_api_key"])
		{
			DB::query("UPDATE {config} SET value='%h' WHERE module_name='route' AND name='google_api_key'", $_POST["route_google_api_key"]);
		}

		Customization::inc('includes/config.php');
		Config::save($new_values, $this->diafan->language_all);

		if (! empty($_POST["mod_developer_delete_cache"]) || ROUTE_END != $this->diafan->get_param($_POST, "route_end", "", 1))
		{
			$this->diafan->_cache->delete("", array());
		}
		if ($admin_folder == ADMIN_FOLDER)
		{
			$this->diafan->redirect(URL.'success1/');
		}
		else
		{
			$this->diafan->redirect('http://'.BASE_URL.'/'.$admin_folder.'/config/success1/');
		}
		return TRUE;
	}
}
