<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Faq
 *
 * Контроллер модуля "Вопрос-Ответ"
 */
class Faq extends Controller
{
	/**
	 * Инициализация модуля
	 * 
	 * @return void
	 */
	public function init()
	{
		$this->rewrite_variable_names = array('page', 'show', 'cat');
		$this->diafan->rewrite_variable_names = $this->rewrite_variable_names;

		$model = new Faq_model($this->diafan);
		
		if ($this->diafan->show)
		{
			$this->result = $model->id();
		}
		elseif (! $this->diafan->configmodules("cat"))
		{
			$this->result = $model->list_();
		}
		elseif (! $this->diafan->cat)
		{
			$this->result = $model->first_page();
		}
		else
		{
			$this->result = $model->list_category();
		}
		$this->get_global_variables();
		$this->result = $model->form();
	}

	/**
	 * Выводит контент модуля
	 * 
	 * @return boolean true
	 */
	public function show_module()
	{
		$this->diafan->_tpl->get($this->view, 'faq', $this->result);

		return true;
	}

	/**
	 * Шаблонная функция: блок вопросов и ответов
	 *
	 * @param array $attributes атрибуты шаблонного тэга
	 * @return boolean
	 */
	public function show_block($attributes)
	{
		$attributes = $this->get_attributes($attributes, 'count', 'cat_id', 'sort', 'site_id', 'often', 'template');
		
		$count   = $attributes["count"] ? intval($attributes["count"]) : 3;
		$cat_id  = intval($attributes["cat_id"]);
		$site_id = intval($attributes["site_id"]);
		$sort    = $attributes["sort"] == "date" || $attributes["sort"] == "rand" ? $attributes["sort"] : "date";
		$often   = $attributes["often"] ? true : false;

		if (($this->diafan->cid == $site_id || ! $site_id && $this->diafan->module == "faq") && ! $this->diafan->show && $this->diafan->page < 2)
			return false;

		Customization::inc('modules/faq/faq.model.php');
		$model = new Faq_model($this->diafan);
		$result = $model->show_block($count, $cat_id, $often, $sort, $site_id);

		if (! $attributes["template"] || ! $this->diafan->_tpl->get('show_block_'.$attributes["template"], 'faq', $result))
		{
			$this->diafan->_tpl->get('show_block', 'faq', $result);
		}
		return true;
	}

	/**
	 * Шаблонная функция: форма добавления вопроса
	 *
	 * @param array $attributes атрибуты шаблонного тэга
	 * @return boolean
	 */
	public function show_form($attributes)
	{
		$attributes = $this->get_attributes($attributes, 'cat_id', 'site_id', 'template');

		$cat_id  = intval($attributes["cat_id"]);
		$site_id = intval($attributes["site_id"]);

		include_once ABSOLUTE_PATH.'modules/faq/faq.model.php';
		$model = new Faq_model($this->diafan);
		$result = $model->form($site_id, $cat_id, true);
		if (! empty($result["form"]))
		{
			if (! $attributes["template"] || ! $this->diafan->_tpl->get('form_'.$attributes["template"], 'faq', $result["form"]))
			{
				$this->diafan->_tpl->get('form', 'faq', $result["form"]);
			}
		}
		return true;
	}
}