<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Images_admin_edit
 * 
 * Редактирование полей, связанных с работой модуля "Изображения"
 */
class Images_admin_edit
{
	/**
	 * Редактирование поля "Изображения"
	 * 
	 * @return boolean
	 */
	public static function edit($th)
	{
		if ($th->config_module['category'] && ! $th->diafan->configmodules("images_cat")
		   || ! $th->config_module['category'] && ! $th->diafan->configmodules("images"))
		{
			return false;
		}

		if (! extension_loaded('gd'))
		{
			$th->diafan->error = _ADMIN_NOT_GD;
		}
		Customization::inc('modules/images/admin/images.admin.view.php');
		echo '
		<script type="text/javascript" src="'.BASE_PATH.'modules/images/admin/images.admin.js"></script>

		<tr valign="top">
			<td class="td_first">'.$th->variable_names().'</td>
			<td>
				<input type="file" class="images_upload" name="image" size="40">	
				<div class="images_container">';
				if (! $th->diafan->addnew)
				{
					echo Images_admin_view::show($th, $th->diafan->edit);
				}
				echo '</div>
				<div class="errors error_images"></div>
			</td>
		</tr>';
		return true;
	}

	/**
	 * Редактирование поля "Подключить изображения" для конфигурации модуля
	 * 
	 * @return boolean true
	 */
	public static function edit_config($th)
	{
		$category = false;
		if (! empty($th->variable_table["cat"]))
		{
			$category = true;
		}
		elseif (! empty($th->config_module["tab_card"]))
		{
			foreach ($th->variable_table as $v)
			{
				if (! empty($v["cat"]))
				{
					$category = true;
				}
			}
		}
		if ($category)
		{
			$fileds = array('images', 'big_width', 'big_height', 'big_quality', 'medium_width', 'medium_height', 'medium_quality', 'list_img',
							'images_cat', 'big_width_cat', 'big_height_cat', 'big_quality_cat', 'medium_width_cat', 'medium_height_cat',
							'medium_quality_cat', 'list_img_cat', 'use_animation', 'watermark', 'watermark_only_big', 'watermark_path',
							'watermark_placement', 'resize');
		}
		else
		{
			$fileds = array('images', 'big_width', 'big_height', 'big_quality', 'medium_width', 'medium_height', 'medium_quality', 'list_img',
							'use_animation', 'watermark', 'watermark_only_big', 'watermark_path', 'watermark_placement', 'resize');
		}
		foreach ($fileds as $filed)
		{
			if (empty($th->values[$filed]))
			{
				$th->values[$filed] = $th->diafan->configmodules($filed);
			}
		}
		$th->show_tr_click_checkbox['images'] = array(
				'list_img',
				'big',
				'medium',
				'images_cat',
				'use_animation',
				'upload_max_filesize',
				'watermark',
				'resize'
			);
		$th->show_tr_click_checkbox['watermark'] = array(
				'watermark_only_big',
				'watermark_path',
				'watermark_placement'
			);
		if ($category)
		{
			$th->show_tr_click_checkbox['images_cat'] = array(
					'big_cat',
					'medium_cat',
					'list_img_cat'
				);
			$th->show_tr_click_checkbox['cat'][] = 'images_cat';
			?>
			<script language="javascript" type="text/javascript">$('input[name=cat]').attr("rel", $('input[name=cat]').attr("rel") + ',#images_cat');</script>
			<?php
		}
		else
		{
			$th->show_tr_click_checkbox['images'][] = 'use_animation';
			$th->show_tr_click_checkbox['images'][] = 'upload_max_filesize';
			$th->show_tr_click_checkbox['images'][] = 'watermark';
			$th->show_tr_click_checkbox['images'][] = 'resize';
		}
		echo '
		<tr id="images">
			<td class="td_first">'.$th->variable_names("images").'</td>
			<td>
				<input type="checkbox" name="images"'
				.(! extension_loaded('gd')
				 ? ' onclick="javascript:alert(\''._ADMIN_IMAGE_NO_GD_CONFIG.'\');" value="0"'
				 : $th->show_tr_click_checkbox("images").'" value="1" '
				   .($th->values["images"] == 1 ? " checked" : '')
				 )
				.' id="images_">
				'.$th->show_help_row("images").'
			</td>
		</tr>
		<tr id="big">
			<td class="td_first">'.$th->variable_names("big_width").'</td>
			<td><input type="text" name="big_width" size="3" value="'.$th->values["big_width"].'" class="inpnum"> x
				<input type="text" name="big_height" size="3" value="'.$th->values["big_height"].'" class="inpnum">,
				'._LANG_QUALITY.'
				<input type="text" name="big_quality" size="2" value="'.$th->values["big_quality"].'" class="inpnum">'
				.$th->show_help_row("big_quality").'
			</td>
		</tr>
		<tr id="medium">
			<td class="td_first">'.$th->variable_names("medium_width").'</td>
			<td>
				<input type="text" name="medium_width" size="3" value="'.$th->values["medium_width"].'" class="inpnum"> x
				<input type="text" name="medium_height" size="3" value="'.$th->values["medium_height"].'" class="inpnum">,
				'._LANG_QUALITY.'
				<input type="text" name="medium_quality" size="2" value="'.$th->values["medium_quality"].'" class="inpnum">'
				.$th->show_help_row("big_quality").'
			</td>
		</tr>';
		if ($th->diafan->module != 'site')
		{
			echo '
			<tr id="list_img">
				<td class="td_first">'.$th->variable_names("list_img").'</td>
				<td>
					<select name="list_img">
						<option value="0"'.($th->values["list_img"] == 0 ? ' selected' : '').'>'._ADMIN_CONFIG_LIST_IMG_0.'</option>
						<option value="1"'.($th->values["list_img"] == 1 ? ' selected' : '').'>'._ADMIN_CONFIG_LIST_IMG_1.'</option>
						<option value="2"'.($th->values["list_img"] == 2 ? ' selected' : '').'>'._ADMIN_CONFIG_LIST_IMG_2.'</option>
					</select>
					'.$th->show_help_row("list_img").'
				</td>
			</tr>';
		}
		if ($category)
		{
			echo '
			<tr id="images_cat"'.(! $th->values["cat"] ? ' class="hide"' : '').'>
				<td class="td_first">'.$th->variable_names("images_cat").'</td>
				<td>
					<input type="checkbox" name="images_cat"'
					.(! extension_loaded('gd')
					 ? ' onclick="javascript:alert(\''._ADMIN_IMAGE_NO_GD_CONFIG.'\');" value="0"'
					 : $th->show_tr_click_checkbox("images_cat").'" value="1" '
					   .($th->values["images_cat"] == 1 ? " checked" : '')
					 )
					.' id="images_cat_">
					'.$th->show_help_row("images_cat").'
				</td>
			</tr>
			<tr id="big_cat"'.(! $th->values["cat"] ? ' class="hide"' : '').'>
				<td class="td_first">'.$th->variable_names("big_width_cat").'</td>
				<td><input type="text" name="big_width_cat" size="3" value="'.$th->values["big_width_cat"].'" class="inpnum"> x
					<input type="text" name="big_height_cat" size="3" value="'.$th->values["big_height_cat"].'" class="inpnum">,
					'._LANG_QUALITY.'
					<input type="text" name="big_quality_cat" size="2" value="'.$th->values["big_quality_cat"].'" class="inpnum">'
					.$th->show_help_row("big_quality").'
				</td>
			</tr>
			<tr id="medium_cat"'.(! $th->values["cat"] ? ' class="hide"' : '').'>
				<td class="td_first">'.$th->variable_names("medium_width_cat").'</td>
				<td>
					<input type="text" name="medium_width_cat" size="3" value="'.$th->values["medium_width_cat"].'" class="inpnum"> x
					<input type="text" name="medium_height_cat" size="3" value="'.$th->values["medium_height_cat"].'" class="inpnum">,
					'._LANG_QUALITY.'
					<input type="text" name="medium_quality_cat" size="2" value="'.$th->values["medium_quality_cat"].'" class="inpnum">'
					.$th->show_help_row("big_quality").'
				</td>
			</tr>
			<tr id="list_img_cat"'.(! $th->values["cat"] ? ' class="hide"' : '').'>
				<td class="td_first">'.$th->variable_names("list_img_cat").'</td>
				<td>
					<select name="list_img_cat">
						<option value="0"'.($th->values["list_img_cat"] == 0 ? ' selected' : '').'>'._ADMIN_CONFIG_LIST_IMG_0.'</option>
						<option value="1"'.($th->values["list_img_cat"] == 1 ? ' selected' : '').'>'._ADMIN_CONFIG_LIST_IMG_1.'</option>
						<option value="2"'.($th->values["list_img_cat"] == 2 ? ' selected' : '').'>'._ADMIN_CONFIG_LIST_IMG_2.'</option>
					</select>
					'.$th->show_help_row("list_img_cat").'
				</td>
			</tr>';
		}
		echo '
		<tr id="use_animation">
			<td class="td_first">'.$th->variable_names("use_animation").'</td>
			<td>
				<input type="checkbox" name="use_animation" value="1"'.($th->values["use_animation"] == 1 ? " checked" : '').'>
				'.$th->show_help_row("use_animation").'
			</td>
		</tr>
		<tr id="upload_max_filesize">
			<td class="td_first">'.$th->variable_names("upload_max_filesize").'</td>
			<td>
				'.ini_get('upload_max_filesize')
				.$th->show_help_row("upload_max_filesize").'
			</td>
		</tr>
		<tr id="watermark">
			<td class="td_first">'.$th->variable_names("watermark").'</td>
			<td>
				<input type="checkbox" name="watermark" value="1"'.($th->values["watermark"] == 1 ? " checked" : '').$th->show_tr_click_checkbox("watermark").'>
				'.$th->show_help_row("watermark").'
			</td>
		</tr>';
		Customization::inc('modules/images/admin/images.admin.view.php');
		echo '
		<script type="text/javascript" src="'.BASE_PATH.'modules/images/admin/images.admin.js"></script>

		<tr valign="top" id="watermark_path">
			<td class="td_first">'.$th->variable_names("watermark_path").'</td>
			<td>
				<input type="file" name="watermark" size="40">
				<input type="button" value="'._ADMIN_IMAGE_UPLOAD.'" class="watermark_upload"> '.$th->show_help_row("watermark_path").'
				<div class="images_container">'.Images_admin_view::show_watermark($th).'</div>
				<div class="errors error_watermark"></div>
			</td>
		</tr>';
		if (! $th->values["watermark_placement"])
		{
			$th->values["watermark_placement"] = 'bottom=5,right=5';
		}
		list($vertical,  $horizontal) = explode(',', $th->values["watermark_placement"], 2); 
		list($vertical,  $sy)         = explode('=', trim($vertical), 2); 
		list($horizontal, $sx)        = explode('=', trim($horizontal), 2);

		echo '
		<tr id="watermark_placement">
			<td class="td_first">'.$th->variable_names("watermark_placement").'</td>
			<td>
				<select name="watermark_placement_vertical">
					<option value="middle"'.($vertical == 'middle' ? ' selected' : '').'>'._ADMIN_WATERMARK_PLACEMENT_MIDDLE_CONFIG.'</option>
					<option value="bottom"'.($vertical == 'bottom' ? ' selected' : '').'>'._ADMIN_WATERMARK_PLACEMENT_BOTTOM_CONFIG.'</option>
				</select>
				<input type="text" name="watermark_placement_vertical_px" size="3" value="'.$sy.'" class="inpnum"> px
				<select name="watermark_placement_horizontal">
					<option value="center"'.($horizontal == 'cetner' ? ' selected' : '').'>'._ADMIN_WATERMARK_PLACEMENT_CENTER_CONFIG.'</option>
					<option value="right"'.($horizontal == 'right' ? ' selected' : '').'>'._ADMIN_WATERMARK_PLACEMENT_RIGHT_CONFIG.'</option>
				</select>
				<input type="text" name="watermark_placement_horizontal_px" size="3" value="'.$sx.'" class="inpnum"> px
				&nbsp;&nbsp;&nbsp;
				'.$th->show_help_row("watermark_placement").'
			</td>
		</tr>
		<tr id="watermark_only_big">
			<td class="td_first">'.$th->variable_names("watermark_only_big").'</td>
			<td>
				<input type="checkbox" name="watermark_only_big" value="1"'.($th->values["watermark_only_big"] == 1 ? " checked" : '').'>
				'.$th->show_help_row("watermark_only_big").'
			</td>
		</tr>
		<tr id="resize" valign="top">
			<td class="td_first">'.$th->variable_names("resize").'</td>
			<td>
				<input type="button" name="resize" confirm="'._ADMIN_RESIZE_CONFIG_CONFIRM.'" value="'._ADMIN_APPLY.'">
				'.$th->show_help_row("resize").'
				<div class="errors loading-resize"><img src="'.BASE_PATH.'adm/img/loading.gif"></div>
				<div class="errors error_resize"></div>
			</td>
		</tr>';
		return true;
	}
}