<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Language_admin_file
 *
 * Редактирование файлов перевода
 */
class Language_admin_file extends Frame_admin
{
	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;
	}

	/**
	 * Выводит контент модуля
	 * @return boolean true
	 */
	public function show_module()
	{
		$shortname = ($this->diafan->site == 1 ? LANGUAGE_BASE : DB::title("language", $this->diafan->site, "shortname"));

		echo '<h2>'._ADMIN_LANGUAGEFILE_EDIT_FILE.' language/'.$shortname.'.php</h2>';
		
		if (file_exists(ABSOLUTE_PATH.'language/'.$shortname.'.php') &&  ! is_writable(ABSOLUTE_PATH.'language/'.$shortname.'.php')
		    || ! file_exists(ABSOLUTE_PATH.'language/'.$shortname.'.php') &&  ! is_writable(ABSOLUTE_PATH.'language'))
		{
			echo '<div class="error">'.sprintf(_ADMIN_LANGUAGEFILE_NO_PERMISSION, 'language/'.$shortname.'.php').'</div>';
		}
		
		$values    = array();
		$translate = array();
		
		$fd = fopen (ABSOLUTE_PATH.'language/'.LANGUAGE_BASE.'.php', 'r');
		while (! feof($fd))
		{
			$buffer = fgets($fd, 4096);

			if (strstr($buffer, ' * '))
			{
				continue;
			}
			elseif (preg_match("/define\('([^']+)',\s*'([^\']*)'\);/", $buffer, $res))
			{
				$translate[$res[1]] = $res[2]?$res[2]:$res[1];
			
				if ($shortname == LANGUAGE_BASE)
				{
					$values[$res[1]] = $res[2];
				}
			}
			elseif (preg_match("/\/\/(.*)/", $buffer, $res))
			{
				$translate[] = $res[1];
			}
		}
		fclose($fd);

		if ($shortname != LANGUAGE_BASE && file_exists(ABSOLUTE_PATH.'language/'.$shortname.'.php'))
		{
			$fd = fopen (ABSOLUTE_PATH.'language/'.$shortname.'.php', 'r');
			while (! feof($fd))
			{
				$buffer = fgets($fd, 4096);
				if (preg_match("/define\s*\('([^']+)',\s*'([^\']*)'\);/", $buffer, $res))
				{
					$values[$res[1]] = $res[2];
				}
			}
			fclose ($fd);
		}

		echo '
	<form METHOD="POST" action="'.URL.'save'.$this->diafan->site.'/" enctype="multipart/form-data" id="save">
		<input type="hidden" name="noOut" id="noOut" value="0">
		<input type="hidden" name="check_hash_user" value="'.$this->diafan->_user->get_hash().'">
		<input type="hidden" name="save_post" value="1">
		<table class="table_edit">
			<tr>
				<td class="td_first"><b>'._ADMIN_PROPERTY.'</b></td>
				<td><b>'._ADMIN_VALUE.'</b></td>
			</tr>';
		foreach ($translate as $key => $name)
		{
			echo (strstr($key, '_') ? '
			<tr>
				<td class="td_first">'.str_replace(array('<', '>'), array('&lt;', '&gt;'), $name).'</td>
				<td>
				'.(strlen($name) < 50 ? '
					<input type="text" name="'. $key.'" size="40" value="'
					.(! empty($values[$key]) ? str_replace('"', '&quot;', $values[$key]) : '')
					.'">
				':'
					<textarea name="'.$key.'" cols="60" rows="5">'
					.(! empty($values[$key]) ? $values[$key] : '').'</textarea>
				').'
				</td>
			</tr>'
			
			:'
			<tr><th colspan="2">'.$name.'</th>
			');
		}
		echo '
			<tr>
				<td align="right">
					<input type="submit" value="'._LANG_SAVE.'" class="button" onmouseover="this.style.cursor=\'hand\';">
				</td>
				<td align="left">
					<input type="button" onClick="document.location=\''.path_module($this->diafan, 0, 0, 0, 0, 1).'\'"
					class="button" onmouseover="this.style.cursor=\'hand\';" value="'._ADMIN_OUT_TO_LIST.'">
				</td>
			</tr>
		</table>
	</form>';
		return true;
	}

	/**
	 * Cохранение элемента (вместо основной функции)
	 * @return boolean true
	 */
	public function save_module()
	{
		// Прошел ли пользователь проверку идентификационного хэша
		if (! $this->diafan->_user->checked)
		{
			$this->diafan->redirect(URL);
			return false;
		}

		$text = '<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined(\'DIAFAN\'))
{
	include dirname(dirname(__FILE__)).\'/includes/404.php\';
}';
	
		$shortname = ($this->diafan->site == 1 ? LANGUAGE_BASE : DB::title("language", $this->diafan->site, "shortname"));
		
		$fd = fopen(ABSOLUTE_PATH.'language/'.LANGUAGE_BASE.'.php', 'r');
		while (! feof($fd))
		{
			$buffer = fgets($fd, 4096);

			if (strstr($buffer, ' * '))
			{
				continue;
			}
			elseif (preg_match("/define\('([^']+)',\s*'([^\']*)'\);/", $buffer, $res))
			{			
				$text.="\ndefine('".$res[1]."', '".str_replace(array("'", '\"'), array("", '"'), $_POST[$res[1]])."');";
			}
			elseif (preg_match("/\/\/(.*)/",$buffer,$res))
			{
				$text .= "\n\n".'//'.$res[1];
			}
		}
		fclose($fd);

		$fp = fopen(ABSOLUTE_PATH.'language/'.$shortname.'.php', "w");
		fwrite($fp, $text);
		fclose($fp);
		$this->diafan->redirect(URL.'error1/');

		return true;
	}
}