<?php

/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */
if (!defined('DIAFAN'))
{
    include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Menu_admin
 *
 * Редактирование пунктов меню
 */
class Menu_admin extends Frame_admin
{

    /**
     * @var string название файла. используется в имени констант, определяющих названия полей
     */
    public $file = 'menu';

    /**
     * @var string таблица в базе данных
     */
    public $table = 'menu';

    /**
     * Конструктор класса
     * 
     * @return void
     */
    public function __construct($diafan)
    {
	$this->diafan = $diafan;

	//поля в базе данных для редактирования
	$this->variable_table = array(
	    'main' => array(
		'name' => 'text',
		'act' => 'checkbox',
		'module_name' => 'function',
		'parent_id' => 'function',
		'cat_id' => 'function',
		'othurl' => 'text',
		'access' => 'function',
		'image' => 'function',
	    ),
	);

	//переводимые поля
	$this->language_names = array(
	    'name',
	    'act'
	);

	$this->config_module = array(
	    'del' => 1, //удалить
	    'act' => 1, //показать/скрыть
	    'parent' => 1, //содержит вложенности
	    'trash' => 1, //использовать корзину
	    'order' => 1, //сортируется
	    'element' => 1, //используются группы
	    'category_flat' => 1  // категори не содержат вложенности
	);
	if (!$this->diafan->cat)
	{
	    $this->diafan->cat = 1;
	}
    }

    /**
     * Выводит списко ответов
     * @return boolean true
     */
    public function show_module()
    {

	$this->addnew_init(_ADMIN_MENU_ITEM_ADD);

	$this->list_row();


	return true;
    }

    /**
     * Редактирование поля "Элемент модуля"
     * @return boolean true
     */
    protected function edit_module_name_module()
    {
		if ($this->diafan->addnew)
		{
			$this->values["module_name"] = '';
			$this->values["element_id"] = 0;
			$this->values["site_id"] = 0;
			$this->values["module_cat_id"] = 0;
		}
		echo '
			<script type="text/javascript" src="'.BASE_PATH.'modules/menu/admin/menu.admin.js"></script>
			<tr id="images">
				<td class="td_first">'.$this->variable_names("element_id").'</td>
				<td>';
		if ($this->values["site_id"] && $this->values["module_name"] == "site")
		{
			$name = DB::query_result("SELECT [name] FROM {site} WHERE id=%d", $this->values["site_id"]);
			echo '<a href="'.BASE_PATH_HREF.'site/edit'.$this->values["site_id"].'/" class="menu_base_link">'.$name.'</a>
					<a href="javascript:void(0)"><img src="'.BASE_PATH.'adm/img/edit.gif" width="12" height="14" alt="'._LANG_EDIT.'" class="menu_check"></a>';
		}
		elseif ($this->values["element_id"])
		{
			$name = DB::query_result("SELECT [name] FROM {%s} WHERE id=%d", $this->values["module_name"], $this->values["element_id"]);
			echo '<a href="'.BASE_PATH_HREF.$this->values["module_name"].'/edit'.$this->values["element_id"].'/" class="menu_base_link">'.$name.'</a>
					<a href="javascript:void(0)"><img src="'.BASE_PATH.'adm/img/edit.gif" width="12" height="14" alt="'._LANG_EDIT.'" class="menu_check"></a>';
		}
		elseif ($this->values["module_cat_id"])
		{
			$name = DB::query_result("SELECT [name] FROM {%s_category} WHERE id=%d", $this->values["module_name"], $this->values["module_cat_id"]);
			echo '<a href="'.BASE_PATH_HREF.$this->values["module_name"].'/category/edit'.$this->values["module_cat_id"].'/" class="menu_base_link">'.$name.'</a>
					<a href="javascript:void(0)"><img src="'.BASE_PATH.'adm/img/edit.gif" width="12" height="14" alt="'._LANG_EDIT.'" class="menu_check"></a>';
		}
		else
		{
			echo '<a href="#" class="menu_base_link"></a>
					<a href="#inline" class="menu_check"><img src="'.BASE_PATH.'adm/img/edit.gif" width="12" height="14" alt="'._LANG_EDIT.'"></a>';
		}

		echo $this->show_help_row("element_id").'
				<input name="module_name" value="'.$this->values["module_name"].'" type="hidden">
				<input name="site_id" value="'.$this->values["site_id"].'" type="hidden">
				<input name="module_cat_id" value="'.$this->values["module_cat_id"].'" type="hidden">
				<input name="element_id" value="'.$this->values["element_id"].'" type="hidden">
				<div id="inline" class="hide"></div>
				</td>
			</tr>';

	return true;
    }

    /**
     * Редактирование поля "Доступ"
     * @return boolean true
     */
    protected function edit_access_module()
    {
		return true;
    }

	/**
	 * Редактирование поля "Изображение"
	 * @return boolean true
	 */
	protected function edit_image_module()
	{
		if(! $this->diafan->addnew)
		{
			$images_row = DB::fetch_array(DB::query("SELECT id, name FROM {images} WHERE element_id=%d AND module_name='%s' AND trash='0' ORDER BY sort DESC LIMIT 1", $this->diafan->edit, $this->table));

			if ($images_row && file_exists(ABSOLUTE_PATH.USERFILES."/".$this->table."/".$images_row["name"]))
			{
				echo '
				<tr>
					<td align="right">
					</td>
					<td>
						<img src="http://'.BASE_URL."/".USERFILES."/".$this->table.'/'.$images_row["name"].'" border="0">
						<input type="checkbox" name="delete_image" value="1"> '._ADMIN_DELETE.'
					</td>
				</tr>';
			}
		}
		echo '
		<tr>
			<td align="right">'.$this->variable_names().'</td>
			<td>
				<input type="file" name="images" size="70">
				'.$this->show_help_row().'
			</td>
		</tr>';

		return true;
	}

    /**
     * Сохранение поля "Элемент модуля"
     * @return boolean true
     */
    protected function save_module_name_module()
    {
		$this->query[] = "module_cat_id='%d'";
		$this->value[] = $_POST["module_cat_id"];

		$this->query[] = "site_id='%d'";
		$this->value[] = $_POST["site_id"];

		$this->query[] = "element_id='%d'";
		$this->value[] = $_POST["element_id"];

		$this->query[] = "module_name='%h'";
		$this->value[] = $_POST["module_name"];

		return true;
    }

    /**
     * Сохранение поля "Доступ"
     * @return boolean true
     */
    protected function save_access_module()
    {
		if ($_POST["element_id"])
		{
			$element = DB::fetch_array(DB::query("SELECT access FROM {%h} WHERE id=%d", $_POST["module_name"], $_POST["element_id"]));
		}
		elseif ($_POST["module_cat_id"])
		{
			$element = DB::fetch_array(DB::query("SELECT access FROM {%h_category} WHERE id=%d", $_POST["module_name"], $_POST["module_cat_id"]));
		}
		else
		{
			$element = DB::fetch_array(DB::query("SELECT access FROM {site} WHERE id=%d", $_POST["site_id"]));
		}

		$this->query[] = "access='%d'";
		$this->value[] = $element["access"];

		return true;
    }

    /**
     * Сохранение поля "Родитель"
     * 
     * @return boolean
     */
    protected function save_parent_id_module()
    {
		if (!$this->diafan->savenew && $_POST["cat_id"] != $this->oldrow["cat_id"])
		{
			if ($_POST["parent_id"] && DB::query_result("SELECT cat_id FROM {menu} WHERE id=%d", $_POST["parent_id"]) != $_POST["cat_id"])
			{
			$_POST["parent_id"] = 0;
			}
		}
		parent::save_parent_id_module();
    }

	/**
	 * Сохранение поля "Изображение"
	 * @return boolean true
	 */
	protected function save_image_module()
	{
		if (! empty($_POST["delete_image"]))
		{
			$result = DB::query("SELECT id, name FROM {images} WHERE module_name='%s' AND element_id='%d'", $this->table, $this->diafan->save);
			while ($row = DB::fetch_array($result))
			{
				unlink(ABSOLUTE_PATH.USERFILES.'/'.$this->table.'/'.$row["name"]);
			}
			DB::query("DELETE FROM {images} WHERE module_name='%s' AND element_id='%d'", $this->table, $this->diafan->save);
		}
		if (isset($_FILES["images"]) && is_array($_FILES["images"]) && $_FILES["images"]['name'] != '')
		{
			Customization::inc("includes/image.php");

			$result = DB::query("SELECT id, name FROM {images} WHERE module_name='%s' AND element_id='%d'", $this->table, $this->diafan->save);
			while ($row = DB::fetch_array($result))
			{
				unlink(ABSOLUTE_PATH.USERFILES.'/'.$this->table.'/'.$row["name"]);
			}
			DB::query("DELETE FROM {images} WHERE module_name='%s' AND element_id='%d'", $this->table, $this->diafan->save);

			$new_name = strtolower($this->diafan->translit($_FILES["images"]['name']));
			$extension = substr(strrchr($new_name, '.'), 1);
			$new_name = substr($new_name, 0, - (strlen($extension) + 1));
			if (strlen($new_name) + strlen($extension) > 49)
			{
				$new_name = substr($new_name, 0, 49 - strlen($extension));
			}

			if (! in_array($extension, array('gif', 'jpeg', 'jpg', 'jpe', 'png')))
			{
				return '<br>'.sprintf(_LANG_ATTACHMENT_EXTENSIONS, 'gif, jpeg, jpg, jpe, png');
			}

			$size = filesize($_FILES["images"]['tmp_name']);

			$new_name = $new_name.'.'.$extension;

			DB::query("INSERT INTO {images} (name, module_name, element_id, size) VALUES ('%s', '%s', '%d', '%d')",
				$new_name,
				$this->table,
				$this->diafan->save,
				$size
			);

			$id = DB::last_id("images");
			$new_name = $id.'_'.$new_name;
			DB::query("UPDATE {images} SET name='%h' WHERE id=%d", $new_name, $id);

			if (! copy($_FILES["images"]['tmp_name'], ABSOLUTE_PATH.USERFILES."/".$this->table."/".$new_name))
			if ($err)
			{
				echo '<script language="javascript" type="text/javascript">alert(\''._ADMIN_NO_UPLOAD_FILE.'\');history.go(-1);</script>';
			}

			chmod(ABSOLUTE_PATH.USERFILES."/".$this->table."/".$new_name, 0755);

		}

		return true;
	}
}