<?php

/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */
if (!defined('DIAFAN'))
{
    include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * News_admin
 *
 * Редактирование новостей
 */
class News_admin extends Frame_admin
{

    /**
     * @var string название файла. используется в имени констант, определяющих названия полей
     */
    public $file = 'news';

    /**
     * @var string таблица в базе данных
     */
    public $table = 'news';

    /**
     * Конструктор класса
     * 
     * @return void
     */
    public function __construct($diafan)
    {
	$this->diafan = $diafan;

	//поля в базе данных для редактирования
	$this->variable_table = array(
	    'main' => array(
		'name' => 'text',
		'created' => 'datetime',
		'act' => 'checkbox',
		'hr1' => 'hr',
		'images' => 'module',
		'hr2' => 'hr',
		'site_id' => 'function',
		'cat_id' => 'function',
		'anons' => 'editor',
		'text' => 'editor',
		'search' => 'module',
	    ),
	    'other_rows' => array(
		'tags' => 'module',
		'hr4' => 'hr',
		'menu' => 'module',
		'number' => 'function',
		'timeedit' => 'function',
		'title_meta' => 'text',
		'keywords' => 'text',
		'descr' => 'textarea',
		'rewrite' => 'function',
		'access' => 'function',

		'view'        => 'none',
		'prior' => 'checkbox',
		'map_no_show' => 'checkbox',
		'hr5' => 'hr',
		'comments' => 'module',
		'rating' => 'module',
			'h6'=>'hr',
			'theme'       => 'function',
	    )
	);

	//переводимые поля
	$this->language_names = array(
	    'name',
	    'title_meta',
	    'anons',
	    'act',
	    'keywords',
	    'descr',
	    'text'
	);

	$this->config_module = array(
	    'act' => 1, //показать/скрыть
	    'menu' => 1, //используется в меню
	    'del' => 1, //удалить
	    'date' => 1, //показывать дату в списке, сортировать по дате
	    'prior' => 1, //сортировать по полю приоритет
	    'element_site' => 1, //модуль может быть прикреплен к нескольким страницам
	    'element' => $this->diafan->configmodules("cat", "news", $this->diafan->site) ? 1 : 0, //используются группы
	    'element_multiple' => $this->diafan->configmodules("cat", "news", $this->diafan->site) ? 1 : 0, //модуль может быть прикреплен к нескольким группам
	    'search_name' => 1, //искать по названию
	    'trash' => 1  //использовать корзину
	);

	//выводить в списке содержание полей:
	$this->config_other_row = array(
	    'anons',
	    //'text'
	);

	//высота поля для Визуального редактора
	$this->editor_height = array(
	    'anons' => 200,
	    'text' => 400
	);
    }

    /**
     * Выводит список новостей
     * @return boolean TRUE
     */
    public function show_module()
    {
	if ($this->config_module['element'] && !$this->not_empty_categories)
	{
	    echo '<div class="error">'.sprintf(_ADMIN_NEWS_EMPTY_CATEGORIES, '<a href="'.BASE_PATH_HREF.'news/config/">', '</a>','<a href="'.BASE_PATH_HREF.'news/category/'.($this->diafan->site ? 'site'.$this->diafan->site.'/' : '').'">', '</a>').'</div>';
	}
	else
	{
	    $this->addnew_init(_ADMIN_NEWS_ADD);
	}

	$this->list_row();


	return TRUE;
    }

}