<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Шаблон первой страницы фотогалереи, где выводятся все категории и по несколько фотографий из каждой
 */

if (empty($result["categories"]))
	return false;

//вывод категорий
foreach ($result["categories"] as $cat_id => $cat)
{
	echo '<div class="photo_list">';

	//название категории
	echo '<h2>'.$cat["name"].'</h2>';

	//краткое описание категории
	if (! empty($cat["anons"]))
	{
		echo '<div class="photo_cat_anons">'.$cat["anons"].'</div>';
	}

	//подкатегории
	if (! empty($cat["children"]))
	{
		foreach ($cat["children"] as $child)
		{
			echo '<div class="photo_cat_link">';

			//название и ссылка подкатегории
			echo '<a href="'.BASE_PATH_HREF.$child["link"].'">'.$child["name"].'</a>';

			//краткое описание подкатегории
			if (! empty($child["anons"]))
			{
				echo '<div class="photo_cat_anons">'.$child["anons"].'</div>';
			}
			echo '</div>';
		}
	}

	//вывод нескольких фотографий из текущей категории (задается в настройках модуля)
	if ($cat["rows"])
	{
		foreach ($cat["rows"] as $row)
		{
			echo '<div class="photo">';

			//изображение
			if (! empty($row["img"]))
			{
				echo '<div class="photo_img">';
				switch($row["img"]["type"])
				{
					case 'animation':
						echo '<a href="'.BASE_PATH.$row["img"]["link"].'" rel="prettyPhoto[galleryphoto]">';
						break;
					case 'big_image':
						echo '<a href="'.BASE_PATH.$row["img"]["link"].'" rel="big_image" width="'.$row["img"]["link_width"].'" height="'.$row["img"]["link_height"].'">';
						break;
					default:
						echo '<a href="'.BASE_PATH_HREF.$row["img"]["link"].'">';
						break;
				}
				echo '<img src="'.$row["img"]["src"].'" width="'.$row["img"]["width"].'" height="'.$row["img"]["height"]
				.'" alt="'.$row["img"]["alt"].'" title="'.$row["img"]["title"].'">'
				.'</a></div>';
			}

			//название и, если используется, ссылка на отдельную страницу фотографии
			if ($row["name"])
			{
				echo '<div class="photo_name">';
				if ($row["link"])
				{
					echo '<a href="'.BASE_PATH_HREF.$row["link"].'">';
				}
				echo $row["name"];
				if ($row["link"])
				{
					echo '</a>';
				}
				echo '</div>';
			}

			//краткое описание фотографии
			if (! empty($row["anons"]))
			{
				echo '<div class="photo_anons">'.$row["anons"].'</div>';
			}

			//рейтинг фотографии
			if (! empty($row["show_rating"]))
			{
				echo $row["show_rating"];
			}

			echo '</div>';
		}
	}

	//ссылка на все фотографии в категории
	if ($cat["link_all"])
	{
		echo '<div class="show_all"><a href="'.BASE_PATH_HREF.$cat["link_all"].'">'
		.$this->_('SHOW_ALL_PHOTOS_IN_CATEGORY').' '.$this->_('LQUOT').$cat["name"].$this->_('RQUOT')
		.'</a></div>';
	}

	echo '</div>';
}