<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Rating_admin_del
 * 
 * Удаление рейтинга элемента
 */
class Rating_admin_del
{
	/**
	 * Помечает рейтинг элемена на удаление или удаляет рейтинг
	 * 
	 * @param string $module_name название модуля, к которому прикреплен рейтинг
	 * @param integer $element_id номер элемента, к которому прикреплен рейтинг
	 * @param integer $trash_id номер записи в корзине, с которой связано удаление
	 * @param integer $is_category удаляемый элемент - категория
	 * @return boolean true
	 */
	public static function delete($th, $module_name, $element_id, $trash_id = 0, $is_category = false)
	{
		if ($is_category)
		{
			return false;
		}
		$th->del_or_trash_where("rating", "element_id='".$element_id."' AND module_name='".$module_name."'", $trash_id);
		$th->diafan->_cache->delete("", "rating");
		return true;
	}
}