<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Rating_admin
 *
 * Редактирование рейтигов
 */
class Rating_admin extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file	=	'rating';

	/**
	 * @var string таблица в базе данных
	 */
	public $table	=	'rating';

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;
		
		//поля в базе данных для редактирования
		$this->variable_table = array(
			'main'=>
array (
  'element_id' => 'function',
  'rating' => 'floattext',
  'count_votes' => 'numtext',
  'created' => 'datetime',
)
		);
		
		$this->config_module = array(
			'del'		=> 1,	//удалить
			'datetime'	=> 1,	//показывать дату и время в списке
			'trash'		=> 1	//использовать корзину
		);
		
		//выводить в списке содержание полей:
		$this->config_other_row = array(
			'module_name',
			'element_id',
			'rating'
		);
	}

	/**
	 * Выводит список оценок
	 * @return boolean true
	 */
	public function show_module()
	{
		$this->name = "id, '"._LANG_EDIT."'";
		/*echo '<table border="0" cellpadding="1" cellspacing="3" class="list"><tr valign="top"><td>
		<b>'._ADMIN_RATING_CREATED.'</b></td><td>
		<b>'._LANG_EDIT.'</b></td><td>
		<b>'._ADMIN_MODULE_NAME.'</b></td><td>
		<b>'._LANG_NAME.'</b></td><td>
		<b>'._ADMIN_RATING_RATING.'</b></td><td>
		<b>'._ADMIN_RATING_COUNT_VOTES.'</b></td>
		</tr>';*/
		$this->list_row();	
		//echo '<tr><td><br /></td></tr></table>';

		return true;
	}

	/**
	 * Выводит объект, которому поставлена оценка
	 * 
	 * @return string
	 */
	protected function other_row_element_id($row)
	{					
		$name = DB::query_result("select name from {".$row["module_name"]."} where id='%d'", $row["element_id"]);
		return '</td><td class="element_id">'.($name ? $name : $row["element_id"]);
	}

	/**
	 * Выводит название модуля в списке
	 * 
	 * @return string
	 */
	protected function other_row_module_name($row)
	{					
		$const = strtoupper('_LANG_'.$row["module_name"]);
		return '</td><td class="module_name">'.(defined($const) ? constant($const) : $row["module_name"]);
	}

	/**
	 * Выводит среднюю оценку в списке
	 * 
	 * @return string
	 */
	protected function other_row_rating($row)
	{
		return '</td><td class="raiting">'.$row["rating"];
	}


	/**
	 * Редактирование поля "Объект"
	 * @return boolean true
	 */
	protected function edit_element_id_module()
	{
		$link = BASE_PATH_HREF.$this->values["module_name"]
		.($this->diafan->configmodules('cat', $this->values["module_name"]) ? '/cat'.DB::title($this->values["module_name"], $this->value,"cat_id") : '')
		.'/edit'.$this->value.'/';
		
		echo '
		<tr valign="top">
			<td align="right">
				'.$this->variable_names().'
			</td>
			<td>
				<a href="'.$link.'" target="_blank">'.$link.'</a>
			</td>
		</tr>';

		return true;
	}

	/**
	 * Сохранение поля "Объект"
	 * @return boolean true
	 */
	protected function save_element_id_module()
	{
		return true;
	}
}