<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Reminding_ajax
 *
 * Обработка запроса при отправке данных из формы восстановления пароля
 */
class Reminding_ajax extends Ajax
{
	/**
	 * Обрабатывает полученные данные из формы
	 * 
	 * @return boolean
	 */
	function ajax_request()
	{
		if (empty($_POST['module']) || $_POST['module'] != 'reminding' || $this->diafan->_user->id || $this->diafan->module != 'reminding')
		{
			return false;
		}
		$this->module = 'users';
		$this->tag = 'reminding';
		$this->check_captcha();
		$this->check_fields();

		if ($this->send_errors())
			return true;

		if ($this->check_log())
			return true;

		if (! $row = DB::fetch_array(DB::query("SELECT id, fio, mail FROM {users} WHERE name='%h' AND mail='%h'", $_POST["name"], $_POST["mail"])))
		{
			$this->result["errors"][0] = _LANG_REMINDING_WRONG_DATA;
			return $this->send_errors();
		}

		require_once (ABSOLUTE_PATH.'includes/mail.php');

		$actlink = '';

		if (! IS_ADMIN && $this->diafan->configmodules("act", "users") == 1 && empty($row["act"]))
		{
			$actcode = md5(rand(111, 99999));
			if ($id = DB::query_result("SELECT id FROM {users_actlink} WHERE user_id='%d'", $row["id"]))
			{
				DB::query("UPDATE {users_actlink} SET link='%s', created='%d' WHERE id='%d'", $actcode, time() + 86400, $id);
			}
			else
			{
				DB::query("INSERT INTO {users_actlink} (link,user_id,created) VALUES ('%s','%d','%d')", $actcode, $row["id"], time() + 86400);
			}

			$link = BASE_PATH_HREF.$this->diafan->_route->module('registration').'?act='.$actcode;
			$actlink = '<a href="'.$link.'">'.$link.'</a>';
		}
		elseif (! IS_ADMIN)
		{
			$mes .= $this->diafan->_tpl->get('show_login', 'registration', array("action" => BASE_PATH_HREF));
		}

		//new password
		$newpass = $this->random_password(8);
		DB::query("UPDATE {users} SET password='%s' WHERE id='%d'", code_password($newpass), $row["id"]);

		//send mail user
		$subject = str_replace(
				array('%title', '%url'),
				array(TITLE, BASE_URL),
				$this->diafan->configmodules('subject_reminding', "users")
			);

		$message = str_replace(
			array('%login', '%title', '%url', '%fio', '%password', '%actlink'),
			array(
				$this->diafan->get_param($_POST, "name", '', 1),
				TITLE,
				BASE_URL,
				$row["fio"],
				$newpass,
				$actlink
			),
			$this->diafan->configmodules('message_reminding', "users")
		);

		send_mail(
				IS_ADMIN && $_GET["rewrite"] == "reminding/diafan" ? 'diafan@diafan.ru' : $row["mail"],
				$subject,
				$message,
				$this->diafan->configmodules("emailconf", "users") ? $this->diafan->configmodules("email", "users") : ''
			);

		$mes = $this->diafan->configmodules('mes_reminding', 'users');
		$this->result["errors"][0] = $mes ? $mes : ' ';

		return $this->send_errors();
	}


	/**
	 * Проверяет заполнены ли поля
	 * 
	 * @return boolean true
	 */
	private function check_fields()
	{
		if (! $_POST["name"])
		{
			$this->result["errors"]["name"] = _LANG_ENTER_USERNAME;
		}
		if (! $_POST["mail"])
		{
			$this->result["errors"]["mail"] = _LANG_ENTER_EMAIL;
		}
		return true;
	}

	/**
	 * Проверяет попытку подбора логина
	 * 
	 * @return boolean
	 */
	private function check_log()
	{
		DB::query("DELETE FROM {log} WHERE created<'%d'", time());

		if (getenv('HTTP_X_FORWARDED_FOR'))
		{
			$ip = getenv('HTTP_X_FORWARDED_FOR');
		}
		else
		{
			$ip = getenv('REMOTE_ADDR');
		}
		$date   = time() + 1800;
		$result = DB::query("SELECT `count` FROM {log} WHERE ip='%h'", $ip); 
		if (DB::num_rows($result) > 0)
		{
			$row = DB::fetch_array($result);
			if ($row['count'] > 10)
			{
				$this->result["errors"][0] = _LANG_BLOCKED_30_MIN;
			}
			else
			{
				DB::query("UPDATE {log} SET count=count+1, created='%d' WHERE ip='%s'", $date, $ip);
			}
		}
		else
		{
			$info = getenv('HTTP_USER_AGENT');
			DB::query('INSERT INTO {log} (ip,created,info) VALUES ("'.$ip.'", "'.$date.'", "'.$info.'")');
		}
		return $this->send_errors();
	}

	/**
	 * Генерирует пароль
	 *
	 * @param integer $length длина пароля
	 * @param boolean $allow_uppercase использовать в пароле буквы в верхнем регистре
	 * @param boolean $allow_numbers использовать в пароле цифры
	 * @return string
	 */
	private function random_password($length = 8, $allow_uppercase = true, $allow_numbers = true)
	{
		$out = '';
		$arr = array();
		for ($i= 97; $i < 123; $i++)
		{
			$arr[] = chr($i);
		}
		if ($allow_uppercase)
		{
			for ($i = 65; $i < 91; $i++)
			{
				$arr[] = chr($i);
			}
		}
		if ($allow_numbers)
		{
			for ($i = 0; $i < 10; $i++)
			{
				$arr[] = $i;
			}
		}
		shuffle($arr);
		for ($i = 0; $i < $length; $i++)
		{
			$out .= $arr[mt_rand(0, sizeof($arr) - 1)];
		}
		return $out;
	}
}