<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Search_admin
 *
 * Работа с поисковым индексом
 */
class Search_admin extends Frame_admin
{
	
    public $file =	'search';
	
    public function __construct($diafan)
    {
	   $this->diafan = $diafan;
    }

    /**
    * Вывод списка модулей, готовых к поисковому индексированию.
    * 
    * @return boolean true
    */
    public function show_module()
    {
        if(! empty($_REQUEST['action']))
        {
			if(empty($_REQUEST['ids']))
			{
				$this->diafan->redirect_js(URL);
			}
            $this->delete_index($_REQUEST['ids']);

            if($_REQUEST['action'] == "create_index")
            {
                $this->create_index($_REQUEST['ids']);
            }
			$this->diafan->redirect_js(URL . 'error1/');
        }
         
	   $modules = array();
	   if ($dir = opendir(ABSOLUTE_PATH."modules"))
		{
			while (($file = readdir($dir)) !== false)
			{
				if (! $file != '.' && $file != '..' && file_exists(ABSOLUTE_PATH.'modules/'.$file.'/'.$file.'.search.php'))
				{
				   $modules[] = $file;
				}
			}
		}
		closedir($dir);
              
        echo '<form method="get" action=""><ul class="list">';
		foreach ($modules as $module)
        {
            $name  = $module;
			$const = strtoupper('_LANG_'.$module);

			if (defined($const))
			{
				$name = constant($const);
			}
                        
            echo '<li class="level_0"><div class="table_wrap"><table width="100%"><tr>
            <td class="checkbox"><input type="checkbox" value="'.$module.'" name="ids[]"><td class="name">'.$name.'</td>
            <td class="action_separator"><span></span></td>
            <td class="action_icon">&nbsp;<a href="?action=create_index&ids[]='.$module.'">'._ADMIN_SEARCH_CREATE_INDEX.'</a>&nbsp;</td>
            <td class="action_separator"><span></span></td>
            <td class="action_icon">&nbsp;<a href="?action=delete_index&ids[]='.$module.'">'._ADMIN_SEARCH_DELETE_INDEX.'</a>&nbsp;</td>

            </td></tr></table>
            </div></li>';
        }
		echo '</ul>

		<div class="group_action no_move">

		<table><tr>
		<td><input type="checkbox" id="select_all"></td>
		<td><span class="select_all">'._ADMIN_CHECK_ALL.'</span></td>
		<td><select name="action"><option value="create_index">'._ADMIN_SEARCH_CREATE_INDEX.'</option><option value="delete_index">'._ADMIN_SEARCH_DELETE_INDEX.'</option></select></td>
		<td><input type="submit" class="button" value="'._ADMIN_APPLY.'" id="group_actions_search"></td>
		</tr>
</table>
		</div>
		</form>';

	   return true;
    }

    /**
    * Создание поискового индекса.
    * 
    * @param array $modules массив названий модулей
    * 
    * @return boolean true
    */
    public function create_index($modules)
    {
	   foreach($modules as $module)
	   {
		  if($module == 'site')
		  {
			 $this->create_index_for_site_pages();
		  }
		  else
		  {
			 $this->create_index_for_module_pages($module);
		  }
	   }
       return TRUE;
    }
    
    /**
    * Создание поискового индекса для страниц сайта.
    * 
    * 
    * @return boolean true
    */
    public function create_index_for_site_pages()
    {
	   $element_ids = array();
	   $result = DB::query("SELECT id FROM {site} WHERE [act]='1' AND trash='0' AND block='0'");

	   while($row = DB::fetch_array($result))
	   {
		  $element_ids[] = $row['id'];
	   }
	   if(! empty($element_ids))
	   {
		  $params = array();

		  $params['module'] = 'site';
		  $params['config_module']['category']  = 0;
		  $params['site'] =  1;
		  Customization::inc('modules/search/admin/search.admin.act.php');
		  Search_admin_act::act($this, 'site', $element_ids, 1, $params);
	   }
       
       return TRUE;
    }
    
    /**
    * Создание поискового индекса для модуля.
    * 
    * @param string $module название модуля
    * 
    * @return boolean true
    */
    public function create_index_for_module_pages($module)
    {
	   include_once ABSOLUTE_PATH.'modules/search/admin/search.admin.act.php';
	   $lang = _LANG ? _LANG : 0;
	   $result = DB::query("SELECT id FROM {site} WHERE [act]='1' AND trash='0' AND addmodule='%s'", $module);

	   while ($row = DB::fetch_array($result))
	   {
		  $element_ids = array();
		  $params = array();
		  $params['module'] = $module;
		  $params['config_module']['category']  = 0;
		  $params['site'] =  $row['id'];

		  $elements_result = DB::query("SELECT id FROM {%s} WHERE [act]='1' AND trash='0' AND
		                                site_id=%d", $module, $row['id']);

		  while($element_row = DB::fetch_array($elements_result))
		  {
			 $element_ids[] = $element_row['id'];
		  }
		  if(! empty($element_ids))
		  {
			 Search_admin_act::act($this, $module, $element_ids, 1, $params);
		  }
		  
		  if($this->diafan->configmodules ('cat', $module, $row['id'], $lang))
		  {
			 $element_ids = array();
			 $params['config_module']['category']  = 1;

			 $categories_result = DB::query("SELECT id FROM {%s} WHERE [act]='1' AND trash='0' AND
			                                 site_id=%d", $module.'_category', $row['id']);

			 while($categories_row = DB::fetch_array($categories_result))
			 {
				$element_ids[] = $categories_row['id'];
			 }
			 if(! empty($element_ids))
			 {
				Search_admin_act::act($this, $module.'_category', $element_ids, 1, $params);
			 }
		  }
	   }
	   return true;
    }
    
    /**
    * Удаление поискового индекса для выбранных модулей.
    * 
    * @param array $modules массив названий модулей
    * 
    * @return boolean true
    */
    public function delete_index($modules)
    {
       $lang = _LANG ? _LANG : 1;
       foreach($modules as $module)
	   {
		  DB::query("DELETE FROM {search_index} WHERE result_id IN
	                (SELECT id FROM {search_results} WHERE  (module='%s' OR module='%s') AND
                     lang_id=%d)", $module, $module.'_category', $lang);
		  DB::query("DELETE FROM {search_results} WHERE (module='%s' OR module='%s') AND lang_id=%d",
                    $module, $module.'_category', $lang);
	   }
		DB::query("DELETE FROM {search_keywords} WHERE id NOT IN (SELECT DISTINCT(keyword_id) FROM {search_index} )");

	   return true;
    }
}