<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Search_admin_save
 * 
 * Добавление в поисковый индекс
 */
class Search_admin_save
{

    protected static $config;


    /**
	 * Добавление элемента в поисковый индекс.
	 * 
	 * @return boolean true
	 */
	public static function save($th)
	{
	   Customization::inc('modules/search/admin/search.admin.index.php');
       if((isset($_REQUEST['block']) || ! isset($_REQUEST['act'])) &&
          (! ($th->diafan->save == 1 && $th->diafan->module == 'site')))
	   {
		  
          $module = self::get_module($th);
		  self::delete_search_index($module, $th->diafan->save);
		  return true;
	   }
	   	  
	   if(!file_exists(ABSOLUTE_PATH.'modules/'.$th->diafan->module.'/'.$th->diafan->module.'.search.php'))
       {
           return false;
       }
	   Customization::inc('modules/'.$th->diafan->module.'/'.$th->diafan->module.'.search.php');

	   $config = self::get_config($th->diafan->module);
	   $lang = _LANG ? _LANG : 1;
	   
	   $module = self::get_module($th);
	   $url = self::get_url($th);
	  
	   $element_for_indexation = new Element_for_indexation($th->diafan->save, $module, $url,
												 $config,  $lang);

       try
	   {
		  $search_index = new Search_index($element_for_indexation, $th->diafan);
	   }
	   catch(Exception $e)
	   {
		  echo $e;
		  exit;
	   }
       try
	   {
		  $search_index->add();
	   }
	   catch(Exception $e)
	   {
		  echo $e;
		  exit;
	   }

	   return true;
	}
    
     /**
	 * Получение url элемента
	 * 
	 * @return string $url
	 */
    protected static function get_url($th)
    {
        $site_id = ! empty($th->diafan->site) ? $th->diafan->site : $th->diafan->cid;

        if($th->config_module['category'])
        {
            $cat_id =  $th->diafan->save;
            $element_id = 0;
        }
        else
        {
            $category_exists = DB::fetch_array(DB::query("SELECT value FROM {config}
                               WHERE name='cat' AND module_name='%s' AND site_id=%d",
                               $th->diafan->module, $site_id));
            if($category_exists['value'] == 1)
            {
                $cat_id = DB::query_result("SELECT cat_id FROM {%s} WHERE id=%d",
                                           $th->diafan->module, $th->diafan->save);
            }
            else
            {
                $cat_id = 0;
            }

            $element_id = $th->diafan->save;
        }
       
        $url = '';
        if ($_GET["rewrite"] || defined('_LANG') && _LANG)
        {
            $rew = explode('/', $_GET["rewrite"], 2);
            foreach ($th->diafan->language_all as $l => $langarr)
            {
                if (! defined('_LANG') && in_array($rew[0], $langarr) || defined('_LANG') && $langarr[0] == _LANG)
                {
                    $url .= ! empty($langarr[1])? $langarr[1].'/' : '';
                    break;
                }
            }

        }

        if(! ($th->diafan->save == 1 && $th->diafan->module == 'site'))
        {
            $url .=$th->diafan->_route->link($site_id, $th->diafan->module, $cat_id, $element_id);
        }

        return $url;
    }
    
     /**
	 * Получение конфигурации модуля, к которому относится элемент.
	 * 
     * @param string $module название модуля
	 * 
     * @return array $config
	 */
    protected static function get_config($module)
    {
        if(! empty(self::$config))
        {
            return self::$config;
        }

        $config_classname = $module.'_search_config';
        $config = new $config_classname();
        self::$config = $config->config;

        return  self::$config;
   }
    
    /**
    * Получение названия модуля, к которому относится элемент.
    * 
    * @return string $module
    */
    protected static function get_module($th)
    {
       if($th->config_module['category'])
       {
           $cat_id =  $th->diafan->save;
       }
       
       return $th->diafan->module.(! empty($cat_id) ? '_category' : '');
   }
   
    /**
	 * Удаление данных поискового индекса, связанных с элементом.
	 * 
     * @param string $module название модуля
     * @param integer $element_id идентификатор элемента
     * 
	 * @return boolean true
	 */
    protected static function delete_search_index($module, $element_id)
    {
	   $lang = _LANG ? _LANG : 1;
	   Search_index::delete($element_id, $module, $lang);

	   return true;
    }
}