<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Search_model
 *
 * Модель модуля "Поиск по сайту"
 */
class Search_model extends Model
{
	/**
	 * @var integer количество элементов, показанных на странице
	 */
	private $nastr = 10;

	/**
	 * Генерирует список найденных страниц
	 * 
	 * @return array
	 */
    public function show_module()
    {
	   $search = '';
	   if (isset($_GET["searchword"]))
	   {
		  if (is_array($_GET["searchword"]))
		  {
			 $_GET["searchword"] = '';
		  }
		  $search = trim(htmlspecialchars(stripslashes($_GET["searchword"])));
	   }
	   $this->result = array();

	   if (! empty($search))
	   {
			$search_words = $this->diafan->_search->prepare($search);
          
			$lang = _LANG ? _LANG : 1;

			$nen = DB::query_result("SELECT COUNT(*) FROM {search_results} as r 
									WHERE r.lang_id=%d AND r.id IN 
								(
									SELECT i.result_id 
									FROM {search_keywords} AS k INNER JOIN {search_index} AS i ON  k.id=i.keyword_id
									WHERE k.keyword IN('".implode("', '", $search_words)."')
								)", $lang);

			////navigation//
			if ($this->nastr)
			{
				$this->diafan->_paginator->nastr = $this->nastr;
			}
			$this->diafan->_paginator->page    = $this->diafan->page;
			$this->diafan->_paginator->navlink = $this->diafan->_route->current_link("page");
			$this->diafan->_paginator->get_nav = '?searchword='.$search;
			$this->diafan->_paginator->nen     = $nen;
			$links = $this->diafan->_paginator->get();
			////navigation///
		  
			$k = ! $this->diafan->page ? 1 : ($this->diafan->page - 1) * $this->diafan->_paginator->nastr + 1;

			$this->result["paginator"] = $this->diafan->_tpl->get('get', 'paginator', $links);

			$result = DB::query_range("SELECT r.name, r.url as link, r.snippet FROM {search_results} as r 
										WHERE r.lang_id=%d AND r.id IN 
									(
									SELECT i.result_id 
									FROM {search_keywords} AS k INNER JOIN {search_index} AS i ON  k.id=i.keyword_id
									WHERE k.keyword IN('".implode("', '", $search_words)."')
									)", 
									$lang, $this->diafan->_paginator->polog, $this->diafan->_paginator->nastr);
		  
		  
			while ($row = DB::fetch_array($result))
			{
				$row["snippet"] = $this->str_search($row["snippet"], $search);
				$row["name"] = $this->diafan->short_text($row["name"], 20);
				$row["link"] = BASE_PATH_HREF.$row["link"];

				$this->result["rows"][] = $row;
			}

			$this->result["count"] = $this->diafan->_paginator->nen;
			$this->result["count-page"] = $this->diafan->_paginator->nen > $this->diafan->_paginator->nastr ? 
			                                    $this->diafan->_paginator->nastr : $this->diafan->_paginator->nen;
		}
		$this->result["value"] = $search;
		$this->result["button"] = _LANG_SEARCH;
		$this->result["action"] = BASE_PATH_HREF.$this->diafan->_route->link($this->diafan->cid);

		return $this->result;
    }

	/**
	 * Генерирует контент для шаблонной функции: форма поиска по сайту
	 * 
	 * @return array
	 */
	function show_search($button)
	{			
		$result["value"] = '';
		if (isset($_GET["searchword"]))
		{
			if (is_array($_GET["searchword"]))
			{
				$_GET["searchword"] = '';
			}
			$result["value"] = trim(htmlspecialchars(stripslashes($_GET["searchword"])));
		}
		$result["action"] = BASE_PATH_HREF.$this->diafan->_route->module('search');
		$result["button"] = $button;
		return $result;
	}

	/**
	 * Ищет слово в тексте и выделяет его жирным
	 * 
	 * @return array
	 */
	private function str_search($text, $search)
	{
		return $this->diafan->short_text($text, 200);
	}
}
