<?php

/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */
if (!defined('DIAFAN'))
{
    include dirname(dirname(dirname(__FILE__))) . '/includes/404.php';
}

/**
 * Shop_admin_config
 *
 * Конфигурация магазина
 */
class Shop_admin_config extends Frame_admin {

    /**
     * @var string название файла. используется в имени констант, определяющих названия полей
     */
    public $file = 'shop_config';

    /**
     * Конструктор класса
     * 
     * @return void
     */
    public function __construct($diafan)
    {
        $this->diafan = $diafan;

        $this->variable_table = array(
            'base' => array(
                'not_buy'       => 'checkbox',
                'security_user' => 'checkbox',
                'hr1'           => 'hr',
                'nastr'                  => 'numtext',
                'hr2'                    => 'hr',
				'use_non_material_goods' => 'checkbox',
                'attachment_extensions'  => 'text',
                'attachments_access_admin'  => 'none',
                'hr3'                    => 'hr',
                'use_count_goods'        => 'checkbox',
                'hr4'                    => 'hr',
                'cat'                => 'checkbox',
                'count_list'         => 'numtext',
                'childrens_elements' => 'checkbox',
                'hr5'                => 'hr',
                'currency'       => 'text',
                'format_price'   => 'function',
                'format_price_1' => 'none',
                'format_price_2' => 'none',
                'format_price_3' => 'none',
                'hr6'            => 'hr',
                'search_price'   => 'checkbox',
                'search_text'    => 'checkbox',
                'search_name'    => 'checkbox',
                'search_article' => 'checkbox',
                'hr7'            => 'hr',
                'comments' => 'module',
                'tags'     => 'module',
                'rating'   => 'module',
				'hr8'=>'hr',

				'themes'             => 'function',
				'theme_list'         => 'none',
				'view_list'          => 'none',
				'theme_first_page'   => 'none',
				'view_first_page'    => 'none',
				'theme_id'           => 'none',
				'view_id'            => 'none',
				'theme_list_param'   => 'none',
				'view_list_param'    => 'none',
				'theme_list_compare' => 'none',
				'view_list_compare'  => 'none',
				'theme_list_search' => 'none',
				'view_list_search'  => 'none'
            ),
            'images'   => array(
                'images'      => 'module',
            ),
            'yandex_shop' => array(
                'yandex'               => 'checkbox',
                'nameshop'             => 'text',
                'currencyyandex'       => 'function',
                'currencyratesel'      => 'none',
                'currencyrate'         => 'none',
                'show_yandex_category' => 'select',
                'show_yandex_element'  => 'select',
                'bid'                  => 'numtext',
                'cbid'                 => 'numtext'
            ),
            'send_mails'           => array(
                'mes' => 'textarea',
                'desc_order'         => 'text',
                'error_empty_fields' => 'text',
                'hr9' => 'hr',
                'subject'   => 'text',
                'message'   => 'textarea',
                'emailconf' => 'function',
                'email'     => 'none',
                'hr10' => 'hr',
                'subject_admin'     => 'text',
                'message_admin'     => 'textarea',
                'emailconfadmin'    => 'function',
                'email_admin'       => 'none',
                'hr11'              => 'hr',
                'file_sale_message' => 'textarea'
            )
        );

        $this->language_names = array(
            'currency',
            'mes',
            'subject',
            'message',
            'desc_order'
        );

        $this->config_module = array(
            'tab_card'     => 1, //делить редактирование на вкладки
            'element_site' => 1, //делит элементы по разделам (страницы сайта, к которым прикреплен модуль)
            'config'       => 1  //файл настроек модуля
        );

        $this->select_arr["currencyyandex"] = array(
            'RUR' => 'RUR',
            'USD' => 'USD',
            'EUR' => 'EUR',
            'UAH' => 'UAH'
        );

        $this->select_arr["show_yandex_category"] = array(
            '0' => _ADMIN_SHOP_YANDEX_0,
            '1' => _ADMIN_SHOP_YANDEX_1
        );

        $this->select_arr["show_yandex_element"] = array(
            '0' => _ADMIN_SHOP_YANDEX_0,
            '1' => _ADMIN_SHOP_YANDEX_1
        );

        $this->select_arr["currencyratesel"] = array(
            '1' => _ADMIN_SHOP_CONFIG_CURRENCYRATESEL_1,
            '2' => _ADMIN_SHOP_CONFIG_CURRENCYRATESEL_2,
            '3' => _ADMIN_SHOP_CONFIG_CURRENCYRATESEL_3
        );

        $this->show_tr_click_checkbox = array(
            'cat' => array(
                'count_list'
            ),
            'yandex' => array(
                'nameshop',
                'currencyyandex',
                'bid',
                'cbid',
                'show_yandex_category',
                'show_yandex_element'
            ),
			'use_non_material_goods' => array(
                'attachment_extensions'
			)
        );
    }

    /**
     * Редактирование поля "Формат цены"
     * 
     * @return boolean true
     */
    function edit_format_price_module_config()
    {
        echo '
		<tr>
			<td class="td_first">' . $this->variable_names() . '</td>
			<td>
				'
        . sprintf(
                _ADMIN_SHOP_CONFIG_FORMAT_PRICE_NUM, '<input type="text" name="format_price_1" size="2" value="' . $this->values["format_price_1"] . '" class="inpnum">'
                . '<br>', '<input type="text" name="format_price_2" size="2" value="' . $this->values["format_price_2"] . '">'
                . '<br>', '<input type="text" name="format_price_3" size="2" value="' . $this->values["format_price_3"] . '">'
        )
        . $this->show_help_row() . '
			</td>
		</tr>';

        return true;
    }

    /**
     * Редактирование поля "Валюта для Яндекс.Маркета"
     * 
     * @return boolean true
     */
    protected function edit_currencyyandex_module_config()
    {
        echo '
		<tr valign="top">
			<td class="td_first">' . $this->variable_names() . '</td>
			<td>
				<select name="' . $this->key . '">
					' . $this->select_option($this->key, '', '', '', $this->value) . '
				</select>
				<div class="currencyratesel">
					<br>
					<select name="currencyratesel">
						' . $this->select_option('currencyratesel', '', '', '', $this->values['currencyratesel']) . '
					</select>
					<div class="currencyrate">
						<br>
						<input type="text" name="currencyrate" size="20" value="' . $this->values["currencyrate"] . '">
						' . $this->variable_names("currencyrate") . '
					</div>
				</div>';
        ?>
        <script language="javascript" type="text/javascript">
            $(document).ready(function() {
                $("select[name=currencyyandex]").change(function(){
                    show_currency($(this));
                });
                $("select[name=currencyratesel]").change(function(){
                    show_currencysel($(this));
                });
        			
                show_currency($("select[name=currencyyandex]"));
                show_currencysel();
                                
                function show_currency(th)
                {
                    if (th && th.val() == 'RUR')
                    {
                        $(".currencyratesel").hide();
                    }
                    else
                    {
                        $(".currencyratesel").show();
                    }
                }
                function show_currencysel(th)
                {
                    if (th && th.val() == '2')
                    {
                        $(".currencyrate").hide();
                    }
                    else
                    {
                        $(".currencyrate").show();
                    }
                }
            });
        </script>
        <?php

        echo $this->show_help_row() . '
			</td>
		</tr>';

		return TRUE;
    }

    /**
     * Выводит вкладку "Название магазина для Яндекс.Маркета"
     * 
     * @return boolean true
     */
    protected function edit_nameshop_module_config()
    {
        echo '
		<tr>
			<td class="td_first">' . $this->variable_names() . '</td>
			<td>
				<input type="text" name="' . $this->key . '" size="40" value="'
        . (!$this->diafan->addnew ? str_replace('"', '&quot;', $this->value) : '')
        . '" maxlength="20" class="inp_maxlength"> <span class="maxlength">' . (20 - utf::strlen($this->value)) . '</span>
				' . $this->show_help_row() . '
			</td>
		</tr>';

		return TRUE;
    }

	/**
	 * Редактирование поля "Шаблон страницы для разных ситуаций"
	 * @return boolean true
	 */
	protected function edit_themes_module_config()
	{
		$themes = array();
		if ($dir = opendir(ABSOLUTE_PATH."themes"))
		{
			while (($file = readdir($dir)) !== false)
			{
				if ($file != '.' && $file != '..' && $file != 'site.php')
				{
					$themes[] = $file;
				}
			}
		}
		arsort($themes);
		closedir($dir);

		$views = array();
		if ($dir = opendir(ABSOLUTE_PATH."modules/".$this->diafan->module."/views"))
		{
			while (($file = readdir($dir)) !== false)
			{
				if ($file != '.' && $file != '..')
				{
					if(! preg_match('/'.$this->diafan->module.'\.view\.([^\.]+)\.php/', $file, $match))
						continue;
					$views[$match[1]] = $file;
				}
			}
		}
		closedir($dir);

		echo '<tr>
			<td class="td_first">
				'.$this->variable_names("theme_list").'
			</td>
			<td>
				<select name="theme_list">
					<option value="">site.php</option>';
				foreach ($themes as $theme)
				{
					echo '<option value="'.$theme.'"'.($this->values["theme_list"] == $theme ? ' selected' : '').'>'.$theme.'</option>';
				}
				echo '
				</select>
				<select name="view_list">
					<option value="">'.$this->diafan->module.'.view.list.php</option>';
				foreach ($views as $key => $view)
				{
					if($view == $this->diafan->module.".view.list.php")
						continue;
					echo '<option value="'.$key.'"'.($this->values["view_list"] == $key ? ' selected' : '').'>'.$view.'</option>';
				}
				echo '
				</select>
				'.$this->show_help_row("theme_list").'
			</td>
		</tr>

		<tr>
			<td class="td_first">
				'.$this->variable_names("theme_first_page").'
			</td>
			<td>
				<select name="theme_first_page">
					<option value="">site.php</option>';
				foreach ($themes as $theme)
				{
					echo '<option value="'.$theme.'"'.($this->values["theme_first_page"] == $theme ? ' selected' : '').'>'.$theme.'</option>';
				}
				echo '
				</select>
				<select name="view_first_page">
					<option value="">'.$this->diafan->module.'.view.first_page.php</option>';
				foreach ($views as $key => $view)
				{
					if($view == $this->diafan->module.".view.first_page.php")
						continue;
					echo '<option value="'.$key.'"'.($this->values["view_first_page"] == $key ? ' selected' : '').'>'.$view.'</option>';
				}
				echo '
				</select>
				'.$this->show_help_row("theme_first_page").'
			</td>
		</tr>

		<tr>
			<td class="td_first">
				'.$this->variable_names("theme_id").'
			</td>
			<td>
				<select name="theme_id">
					<option value="">site.php</option>';
				foreach ($themes as $theme)
				{
					echo '<option value="'.$theme.'"'.($this->values["theme_id"] == $theme ? ' selected' : '').'>'.$theme.'</option>';
				}
				echo '
				</select>
				<select name="view_id">
					<option value="">'.$this->diafan->module.'.view.id.php</option>';
				foreach ($views as $key => $view)
				{
					if($view == $this->diafan->module.".view.id.php")
						continue;
					echo '<option value="'.$key.'"'.($this->values["view_id"] == $key ? ' selected' : '').'>'.$view.'</option>';
				}
				echo '
				</select>
				'.$this->show_help_row("theme_id").'
			</td>
		</tr>
		
		<tr>
			<td class="td_first">
				'.$this->variable_names("theme_list_param").'
			</td>
			<td>
				<select name="theme_list_search">
					<option value="">site.php</option>';
				foreach ($themes as $theme)
				{
					echo '<option value="'.$theme.'"'.($this->values["theme_list_param"] == $theme ? ' selected' : '').'>'.$theme.'</option>';
				}
				echo '
				</select>
				<select name="view_list_param">
					<option value="">'.$this->diafan->module.'.view.list.php</option>';
				foreach ($views as $key => $view)
				{
					if($view == $this->diafan->module.".view.list.php")
						continue;
					echo '<option value="'.$key.'"'.($this->values["view_list_param"] == $key ? ' selected' : '').'>'.$view.'</option>';
				}
				echo '
				</select>
				'.$this->show_help_row("theme_list_param").'
			</td>
		</tr>
		
		<tr>
			<td class="td_first">
				'.$this->variable_names("theme_list_search").'
			</td>
			<td>
				<select name="theme_list_search">
					<option value="">site.php</option>';
				foreach ($themes as $theme)
				{
					echo '<option value="'.$theme.'"'.($this->values["theme_list_search"] == $theme ? ' selected' : '').'>'.$theme.'</option>';
				}
				echo '
				</select>
				<select name="view_list_search">
					<option value="">'.$this->diafan->module.'.view.list.php</option>';
				foreach ($views as $key => $view)
				{
					if($view == $this->diafan->module.".view.list.php")
						continue;
					echo '<option value="'.$key.'"'.($this->values["view_list_search"] == $key ? ' selected' : '').'>'.$view.'</option>';
				}
				echo '
				</select>
				'.$this->show_help_row("theme_list_search").'
			</td>
		</tr>
		
		<tr>
			<td class="td_first">
				'.$this->variable_names("theme_list_compare").'
			</td>
			<td>
				<select name="theme_list_compare">
					<option value="">site.php</option>';
				foreach ($themes as $theme)
				{
					echo '<option value="'.$theme.'"'.($this->values["theme_list_compare"] == $theme ? ' selected' : '').'>'.$theme.'</option>';
				}
				echo '
				</select>
				<select name="view_list_compare">
					<option value="">'.$this->diafan->module.'.view.compare.php</option>';
				foreach ($views as $key => $view)
				{
					if($view == $this->diafan->module.".view.list_compare.php")
						continue;
					echo '<option value="'.$key.'"'.($this->values["view_list_compare"] == $key ? ' selected' : '').'>'.$view.'</option>';
				}
				echo '
				</select>
				'.$this->show_help_row("theme_list_compare").'
			</td>
		</tr>';

		return TRUE;
	}

	/**
	 * Сохранение поля "Валюта"
     * 
	 * @return boolean true
	 */
	protected function save_currency_module_config()
	{
		$this->query[] = "currency='%s'";
		$this->value[] = $_POST["currency"];

		return TRUE;
	}
}