<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Shop_admin_discount
 *
 * Скидки
 */
class Shop_admin_discount extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file = 'shopdiscount';

	/**
	 * @var string таблица в базе данных
	 */
	public $table = 'shop_discount';

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;
		
		//поля в базе данных для редактирования
		$this->variable_table = array(
			'main' => array(
				'discount' => 'floattext',
				'deduction' => 'floattext',
				'act' => 'checkbox',
				'hr2' => 'hr',
				'amount' => 'floattext',
				'threshold' => 'numtext',
				'user_id' => 'numtext',
				'coupon' => 'text',
				'count_use' => 'numtext',
				'hr3' => 'hr',
				'role_id' => 'select',
				'date' => 'function',
				'object' => 'function'
			)
		);
		
		$this->config_module = array(
			'act'   => 1, //показать/скрыть
			'del'   => 1, //удалить
			'trash' => 1  //использовать корзину
		);

		//выводить в списке содержание полей:
		$this->config_other_row = array(
			'date_start'
		);
        
		if($this->diafan->edit)
		{
			$result = DB::query("SELECT id, name from {users_role}");
			$this->select_arr["role_id"][0]=_LANG_ALL;
			while($row = DB::fetch_array($result)) 
			{
				$this->select_arr["role_id"][$row['id']] = $row['name'];
			}
		}
	}

	/**
	 * Выводит список заказов
	 * @return boolean true
	 */
	public function show_module()
	{
		$result["date_start"]  = '';
		if (! empty($_GET["date_start"]))
		{
			$date_start = $this->diafan->unixdate($_GET["date_start"]);
			$result["date_start"] = date('d.m.Y H:i', $date_start);
			$this->get_nav = ($this->get_nav ? '&' : '?').'date_start='.$result["date_start"];
		}
		$result["date_finish"] = '';
		if (! empty($_GET["date_finish"]))
		{
			$date_finish = $this->diafan->unixdate($_GET["date_finish"]);
			$result["date_finish"] = date('d.m.Y H:i', $date_finish);
			$this->get_nav .= ($this->get_nav ? '&' : '?').'date_finish='.$result["date_finish"];
		}
		if (! empty($date_start) && ! empty($date_finish))
		{
			$this->where .= " AND ((date_start <= '".$date_start."' OR date_start = '0') AND (date_finish >= '".$date_start."' OR date_finish = '0')"
			." OR date_start >= '".$date_start."' AND date_start <= '".$date_finish."')";
		}
		elseif (! empty($date_start))
		{
			$this->where = " AND (date_start<='".$date_start."' OR date_start='0') AND (date_finish>='".$date_start."' OR date_finish='0')";
		}
		elseif (! empty($date_finish))
		{
			$this->where = " AND (date_start<='".$date_finish."' OR date_start='0') AND (date_finish>='".$date_finish."' OR date_finish='0')";
		}
		echo '<table border="0" style="width:100%"><tr><td></td><td align="right">
		
		

		<form action="" method="GET">
		'._ADMIN_CREATED.': <input type="text" name="date_start" value="'.$result["date_start"].'" class="timecalendar"> - 
		<input type="text" name="date_finish" value="'.$result["date_finish"].'" class="timecalendar">
		<input type="submit" value="'._LANG_SEARCH.'">
		</form></td></tr></table>';
		
		$this->name = "date_finish, CONCAT(e.discount, ' %')";
		
		$this->addnew_init(_ADMIN_SHOP_ADD_DISCOUNT);

		$this->list_row();

		return true;
	}

	/**
	 * Выводит период действия скидки в списке
	 * @return string
	 */
	protected function other_row_date_start($row)
	{
		if ($row["date_start"] && $row["date_finish"])
		{
			return '</td><td class="date_discount">'.date("d.m.Y H:i", $row["date_start"]).' - '.date("d.m.Y H:i", $row["date_finish"]);
		}
		elseif ($row["date_start"])
		{
			return '</td><td class="date_discount">'._LANG_FROM.' '.date("d.m.Y H:i", $row["date_start"]);
		}
		elseif ($row["date_finish"])
		{
			return '</td><td class="date_discount">'._LANG_TO.' '.date("d.m.Y H:i", $row["date_finish"]);
		}
		else
		{
			return '</td><td>';
		}
	}

	/**
	 * Редактирование поля "Период действия"
	 * @return boolean true
	 */
	protected function edit_date_module()
	{
		echo '
		<tr>
			<td class="td_first">
				'.$this->variable_names().'
			</td>
			<td>
				<input type="text" name="date_start" size="20" value="'
				.(! empty($this->values["date_start"]) ? date("d.m.Y H:i", $this->values["date_start"]) : '')
				.'" class="timecalendar">
				-
				<input type="text" name="date_finish" size="20" value="'
				.(! empty($this->values["date_finish"]) ? date("d.m.Y H:i", $this->values["date_finish"]) : '')
				.'" class="timecalendar">
				'.$this->show_help_row().'
			</td>
		</tr>';

		return true;
	}

	/**
	 * Редактирование поля "Объект"
	 * @return boolean true
	 */
	protected function edit_object_module()
	{
		$marker = "&nbsp;&nbsp;";
		$result = DB::query("SELECT id, name, parent_id FROM {shop_category} WHERE trash='0' ORDER BY id ASC");
		while ($row = DB::fetch_array($result))
		{
			$cats[$row["parent_id"]][] = $row;
		}

		$values = array();
		if (! $this->diafan->addnew)
		{
			$result = DB::query("SELECT cat_id FROM {shop_discount_object} WHERE discount_id='%d' AND cat_id>0", $this->diafan->edit);
			while ($row = DB::fetch_array($result))
			{
				$values[] = $row["cat_id"];
			}
		}
		Customization::inc('modules/shop/admin/shop.admin.view.php');

		echo '
		<tr valign="top">
			<td class="td_first">
				'.$this->variable_names("cat_id").'
			</td>
			<td>
				<select name="cat_ids[]" multiple="multiple">'
				.$this->get_options($cats, $cats[0], $values).'
				</select>
			</td>
		</tr>
		<script type="text/javascript" src="'.BASE_PATH.'modules/shop/admin/shop.admin.discount.js"></script>
		<tr valign="top">
			<td class="td_first">
				'.$this->variable_names("good_id").'
			</td>
			<td>
				<div class="rel_goods">';
				if (! $this->diafan->addnew)
				{
					echo Shop_admin_view::discount_goods($this, $this->diafan->edit);
				}
				echo '</div>
				<a href="javascript:void(0)" class="rel_shop_plus" title="'._LANG_ADD.'"><img src="'.BASE_PATH.'adm/img/add.png" width="16" height="16" alt="'._LANG_ADD.'"></a>
				<div class="hide" id="rel_shop_container"></div>
			</td>
		</tr>';

		return true;
	}

	/**
	 * Редактирование поля "Код купона"
	 * @return boolean true
	 */
	protected function edit_coupon_module()
	{
		if(! empty($this->values["user_id"]))
		{
			echo '
			<tr>
				<td></td>
				<td><a href="'.BASE_PATH.ADMIN_FOLDER.'/users/edit'.$this->values["user_id"].'/">'.DB::query_result("SELECT concat(fio,' (',name,')') FROM {users} WHERE id=%d", $this->values["user_id"]).'</a></td>
			</tr>';
		}
		echo '
		<tr>
			<td class="td_first">
				'.$this->variable_names().'
			</td>
			<td>
				<input type="text" name="coupon" size="20" value="'.$this->value.'" class="inpnum">
				<a href="#" id="couon_generate">'._ADMIN_SHOPDISCOUNT_COUPON_GENERATE.'</a>
				'.$this->show_help_row().'
			</td>
		</tr>';

		return true;
	}

	/**
	 * Сохранение поля "Период действия"
	 * @return boolean true
	 */
	protected function save_date_module()
	{
		$date_start = ! empty($_POST["date_start"]) ? $this->diafan->unixdate($_POST["date_start"]) : 0;
		$date_finish = ! empty($_POST["date_finish"]) ? $this->diafan->unixdate($_POST["date_finish"]) : 0;
		if ($date_finish && $date_finish < $date_start)
		{
			$date = $date_finish;
			$date_finish = $date_start;
			$date_start = $date;
		}

		$this->query[] = "date_start='%d'";
		$this->value[] = $date_start;

		$this->query[] = "date_finish='%d'";
		$this->value[] = $date_finish;

		return true;
	}

	/**
	 * Сохранение поля "Объект"
	 * @return boolean true
	 */
	protected function save_object_module()
	{
		DB::query("DELETE FROM {shop_discount_object} WHERE discount_id=%d AND good_id=0", $this->diafan->save);

		if (! empty($_POST["cat_ids"]))
		{
			foreach ($_POST["cat_ids"] as $id)
			{
				DB::query("INSERT INTO {shop_discount_object} (discount_id, cat_id) VALUES (%d, %d)", $this->diafan->save, $id);
			}
		}
		elseif (! DB::query_result("SELECT COUNT(*) FROM {shop_discount_object} WHERE discount_id=%d", $this->diafan->save))
		{
			DB::query("INSERT INTO {shop_discount_object} (discount_id) VALUES (%d)", $this->diafan->save);
		}
		DB::query("UPDATE {shop_discount} SET act='%d' WHERE id=%d", ! empty($_POST["act"]) ? '1' : '0', $this->diafan->save);
		$this->diafan->_shop->price_calc(0, $this->diafan->save);
		return true;
	}

	/**
	 * Сопутствующие действия при удалении элемента модуля
	 * @return boolean true
	 */
	protected function delete($del_id, $trash_id)
	{
		$this->del_or_trash_where("shop_discount_object", "discount_id=".$del_id, $trash_id);
		$this->del_or_trash_where("shop_price", "discount_id=".$del_id, $trash_id);

		return true;
	}
}