<?php

/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */
if ( ! defined('DIAFAN'))
{
    include dirname(dirname(dirname(__FILE__))) . '/includes/404.php';
}

define('SHOP_IMPORT_PUBLIC_ALL', 1);
define('SHOP_IMPORT_HIDE_ALL', 2);
define('SHOP_IMPORT_REMOVE_ALL', 3);

/**
 * Shop_admin_import_element
 *
 * Редактирование сообщений
 */
class Shop_admin_import_element extends Frame_admin
{

    /**
     * @var string название файла. используется в имени констант, определяющих названия полей
     */
    public $file = 'shopimport';

    /**
     * @var string таблица в базе данных
     */
    public $table = 'shop_import';

    /**
     * Конструктор класса
     * 
     * @return void
     */
    public function __construct($diafan)
    {
        $this->diafan = $diafan;

        $this->diafan->nastr = 30;

        //поля в базе данных для редактирования
        $this->variable_table = array('main' =>
            array(
                'name' => 'text',
                'type' => 'select',
                'param_id' => 'select',
                'cat_id' => 'select',
                'js' => 'function',
            ),
            'other_rows' =>
            array(
            )
        );

        $this->config_module = array(
            'del' => 1, //удалить
            'element' => 1, //используются группы
            'trash' => 1, //использовать корзину
            'order' => 1, //сортируется
            'category_flat' => 1
        );

        $this->select["param_id"] = array(
            "shop_param",
            "id",
            "name",
            "",
            "-"
        );

        $this->select["cat_id"] = array(
            "shop_import_category",
            "id",
            "name",
            "",
            "-"
        );

        $this->select_arr["type"] = array(
            "id" => _ADMIN_SHOP_IMPORT_ID,
            "name" => _ADMIN_SHOP_IMPORT_NAME,
            "article" => _ADMIN_SHOP_IMPORT_ARTICLE,
            "anons" => _ADMIN_SHOP_IMPORT_ANONS,
            "text" => _ADMIN_SHOP_IMPORT_TEXT,
            "price" => _ADMIN_SHOP_IMPORT_PRICE,
            "count" => _ADMIN_SHOP_IMPORT_COUNT,
            "cats" => _ADMIN_SHOP_IMPORT_CATS,
            "empty" => _ADMIN_SHOP_IMPORT_EMPTY,
            "parent" => _ADMIN_SHOP_IMPORT_PARENT,
            "param" => _ADMIN_SHOP_IMPORT_PARAM,
            "image" => _ADMIN_SHOP_IMPORT_IMAGE,
            "rel_goods" => _ADMIN_SHOP_IMPORT_REL_GOODS,
            "no_buy" => _ADMIN_SHOP_IMPORT_NO_BUY,
            "act" => _ADMIN_SHOP_IMPORT_ACT,
            "menu_id" => _ADMIN_SHOP_IMPORT_SHOW_IN_MENU,
            "hit" => _ADMIN_SHOP_IMPORT_HIT,
            "new" => _ADMIN_SHOP_IMPORT_NEW,
            "action" => _ADMIN_SHOP_IMPORT_ACTION,
            "is_file" => _ADMIN_SHOP_IMPORT_IS_FILE,
            "access" => _ADMIN_SHOP_IMPORT_ACCESS,
            "map_no_show" => _ADMIN_SHOP_IMPORT_MAP_NO_SHOW,
            "show_yandex" => _ADMIN_SHOP_IMPORT_SHOW_YANDEX,
            "yandex" => _ADMIN_SHOP_IMPORT_YANDEX
        );
    }

    /**
     * Выводит список сообщений
     * @return boolean true
     */
    public function show_module()
    {
        if ( ! empty($_POST["upload"]) || ! empty($_GET["upload"]))
        {
            $this->upload();
        }
        elseif ( ! empty($_REQUEST['import_action']))//опереации с импортированными элементами
        {
            switch ($_REQUEST['import_action'])
            {
                case SHOP_IMPORT_PUBLIC_ALL:
                    $this->set_act_param(1);
                    break;

                case SHOP_IMPORT_HIDE_ALL:
                    $this->set_act_param(0);
                    break;

                case SHOP_IMPORT_REMOVE_ALL:
                    $this->remove_all();
                    break;
            }

            exit;
        }

        if (DB::query_result("SELECT COUNT(*) FROM {shop_import} WHERE cat_id=%d AND trash='0'", $this->diafan->cat))
        {
            echo '
			<div style="float: right;">
				<br>
				<form action="" enctype="multipart/form-data" method="post">
				<input type="hidden" name="upload" value="true">
				<input type="file" name="file">
				<input type="submit" value="' . _LANG_SEND . '">
				<p>' . _ADMIN_SHOP_IMPORT_ONLY_CSV . '</p>
				</form>
			</div>';
        }

        $this->addnew_init(_ADMIN_ADD_FIELD);

        $this->list_row($this->diafan->cat);

        echo '
        <script type="text/javascript" src="' . BASE_PATH . 'modules/shop/shop.import.js"></script>
        <form class="ajax" method="post">
        <input type="hidden" value="0" name="ajax">
        <input type="hidden" value="0" name="import_action">
            <table>
            <tbody>
            <tr>
                <td><input type="submit" class="button shop_import_button" rel="' . SHOP_IMPORT_PUBLIC_ALL . '" value="'
        . _ADMIN_SHOP_IMPORT_PUBLIC_ALL . '" > &nbsp;</td> 
                <td><input type="submit" class="button shop_import_button" rel="' . SHOP_IMPORT_HIDE_ALL . '" value="'
        . _ADMIN_SHOP_IMPORT_HIDE_ALL . '" > &nbsp;</td> 
                <td><input type="submit" class="button shop_import_button" rel="' . SHOP_IMPORT_REMOVE_ALL . '" value="'
        . _ADMIN_SHOP_IMPORT_REMOVE_ALL . '" ></td>
            </tr>
            </tbody>
            </table>
        </form>';

        return true;
    }

    /**
     * Загружает файл импорта
     * @return boolean true
     */
    private function upload()
    {
        if (isset($_FILES["file"]) && is_array($_FILES["file"]) && $_FILES["file"]['name'] != '')
        {
            move_uploaded_file($_FILES["file"]['tmp_name'], ABSOLUTE_PATH . USERFILES . '/tmp');
            echo '<meta http-equiv="Refresh" content="0; url=' . URL . '?ftell=0&amp;upload=true">';
            exit;
        }
        elseif ( ! file_exists(ABSOLUTE_PATH . USERFILES . '/tmp'))
        {
            $this->diafan->redirect_js(URL);
            exit;
        }

        Customization::inc("includes/image.php");

        // количество строк, выгружаемых за один проход скрипта
        $count_part = 200;
        // разделитель данных в строке
        $delimiter = ";";
        // кодировка: cp1251, utf-8
        $encoding = 'cp1251';
        // разделитель данных внутри поля
        $sub_delimiter = "|";

        //$import -  конфигурация текущего импорта
        $import = DB::fetch_array(DB::query("SELECT * FROM {shop_import_category} WHERE id=%d", $this->diafan->cat));

        //$params - характеристики товара в магазине
        //$req_fileds - поля, заданные для текущего импорта
        list($params, $req_fileds) = $this->get_params_and_req_fileds();

        if ( ! empty($req_fileds)) //в данном импорте есть поля
        {
            if (empty($_GET['ftell']))
            {
                if ($import["type"] == 'category')
                {
                    DB::query("ALTER TABLE {shop_category} ADD `import_parent_id` VARCHAR( 32 ) NOT NULL AFTER `import_id`");
                }
                if ($import["type"] == 'good' && isset($req_fileds["id"]))
                {
                    $this->prepare_before_set_relations_between_items($req_fileds);
                }
            }

            if ($import["delete_items"] && empty($_GET['ftell']))//Удалить неописанные в файле импорта записи, при первом вызове скрипта, если это нужно
            {
                if ( ! isset($req_fileds["id"]))//не задано поле для идентификатора товара  
                {
                    //удаляем все товары или категории из магазина
                    $this->delete_items_before_parsing($import);
                }
                else//если в импорте ЗАДАНО поле для идентификатора товара
                {
                    // включаем режим обновления
                    if ($import["type"] == 'good')
                    {
                        DB::query("UPDATE {shop} SET `import`='0'");
                    }
                    else
                    {
                        DB::query("UPDATE {shop_category} SET `import`='0'");
                    }
                }
            }

            $handle = fopen(ABSOLUTE_PATH . USERFILES . '/tmp', "r");
            if (isset($_GET['ftell']))
            {
                fseek($handle, $_GET['ftell']);
            }
            $i = 0;
            $cache = array();
            // построчное считывание и анализ строк из файла
            while (($data_f = fgets($handle)) !== false)
            {
                if ($encoding == 'cp1251')
                {
                    $data_f = utf::to_utf($data_f);
                }

                $data = $this->prepare_data($delimiter, $data_f, $req_fileds);

                if ( ! isset($req_fileds["id"]))//поле для идентификатора записи не задано
                {
                    $id = $this->insert_new_row1($import, $req_fileds, $data);
                }
                else
                {
                    //существует ли элемент для обновления
                    if ($id = DB::query_result("SELECT id FROM {shop" . ($import["type"] == 'category' ? "_category" : "")
                                    . "} WHERE import_id='%s'AND trash='0'", $data[$req_fileds["id"]]))
                    {
                        $this->update_row($import, $req_fileds, $data, $id);
                    }
                    else//
                    {
                        $id = $this->insert_new_row($import, $req_fileds, $data);
                    }
                }
                if ($import["type"] == 'good')
                {
                    $this->set_price($req_fileds, $data, $id); //устанавливаем цену

                    $this->set_catetegory_relationship($req_fileds, $data, $cache, $id);

                    $this->set_params($params, $data, $id);

                    $this->upload_all_images($req_fileds, $data, $id, $sub_delimiter, $import['image_directory']);

                    $this->set_relations_between_items($req_fileds, $data, $sub_delimiter);
                }

                if ($i == $count_part)
                {
                    echo '<meta http-equiv="Refresh" content="0; url=' . URL . '?ftell=' . ftell($handle) . '&amp;upload=true">';
                    exit;
                }

                $i ++;
            }
            fclose($handle);
            unlink(ABSOLUTE_PATH . USERFILES . '/tmp');

            $this->update_sort($import);

            if ($import["type"] == 'good' && isset($req_fileds["id"]))
            {
                $this->trim_after_set_relations_between_items($import, $req_fileds);
            }

            if (isset($req_fileds["id"]))
            {
                //Удалить неописанные в файле импорта записи, если это нужно
                $this->delete_items_after_parsing($import, $req_fileds, $cache);
            }

            if ($import["type"] == 'category')
            {
                DB::query("ALTER TABLE {shop_category} DROP `import_parent_id`");
            }

            if ($import["type"] == 'category' && ! empty($import["menu_id"]))
            {
                $this->show_in_menu($import['menu_id'], $import['site_id']);
            }

            $this->diafan->_cache->delete("", "shop");
        }

        $this->diafan->redirect_js(URL . 'error1/');
        
        exit;
    }

    /**
     * Выводит порядковый номер поля
     *
     * @param array $row информация о текущем элменте списка
     * @return string
     */
    protected function get_parent_name($row)
    {
        return '<td width="1%">' . (@$this->k - 1) . '.</td>';
    }

    /**
     * Редактирование поля "JS"
     * @return boolean true
     */
    protected function edit_js_module()
    {
        echo '<script type="text/javascript" src="' . BASE_PATH . 'modules/shop/admin/shop.admin.import.element.js"></script>';
        return true;
    }

    /**
     * Сохранение поля "JS"
     * @return boolean true
     */
    protected function save_js_module()
    {
        return true;
    }

    /**
     * Удаление старых записей в БД, если в импорте НЕ участвуют идентификаторы элементов
     *
     * @param array $import конфигурация импорта
     * @return void
     */
    protected function delete_items_before_parsing(&$import)
    {
        if ($import["type"] == 'good')
        {
            DB::query("DELETE FROM {shop_category_rel} WHERE element_id IN (SELECT id FROM {shop} WHERE site_id=%d)", $import["site_id"]);
            DB::query("DELETE FROM {shop_rel} WHERE good_id IN (SELECT id FROM {shop} WHERE site_id=%d)", $import["site_id"]);
            DB::query("DELETE FROM {shop_rel} WHERE rel_good_id IN (SELECT id FROM {shop} WHERE site_id=%d)", $import["site_id"]);
            DB::query("DELETE FROM {shop_price} WHERE good_id IN (SELECT id FROM {shop} WHERE site_id=%d)", $import["site_id"]);
            DB::query("DELETE FROM {shop_param_element} WHERE element_id IN (SELECT id FROM {shop} WHERE site_id=%d)", $import["site_id"]);
            DB::query("DELETE FROM {shop_discount_object} WHERE good_id IN (SELECT id FROM {shop} WHERE site_id=%d)", $import["site_id"]);
            $result = DB::query("SELECT * FROM {images} WHERE module_name='shop' AND element_id IN (SELECT id FROM {shop} WHERE site_id=%d)", $import["site_id"]);
            while ($row = DB::fetch_array($result))
            {
                unlink(ABSOLUTE_PATH . USERFILES . "/shop/" . $row["name"]);
                unlink(ABSOLUTE_PATH . USERFILES . "/shop/medium/" . $row["name"]);
                unlink(ABSOLUTE_PATH . USERFILES . "/shop/small/" . $row["name"]);
            }
            DB::query("DELETE FROM {images} WHERE module_name='shop' AND element_id IN (SELECT id FROM {shop} WHERE site_id=%d)", $import["site_id"]);

            DB::query("DELETE FROM {shop} WHERE site_id=%d", $import["site_id"]);
        }
        else
        {
            DB::query("DELETE FROM {shop_category_parents} WHERE element_id IN (SELECT id FROM {shop_category} WHERE site_id=%d)", $import["site_id"]);
            DB::query("DELETE FROM {shop_param_category_rel} WHERE cat_id IN (SELECT id FROM {shop_category} WHERE site_id=%d)", $import["site_id"]);
            DB::query("DELETE FROM {shop_category_rel} WHERE cat_id IN (SELECT id FROM {shop_category} WHERE site_id=%d)", $import["site_id"]);
            DB::query("DELETE FROM {shop_discount_object} WHERE cat_id IN (SELECT id FROM {shop_category} WHERE site_id=%d)", $import["site_id"]);
            DB::query("DELETE FROM {shop_category} WHERE site_id=%d", $import["site_id"]);
        }
    }

    /**
     * Удаление старых записей в БД, если в импорте участвуют идентификаторы элементов
     *
     * @param array $import конфигурация импорта
     * @param array $req_fileds массив типов полей, используемых в импорте
     * @param array $cache массив для хранения связей между категориями и товарами во время импорта
     * @return void
     */
    protected function delete_items_after_parsing(&$import, &$req_fileds, &$cache)
    {
        if ($import["type"] == 'good')
        {
            if ($import["delete_items"])
            {
                DB::query("DELETE FROM {shop_category_rel} WHERE element_id IN (SELECT id FROM {shop} WHERE `import`='0' AND site_id=%d)", $import["site_id"]);
                DB::query("DELETE FROM {shop_rel} WHERE good_id IN (SELECT id FROM {shop} WHERE `import`='0' AND site_id=%d)", $import["site_id"]);
                DB::query("DELETE FROM {shop_rel} WHERE rel_good_id IN (SELECT id FROM {shop} WHERE `import`='0' AND site_id=%d)", $import["site_id"]);
                DB::query("DELETE FROM {shop_price} WHERE good_id IN (SELECT id FROM {shop} WHERE `import`='0' AND site_id=%d)", $import["site_id"]);
                DB::query("DELETE FROM {shop_param_element} WHERE element_id IN (SELECT id FROM {shop} WHERE `import`='0' AND site_id=%d)", $import["site_id"]);
                DB::query("DELETE FROM {shop_discount_object} WHERE good_id IN (SELECT id FROM {shop} WHERE `import`='0' AND site_id=%d)", $import["site_id"]);
                $result = DB::query("SELECT * FROM {images} WHERE module_name='shop' AND element_id IN (SELECT id FROM {shop} WHERE `import`='0' AND site_id=%d)", $import["site_id"]);
                while ($row = DB::fetch_array($result))
                {
                    unlink(ABSOLUTE_PATH . USERFILES . "/shop/" . $row["name"]);
                    unlink(ABSOLUTE_PATH . USERFILES . "/shop/medium/" . $row["name"]);
                    unlink(ABSOLUTE_PATH . USERFILES . "/shop/small/" . $row["name"]);
                }
                DB::query("DELETE FROM {images} WHERE module_name='shop' AND element_id IN (SELECT id FROM {shop} WHERE `import`='0' AND site_id=%d)", $import["site_id"]);

                DB::query("DELETE FROM {shop} WHERE `import`='0' AND site_id=%d", $import["site_id"]);
            }
        }
        else
        {
            if ($import["delete_items"])
            {
                DB::query("DELETE FROM {shop_category_parents} WHERE element_id IN (SELECT id FROM {shop_category} WHERE `import`='0' AND site_id=%d)", $import["site_id"]);
                DB::query("DELETE FROM {shop_param_category_rel} WHERE cat_id IN (SELECT id FROM {shop_category} WHERE `import`='0' AND site_id=%d)", $import["site_id"]);
                DB::query("DELETE FROM {shop_category_rel} WHERE cat_id IN (SELECT id FROM {shop_category} WHERE `import`='0' AND site_id=%d)", $import["site_id"]);
                DB::query("DELETE FROM {shop_discount_object} WHERE cat_id IN (SELECT id FROM {shop_category} WHERE `import`='0' AND site_id=%d)", $import["site_id"]);
                DB::query("DELETE FROM {shop_category} WHERE `import`='0' AND site_id=%d", $import["site_id"]);
            }
            if (isset($req_fileds["parent"]))
            {
                $result = DB::query("SELECT id, import_parent_id FROM {shop_category} WHERE `import`='1'");
                while ($row = DB::fetch_array($result))
                {
                    DB::query("DELETE FROM {shop_category_parents} WHERE element_id=%d", $row["id"]);
                    if ($row["import_parent_id"])
                    {
                        if ( ! isset($cache["cats"][$row["import_parent_id"]]))
                        {
                            $cache["cats"][$row["import_parent_id"]] =
                                    DB::query_result("SELECT id FROM {shop_category} WHERE import_id='%h' AND trash='0'", $row["import_parent_id"]);
                        }
                        $parent_id = $cache["cats"][$row["import_parent_id"]];
                        DB::query("UPDATE {shop_category} SET parent_id=%d WHERE id=%d", $parent_id, $row["id"]);
                        $parents = array();
                        while ($parent_id > 0 && ! in_array($parent_id, $parents))
                        {
                            $parents[] = $parent_id;
                            DB::query("INSERT INTO {shop_category_parents} (`element_id`, `parent_id`) VALUES (%d, %d)", $row["id"], $parent_id);
                            $parent_id = DB::query_result("SELECT parent_id FROM {shop_category} WHERE id=%d", $parent_id);
                        }
                    }
                }
                $result = DB::query("SELECT id FROM {shop_category}");
                while ($row = DB::fetch_array($result))
                {
                    $count = DB::query_result("SELECT COUNT(*) FROM  {shop_category_parents} WHERE parent_id=%d", $row["id"]);
                    DB::query("UPDATE {shop_category} SET count_children=%d WHERE id=%d", $count, $row["id"]);
                }
            }
        }
    }

    /**
     * Добавление записи в БД, если в импорте участвуют идентификаторы элементов
     *
     * @param array $import конфигурация импорта
     * @param array $req_fileds массив типов полей, используемых в импорте
     * @param array $data массив данных для импортирования

     * @return void
     */
    protected function insert_new_row(&$import, &$req_fileds, &$data)
    {
        DB::query("INSERT INTO {shop" . ($import["type"] == 'category' ? "_category" : "") . "} ( import, import_id, site_id, [act]"
                . (isset($req_fileds["name"]) ? ", [name]" : "")
                . (isset($req_fileds["article"]) ? ", article" : "")
                . (isset($req_fileds["anons"]) ? ", [anons]" : "")
                . (isset($req_fileds["text"]) ? ", [text]" : "")
                . (isset($req_fileds["parent"]) && $import["type"] == 'category' ? ", import_parent_id" : "")
                . (isset($req_fileds["menu_id"]) && $import["type"] == 'category' ? ", import_show_in_menu" : "")
                . (isset($req_fileds["no_buy"]) && $import["type"] == 'good' ? ", no_buy" : "")
                . (isset($req_fileds["hit"]) && $import["type"] == 'good' ? ", hit" : "")
                . (isset($req_fileds["new"]) && $import["type"] == 'good' ? ", new" : "")
                . (isset($req_fileds["action"]) && $import["type"] == 'good' ? ", action" : "")
                . (isset($req_fileds["is_file"]) && $import["type"] == 'good' ? ", is_file" : "")
                . (isset($req_fileds["show_yandex"]) && $import["type"] == 'good' ? ", show_yandex" : "")
                . (isset($req_fileds["map_no_show"]) ? ", map_no_show" : "")
                . (isset($req_fileds["access"]) ? ", access" : "")
                . (isset($req_fileds["yandex"]) && $import["type"] == 'good' ? ", yandex" : "")
                . ") VALUES ('1', '" . $data[$req_fileds["id"]] . "', '" . $import["site_id"] . "'"
                . (isset($req_fileds["act"]) ? ", '" . ( ! empty($data[$req_fileds["act"]]) ? trim($data[$req_fileds["act"]]) : '0') . "'" : ", '0'")
                . (isset($req_fileds["name"]) ? ", '" . ( ! empty($data[$req_fileds["name"]]) ? trim($data[$req_fileds["name"]]) : '') . "'" : "")
                . (isset($req_fileds["article"]) ? ", '" . ( ! empty($data[$req_fileds["article"]]) ? trim($data[$req_fileds["article"]]) : '') . "'" : "")
                . (isset($req_fileds["anons"]) ? ", '" . ( ! empty($data[$req_fileds["anons"]]) ? trim($data[$req_fileds["anons"]]) : '') . "'" : "")
                . (isset($req_fileds["text"]) ? ", '" . ( ! empty($data[$req_fileds["text"]]) ? trim($data[$req_fileds["text"]]) : '') . "'" : "")
                . (isset($req_fileds["parent"]) && $import["type"] == 'category' ? ", '" . ( ! empty($data[$req_fileds["parent"]]) ? trim($data[$req_fileds["parent"]]) : '') . "'" : "")
                . (isset($req_fileds["menu_id"]) && $import["type"] == 'category' ? ", '" . ( ! empty($data[$req_fileds["menu_id"]]) ? trim($data[$req_fileds["menu_id"]]) : '') . "'" : "")
                . (isset($req_fileds["no_buy"]) && $import["type"] == 'good' ? ", '" . ( ! empty($data[$req_fileds["no_buy"]]) ? trim($data[$req_fileds["no_buy"]]) : '0') . "'" : "")
                . (isset($req_fileds["hit"]) && $import["type"] == 'good' ? ", '" . ( ! empty($data[$req_fileds["hit"]]) ? trim($data[$req_fileds["hit"]]) : '10') . "'" : "")
                . (isset($req_fileds["new"]) && $import["type"] == 'good' ? ", '" . ( ! empty($data[$req_fileds["new"]]) ? trim($data[$req_fileds["new"]]) : '20') . "'" : "")
                . (isset($req_fileds["action"]) && $import["type"] == 'good' ? ", '" . ( ! empty($data[$req_fileds["action"]]) ? trim($data[$req_fileds["action"]]) : '30') . "'" : "")
                . (isset($req_fileds["is_file"]) && $import["type"] == 'good' ? ", '" . ( ! empty($data[$req_fileds["is_file"]]) ? trim($data[$req_fileds["is_file"]]) : '40') . "'" : "")
                . (isset($req_fileds["show_yandex"]) && $import["type"] == 'good' ? ", '" . ( ! empty($data[$req_fileds["show_yandex"]]) ? trim($data[$req_fileds["show_yandex"]]) : '50') . "'" : "")
                . (isset($req_fileds["map_no_show"]) ? ", '" . ( ! empty($data[$req_fileds["map_no_show"]]) ? trim($data[$req_fileds["map_no_show"]]) : '60') . "'" : "")
                . (isset($req_fileds["access"]) ? ", '" . ( ! empty($data[$req_fileds["access"]]) ? trim($data[$req_fileds["access"]]) : '70') . "'" : "")
                . (isset($req_fileds["yandex"]) && $import["type"] == 'good' ? ", '" . ( ! empty($data[$req_fileds["yandex"]]) ? trim($data[$req_fileds["yandex"]]) : '') . "'" : "")
                . ")");

        $id = DB::last_id("shop");
        return $id;
    }

    /**
     * Добавление записи в БД, если в импорте НЕ участвуют идентификаторы элементов
     *
     * @param array $import конфигурация импорта
     * @param array $req_fileds массив типов полей, используемых в импорте
     * @param array $data массив данных для импортирования

     * @return void
     */
    protected function insert_new_row1(&$import, &$req_fileds, &$data)
    {
        DB::query("INSERT INTO {shop" . ($import["type"] == 'category' ? "_category" : "") . "} (site_id, act"
                . (isset($req_fileds["name"]) ? ", [name]" : "")
                . (isset($req_fileds["article"]) ? ", article" : "")
                . (isset($req_fileds["anons"]) ? ", [anons]" : "")
                . (isset($req_fileds["text"]) ? ", [text]" : "")
                . (isset($req_fileds["parent"]) && $import["type"] == 'category' ? ", import_parent_id" : "")
                . (isset($req_fileds["menu_id"]) && $import["type"] == 'category' ? ", import_show_in_menu" : "")
                . (isset($req_fileds["no_buy"]) && $import["type"] == 'good' ? ", no_buy" : "")
                . (isset($req_fileds["hit"]) && $import["type"] == 'good' ? ", hit" : "")
                . (isset($req_fileds["new"]) && $import["type"] == 'good' ? ", new" : "")
                . (isset($req_fileds["action"]) && $import["type"] == 'good' ? ", action" : "")
                . (isset($req_fileds["is_file"]) && $import["type"] == 'good' ? ", is_file" : "")
                . (isset($req_fileds["show_yandex"]) && $import["type"] == 'good' ? ", show_yandex" : "")
                . (isset($req_fileds["map_no_show"]) ? ", map_no_show" : "")
                . (isset($req_fileds["access"]) ? ", access" : "")
                . (isset($req_fileds["yandex"]) && $import["type"] == 'good' ? ", yandex" : "")
                . ") VALUES ('" . $import["site_id"] . "'"
                . (isset($req_fileds["act"]) ? ", '" . ( ! empty($data[$req_fileds["act"]]) ? trim($data[$req_fileds["act"]]) : '0') . "'" : ", '0'")
                . (isset($req_fileds["name"]) ? ", '" . ( ! empty($data[$req_fileds["name"]]) ? trim($data[$req_fileds["name"]]) : '') . "'" : "")
                . (isset($req_fileds["article"]) ? ", '" . ( ! empty($data[$req_fileds["article"]]) ? trim($data[$req_fileds["article"]]) : '') . "'" : "")
                . (isset($req_fileds["anons"]) ? ", '" . ( ! empty($data[$req_fileds["anons"]]) ? trim($data[$req_fileds["anons"]]) : '') . "'" : "")
                . (isset($req_fileds["text"]) ? ", '" . ( ! empty($data[$req_fileds["text"]]) ? trim($data[$req_fileds["text"]]) : '') . "'" : "")
                . (isset($req_fileds["parent"]) && $import["type"] == 'category' ? ", '" . ( ! empty($data[$req_fileds["parent"]]) ? trim($data[$req_fileds["parent"]]) : '') . "'" : "")
                . (isset($req_fileds["menu_id"]) && $import["type"] == 'category' ? ", '" . ( ! empty($data[$req_fileds["menu_id"]]) ? trim($data[$req_fileds["menu_id"]]) : '') . "'" : "")
                . (isset($req_fileds["no_buy"]) && $import["type"] == 'good' ? ", '" . ( ! empty($data[$req_fileds["no_buy"]]) ? trim($data[$req_fileds["no_buy"]]) : '0') . "'" : "")
                . (isset($req_fileds["hit"]) && $import["type"] == 'good' ? ", '" . ( ! empty($data[$req_fileds["hit"]]) ? trim($data[$req_fileds["hit"]]) : '0') . "'" : "")
                . (isset($req_fileds["new"]) && $import["type"] == 'good' ? ", '" . ( ! empty($data[$req_fileds["new"]]) ? trim($data[$req_fileds["new"]]) : '0') . "'" : "")
                . (isset($req_fileds["action"]) && $import["type"] == 'good' ? ", '" . ( ! empty($data[$req_fileds["action"]]) ? trim($data[$req_fileds["action"]]) : '0') . "'" : "")
                . (isset($req_fileds["is_file"]) && $import["type"] == 'good' ? ", '" . ( ! empty($data[$req_fileds["is_file"]]) ? trim($data[$req_fileds["is_file"]]) : '0') . "'" : "")
                . (isset($req_fileds["show_yandex"]) && $import["type"] == 'good' ? ", '" . ( ! empty($data[$req_fileds["show_yandex"]]) ? trim($data[$req_fileds["show_yandex"]]) : '0') . "'" : "")
                . (isset($req_fileds["map_no_show"]) ? ", '" . ( ! empty($data[$req_fileds["map_no_show"]]) ? trim($data[$req_fileds["map_no_show"]]) : '0') . "'" : "")
                . (isset($req_fileds["access"]) ? ", '" . ( ! empty($data[$req_fileds["access"]]) ? trim($data[$req_fileds["access"]]) : '0') . "'" : "")
                . (isset($req_fileds["yandex"]) && $import["type"] == 'good' ? ", '" . ( ! empty($data[$req_fileds["yandex"]]) ? trim($data[$req_fileds["yandex"]]) : '') . "'" : "")
                . ")");
        $id = DB::last_id("shop");

        return $id;
    }

    /**
     * Обновляем записи в БД для существующего элемента
     *
     * @param array $import конфигурация импорта
     * @param array $req_fileds массив типов полей, используемых в импорте
     * @param array $data массив данных для импортирования
     * @param int $id идентификатор элемента
     * 
     * @return void
     */
    protected function update_row(&$import, &$req_fileds, &$data, $id)
    {
        DB::query("UPDATE {shop" . ($import["type"] == 'category' ? "_category" : "") . "} SET import='1', site_id='" . $import["site_id"] . "'"
                . (isset($req_fileds["name"]) ? ", [name]='" . ( ! empty($data[$req_fileds["name"]]) ? trim($data[$req_fileds["name"]]) : '') . "'" : "")
                . (isset($req_fileds["article"]) ? ", article='" . ( ! empty($data[$req_fileds["article"]]) ? trim($data[$req_fileds["article"]]) : '') . "'" : "")
                . (isset($req_fileds["anons"]) ? ", [anons]='" . ( ! empty($data[$req_fileds["anons"]]) ? trim($data[$req_fileds["anons"]]) : '') . "'" : "")
                . (isset($req_fileds["text"]) ? ", [text]='" . ( ! empty($data[$req_fileds["text"]]) ? trim($data[$req_fileds["text"]]) : '') . "'" : "")
                . (isset($req_fileds["parent"]) && $import["type"] == 'category' ? ", import_parent_id='" . ( ! empty($data[$req_fileds["parent"]]) ? trim($data[$req_fileds["parent"]]) : '') . "'" : "")
                . (isset($req_fileds["menu_id"]) && $import["type"] == 'category' ? ", import_show_in_menu='" . ( ! empty($data[$req_fileds["menu_id"]]) ? trim($data[$req_fileds["menu_id"]]) : '0') . "'" : "")
                . (isset($req_fileds["no_buy"]) && $import["type"] == 'good' ? ", no_buy='" . ( ! empty($data[$req_fileds["no_buy"]]) ? trim($data[$req_fileds["no_buy"]]) : '0') . "'" : "")
                . (isset($req_fileds["act"]) ? ", [act]='" . ( ! empty($data[$req_fileds["act"]]) ? trim($data[$req_fileds["act"]]) : '0') . "'" : "")
                . (isset($req_fileds["hit"]) && $import["type"] == 'good' ? ",hit='" . ( ! empty($data[$req_fileds["hit"]]) ? trim($data[$req_fileds["hit"]]) : '0') . "'" : "")
                . (isset($req_fileds["new"]) && $import["type"] == 'good' ? ", new='" . ( ! empty($data[$req_fileds["new"]]) ? trim($data[$req_fileds["new"]]) : '0') . "'" : "")
                . (isset($req_fileds["action"]) && $import["type"] == 'good' ? ", action='" . ( ! empty($data[$req_fileds["action"]]) ? trim($data[$req_fileds["action"]]) : '0') . "'" : "")
                . (isset($req_fileds["is_file"]) && $import["type"] == 'good' ? ", is_file='" . ( ! empty($data[$req_fileds["is_file"]]) ? trim($data[$req_fileds["is_file"]]) : '0') . "'" : "")
                . (isset($req_fileds["show_yandex"]) && $import["type"] == 'good' ? ", show_yandex='" . ( ! empty($data[$req_fileds["show_yandex"]]) ? trim($data[$req_fileds["show_yandex"]]) : '0') . "'" : "")
                . (isset($req_fileds["map_no_show"]) ? ", map_no_show='" . ( ! empty($data[$req_fileds["map_no_show"]]) ? trim($data[$req_fileds["map_no_show"]]) : '0') . "'" : "")
                . (isset($req_fileds["access"]) ? ", access='" . ( ! empty($data[$req_fileds["access"]]) ? trim($data[$req_fileds["access"]]) : '0') . "'" : "")
                . (isset($req_fileds["yandex"]) ? ", yandex='" . ( ! empty($data[$req_fileds["yandex"]]) ? trim($data[$req_fileds["yandex"]]) : '') . "'" : "")
                . " WHERE id=%d", $id);
    }

    /**
     * Установка цены товара
     *
     * @param array $req_fileds массив типов полей, используемых в импорте
     * @param array $data массив данных для импортирования
     * @param int $id идентификатор товара
     * 
     * @return void
     */
    protected function set_price(&$req_fileds, &$data, $id)
    {
        if (isset($req_fileds["price"]) || isset($req_fileds["count"]))
        {
            if (isset($req_fileds["id"]))
            {
                DB::query("DELETE FROM {shop_price} WHERE good_id=%d", $id);
            }
            $price = isset($req_fileds["price"]) ? trim($data[$req_fileds["price"]]) : 0;
            $count = isset($req_fileds["count"]) ? trim($data[$req_fileds["count"]]) : 0;

            $this->diafan->_shop->price_insert($id, $price, $count);
        }
    }

    /**
     * Создание связей между товарами и категориями
     *
     * @param array $req_fileds массив типов полей, используемых в импорте
     * @param array $data массив данных для импортирования
     * @param array $cache массив для хранения связей между категориями и товарами во время импорта
     * @param int $id идентификатор товара
     * 
     * @return void
     */
    protected function set_catetegory_relationship(&$req_fileds, &$data, &$cache, $id)
    {
        if (isset($req_fileds["cats"]))
        {
            if (isset($req_fileds["id"]))
            {
                DB::query("DELETE FROM {shop_category_rel} WHERE element_id=%d", $id);
            }
            $cat_id = 0;
            if ( ! empty($data[$req_fileds["cats"]]))
            {
                $data[$req_fileds["cats"]] = trim($data[$req_fileds["cats"]]);
                if ( ! isset($cache["cats"][$data[$req_fileds["cats"]]]))
                {
                    $cache["cats"][$data[$req_fileds["cats"]]] =
                            DB::query_result("SELECT id FROM {shop_category} WHERE import_id='%h' AND trash='0'", $data[$req_fileds["cats"]]);
                }
                $cat_id = $cache["cats"][$data[$req_fileds["cats"]]];
                DB::query("INSERT INTO {shop_category_rel} (element_id, cat_id) VALUES (%d, %d)", $id, $cat_id);
            }
            DB::query("UPDATE {shop} SET cat_id=%d WHERE id=%d", $cat_id, $id);
        }
    }

    /**
     * Прикрепление характеристик к товару
     *
     * @param array $params массив характеристик товаров, используемых в импорте
     * @param array $data массив данных для импортирования
     * @param int $id идентификатор товара, к которому прикрепляются характеристики
     * 
     * @return void
     */
    protected function set_params(&$params, &$data, $id)
    {
        foreach ($params as $k => $param)
        {
            if ( ! $param["id"])
                continue;
            $value = trim($data[$k]);
            if ($param["type"] == 'select' || $param["type"] == 'multiple')
            {
                $value = ! empty($param["values"][trim($data[$k])]) ? $param["values"][trim($data[$k])] : '';
            }

            if (isset($req_fileds["id"]))
            {
                DB::query("DELETE FROM {shop_param_element} WHERE param_id=%d AND element_id=%d", $param["id"], $id);
            }
            if ( ! empty($data[$k]))
            {
                DB::query("INSERT INTO {shop_param_element} (value, param_id, element_id) VALUES ('%s', %d, %d)", $value, $param["id"], $id);
            }
        }
    }

    /**
     * Получение массива характеристик товаров, используемых в импорте и массива типов полей, используемых в импорте
     *
     * 
     * @return array 
     */
    protected function get_params_and_req_fileds()
    {
        $k = 0;
        $params = array();
        $req_fileds = array();


        //получаем типы полей учавствующих в импорте
        $result = DB::query("SELECT type, param_id FROM {shop_import} WHERE trash='0' AND cat_id=%d ORDER BY sort ASC", $this->diafan->cat);
        while ($row = DB::fetch_array($result))
        {
            if ($row["type"] == "param")
            {
                $params[$k]["id"] = $row["param_id"];
                $params[$k]["type"] = DB::query_result("SELECT type FROM {shop_param} WHERE id=%d", $row["param_id"]);
                $params[$k]["values"] = array();
                if ($params[$k]["type"] == 'select' || $params[$k]["type"] == 'multiple')
                {
                    $result2 = DB::query("SELECT id, [name] FROM {shop_param_select} WHERE param_id=%d", $row["param_id"]);
                    while ($row2 = DB::fetch_array($result2))
                    {
                        $params[$k]["values"][$row2["name"]] = $row2["id"];
                    }
                }
            }
            $req_fileds[$row["type"]] = $k;
            $k ++;
        }

        return array($params, $req_fileds);
    }

    /**
     * Обновление сортировки
     *
     * @param array $import конфигурация импорта
     * 
     * @return void
     */
    protected function update_sort(&$import)
    {
        if ($import["type"] == 'good')
        {
            DB::query("UPDATE {shop} SET sort=id WHERE sort=0");
        }
        else
        {
            DB::query("UPDATE {shop_category} SET sort=id WHERE sort=0");
        }
    }

    /**
     * Загрузка всех изображений для товара
     *
     * 
     * @param array $req_fileds массив типов полей, используемых в импорте
     * @param array $data массив данных для импортирования
     * @param int $id идентификатор товара
     * @param string $sub_delimiter разделитель 
     * @param string $image_directory директория с изображениями для импорта (относительно корня сайта)

     * @return void
     */
    protected function upload_all_images(&$req_fileds, &$data, $id, $sub_delimiter, $image_directory)
    {
        if ( ! isset($req_fileds["image"]) || empty($data[$req_fileds["image"]]) || empty($image_directory))
        {
            return FALSE;
        }

        $image_string = trim($data[$req_fileds["image"]]);
        if (empty($image_string))
        {
            return FALSE;
        }

        $images = $this->get_image_data($req_fileds, $data, $sub_delimiter, $image_string, $image_directory);
        if (empty($images))
        {
            return FALSE;
        }

        $this->delete_old_images($id);

        foreach ($images as $image)
        {
            $this->upload_current_image($image, $id);
        }
    }

    /**
     * Загрузка 1 изображения для товара
     *
     * @param array $image данные об изображении
     * @param int $id идентификатор товара
     * @return void
     */
    protected function upload_current_image(&$image, $id)
    {
        DB::query("INSERT INTO {images} (module_name, element_id, size) 
            VALUES ('%s', '%d', '%d')", 'shop', $id, $image['size']);

        $image_id = DB::last_id("images");
        $image_name = $image['name'] . '_' . $image_id . '.jpg';
        DB::query("UPDATE {images} SET name='%h' WHERE id=%d", $image_name, $image_id);

        copy($image['address'], ABSOLUTE_PATH . USERFILES . "/shop/tmp");

        $img_temp = ABSOLUTE_PATH . USERFILES . "/shop/tmp";

        list($width, $height) = getimagesize($img_temp);
        if ($width > $this->diafan->configmodules("big_width", 'shop') || $height > $this->diafan->configmodules("big_height", 'shop'))
        {
            Image::resize($img_temp, $this->diafan->configmodules("big_width", 'shop'), $this->diafan->configmodules("big_height", 'shop'), $this->diafan->configmodules("big_quality", 'shop')
            );
        }
        copy($img_temp, ABSOLUTE_PATH . USERFILES . "/shop/" . $image_name);


        list($width, $height) = getimagesize($img_temp);
        if ($width > $this->diafan->configmodules("medium_width", 'shop') || $height > $this->diafan->configmodules("medium_height", 'shop'))
        {
            Image::resize($img_temp, $this->diafan->configmodules("medium_width", 'shop'), $this->diafan->configmodules("medium_height", 'shop'), $this->diafan->configmodules("medium_quality", 'shop')
            );
        }
        copy($img_temp, ABSOLUTE_PATH . USERFILES . "/shop/medium/" . $image_name);

        list($width, $height) = getimagesize($img_temp);
        if ($width > 50 || $height > 50)
        {
            Image::resize($img_temp, 50, 50, 70);
        }
        copy($img_temp, ABSOLUTE_PATH . USERFILES . "/shop/small/" . $image_name);

        chmod(ABSOLUTE_PATH . USERFILES . "/shop/" . $image_name, 0755);
        chmod(ABSOLUTE_PATH . USERFILES . "/shop/medium/" . $image_name, 0755);
        chmod(ABSOLUTE_PATH . USERFILES . "/shop/small/" . $image_name, 0755);
        unlink($img_temp);
    }

    /**
     * Получение данных об изображениях, доступных для загрузки
     *
     * 
     * @param array $req_fileds массив типов полей, используемых в импорте
     * @param array $data массив данных для импортирования
     * @param string $sub_delimiter разделитель 
     * @param string $image_string строка с названиями изображений, доступных для загрузки
     * @param string $image_directory директория с изображениями для импорта (относительно корня сайта)

     * @return void
     */
    protected function get_image_data(&$req_fileds, &$data, $sub_delimiter, $image_string, $image_directory)
    {
        $image_directory = preg_replace('/(^\/)|(\.)|(\/$)/', '', $image_directory) . '/';
        $images = array();
        $image_addresses = explode($sub_delimiter, $image_string);


        foreach ($image_addresses as $image_address)
        {
            if ( ! file_exists(ABSOLUTE_PATH . $image_directory . $image_address))
            {
                echo ABSOLUTE_PATH . $image_directory . $image_address . '<br>';
                continue;
            }

            $temp = array();
            $temp['address'] = ABSOLUTE_PATH . $image_directory . $image_address;
            $temp['size'] = filesize(ABSOLUTE_PATH . $image_directory . $image_address);
            $temp['name'] = preg_replace('/[^A-Za-z0-9-_]+/', '', strtolower($this->diafan->translit(substr($data[$req_fileds["name"]], 0, 50))));

            $images[] = $temp;
        }

        return $images;
    }

    /**
     * Удаление старых изображений, прикреплённых, к элементу
     *
     * @param int $id идентификатор элемента 
     * 
     * @return void
     */
    protected function delete_old_images($id)
    {
        //удаляем старое изображение
        $result = DB::query("SELECT * FROM {images} WHERE module_name='shop' AND element_id=%d", $id);
        while ($row = DB::fetch_array($result))
        {
            unlink(ABSOLUTE_PATH . USERFILES . "/shop/" . $row["name"]);
            unlink(ABSOLUTE_PATH . USERFILES . "/shop/medium/" . $row["name"]);
            unlink(ABSOLUTE_PATH . USERFILES . "/shop/small/" . $row["name"]);
        }
        DB::query("DELETE FROM {images} WHERE module_name='shop' AND element_id=%d", $id);
    }

    /**
     * Создание связей между товарами
     *
     * @param array $req_fileds массив типов полей, используемых в импорте
     * @param array $data массив данных для импортирования
     * @param string $sub_delimiter разделитель
     * 
     * @return void
     */
    protected function set_relations_between_items(&$req_fileds, &$data, $sub_delimiter)
    {
        if ( ! isset($req_fileds["rel_goods"]) || empty($data[$req_fileds["rel_goods"]]))
        {
            return FALSE;
        }

        $rel_goods_data = trim($data[$req_fileds["rel_goods"]]);
        if (empty($rel_goods_data))
        {
            return FALSE;
        }

        $relations = explode($sub_delimiter, $rel_goods_data);

        foreach ($relations as $relation)
        {
            DB::query("INSERT INTO {shop_rel} (good_id_temp, rel_good_id_temp) VALUES (%d, %d)", $data[$req_fileds["id"]], $relation);
        }
    }

    /**
     * Подготовка к созданию связей между товарами
     *
     * @param array $req_fileds массив типов полей, используемых в импорте
     * 
     * @return void
     */
    protected function prepare_before_set_relations_between_items(&$req_fileds)
    {
        if ( ! isset($req_fileds["rel_goods"]))
        {
            return FALSE;
        }
        DB::query("ALTER TABLE {shop_rel} ADD `good_id_temp` INT( 11 ),  ADD `rel_good_id_temp` INT( 11 )");
    }

    /**
     * Подготовка к созданию связей между товарами
     *
     * @param array $import конфигурация импорта
     * @param array $req_fileds массив типов полей, используемых в импорте
     * 
     * @return void
     */
    protected function trim_after_set_relations_between_items(&$import, &$req_fileds)
    {
        if ( ! isset($req_fileds["rel_goods"]))
        {
            return FALSE;
        }
        DB::query("DELETE FROM {shop_rel} WHERE good_id_temp=0 AND rel_good_id_temp=0 AND 
            good_id IN (SELECT id FROM {shop} WHERE `import`='0' AND site_id=%d)", $import["site_id"]);

        DB::query("DELETE FROM {shop_rel} WHERE good_id_temp=0 AND rel_good_id_temp=0 AND 
            rel_good_id IN (SELECT id FROM {shop} WHERE `import`='0' AND site_id=%d)", $import["site_id"]);

        DB::query("UPDATE {shop_rel} SET good_id=
            (SELECT id FROM {shop} WHERE trash='0' AND import_id=good_id_temp AND site_id=%d)", $import["site_id"]);

        DB::query("UPDATE {shop_rel} SET rel_good_id=
            (SELECT id FROM {shop} WHERE trash='0' AND import_id=rel_good_id_temp AND site_id=%d)", $import["site_id"]);

        DB::query("ALTER TABLE {shop_rel} DROP `good_id_temp`,  DROP `rel_good_id_temp`");
    }

    /**
     * Отображение элементов в меню
     *
     * @param  id $menu_id 
     * @param int $site_id
     * 
     * @return void
     */
    protected function show_in_menu($menu_id, $site_id)
    {
        DB::query("DELETE FROM {menu_parents} WHERE element_id IN (SELECT id FROM {menu} WHERE site_id=%d AND cat_id=%d
            AND module_name='shop' )
            OR parent_id IN (SELECT id FROM {menu} WHERE site_id=%d AND cat_id=%d AND module_name='shop')",
            $site_id, $menu_id, $site_id, $menu_id);
        
        DB::query("DELETE FROM {menu} WHERE module_name='shop' AND site_id=%d AND cat_id=%d AND  module_cat_id!=0 
            AND module_cat_id NOT IN (SELECT id FROM {shop_category} WHERE site_id=%d AND trash='0' 
            AND import_show_in_menu='1')", $site_id, $menu_id, $site_id);

        DB::query("UPDATE {menu} SET [name]=(SELECT [name] FROM {shop_category} WHERE site_id=%d AND trash='0' 
            AND id=module_cat_id) WHERE module_name='shop'  AND site_id=%d AND cat_id=%d ", $site_id, $site_id, $menu_id);

        DB::query("UPDATE {menu} SET [act]=(SELECT [act] FROM {shop_category} WHERE site_id=%d AND trash='0' 
            AND id=module_cat_id) WHERE module_name='shop'  AND site_id=%d AND cat_id=%d ", $site_id, $site_id, $menu_id);

        DB::query("INSERT INTO {menu} ([name], module_name, site_id, module_cat_id, cat_id,  [act])
            SELECT [name], 'shop', %d, id, %d, [act] FROM {shop_category} WHERE trash='0' AND  site_id=%d 
            AND import_show_in_menu='1'
            AND id NOT IN (SELECT module_cat_id FROM {menu} WHERE site_id=%d AND cat_id=%d AND module_name='shop'
            AND  module_cat_id!=0 )", $site_id, $menu_id, $site_id, $site_id, $menu_id);

        DB::query("CREATE TEMPORARY TABLE shop_menu_map 
            SELECT menu.id, category.id AS cat_id, category.parent_id AS cat_parent_id
            FROM {menu} AS menu LEFT JOIN {shop_category} as category ON menu.module_cat_id=category.parent_id
            WHERE menu.site_id=%d AND menu.cat_id=%d AND menu.trash='0'", $site_id, $menu_id);

        DB::query("UPDATE {menu} AS menu SET menu.parent_id=(SELECT id FROM shop_menu_map as map 
            WHERE map.cat_id=menu.module_cat_id)");

        DB::query("DROP TABLE shop_menu_map");

        DB::query("CREATE TEMPORARY TABLE shop_menu_map 
            SELECT menu.id, menu.parent_id, category.id AS cat_id, category.parent_id AS cat_parent_id
            FROM {menu} AS menu LEFT JOIN {shop_category} as category ON menu.module_cat_id=category.parent_id
            WHERE menu.site_id=%d AND menu.cat_id=%d AND menu.trash='0'", $site_id, $menu_id);
        
        DB::query("INSERT INTO {menu_parents} (element_id, parent_id) 
            SELECT map.id, map.parent_id FROM shop_menu_map as map LEFT JOIN {shop_category_parents} AS category
            ON category.parent_id = map.cat_parent_id");

        DB::query("DROP TABLE shop_menu_map");

        DB::query("UPDATE {menu} SET count_children=0, sort=id WHERE site_id=%d AND cat_id=%d AND module_name='shop'", $site_id, $menu_id);

        $result = DB::query("SELECT COUNT(id) as counts, parent_id FROM {menu_parents} WHERE parent_id!=0 
            GROUP BY  parent_id");

        while ($row = DB::fetch_array($result))
        {
            DB::query("UPDATE {menu} SET count_children=%d WHERE id=%d", $row['counts'], $row['parent_id']);
        }
    }

    /**
     * Подготовить импортируемые данные
     *
     * @param  string $delimiter разделитель полей в строке данных
     * @param string $data_f строка данных
     * @param array $req_fileds массив типов полей, используемых в импорте
     * 
     * @return void
     */
    protected function prepare_data($delimiter, $data_f, &$req_fileds)
    {
        $data = explode($delimiter, $data_f);

        foreach ($req_fileds as $key => $value)
        {
            if (in_array($key, array("id", "price", "count", "cats", "parent", "rel_goods")))
            {
                if ( ! empty($data[$value]))
                {
                    $data[$value] = $this->diafan->translit($data[$value]);
                }
            }
        }

        return $data;
    }

    /**
     * Удаляет импортированные элементы с сайта
     *
     * 
     * @return void
     */
    protected function remove_all()
    {
        $import = DB::fetch_array(DB::query("SELECT * FROM {shop_import_category} WHERE id=%d", $this->diafan->cat));

        $this->delete_items_before_parsing($import);

        if ($import["type"] == 'category' && ! empty($import["menu_id"]))
        {
            $this->show_in_menu($import['menu_id'], $import['site_id']);
        }

        $this->diafan->redirect_js(URL . 'error3/');
    }

    /**
     * Публикует / скрывает импортированные элементы на сайте
     *
     * @param enum $act активность элемента на сайте
     * @return void
     */
    protected function set_act_param($act)
    {
        $import = DB::fetch_array(DB::query("SELECT * FROM {shop_import_category} WHERE id=%d", $this->diafan->cat));

        DB::query("UPDATE {shop" . ($import["type"] == 'category' ? "_category" : "") . "} SET act='%d'
            WHERE site_id=%d", $act, $import["site_id"]);

        if ($import["type"] == 'category' && ! empty($import["menu_id"]))
        {
            $this->show_in_menu($import['menu_id'], $import['site_id']);
        }

        $this->diafan->redirect_js(URL . 'error1/');
    }

}