<?php

/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */
if ( ! defined('DIAFAN'))
{
    include dirname(dirname(dirname(__FILE__))) . '/includes/404.php';
}

/**
 * Shop_admin_payment
 *
 * Редактирование методов оплаты
 */
class Shop_admin_payment extends Frame_admin
{

    /**
     * @var string название файла. используется в имени констант, определяющих названия полей
     */
    public $file = 'shoppayment';

    /**
     * @var string таблица в базе данных
     */
    public $table = 'shop_payment';

    /**
     * Конструктор класса
     * 
     * @return void
     */
    public function __construct($diafan)
    {
        $this->diafan = $diafan;

        //поля в базе данных для редактирования
        $this->variable_table = array(
			'main' => array(
            'name' => 'text',
            'act' => 'checkbox',
            'payment' => 'function',
            'text' => 'editor')
        );

        $this->config_module = array(
            'act'   => 1,
            'del'   => 1, //удалить
            'order' => 1,
            'trash' => 1  //использовать корзину
        );

        //переводимые поля
        $this->language_names = array(
            'name',
            'text',
            'act'
        );
    }

    /**
     * Выводит список методов оплаты
     * @return boolean true
     */
    public function show_module()
    {
        $this->addnew_init(_LANG_ADD);
        $this->list_row();

        return true;
    }

    protected function edit_payment_module()
    {
		$rows = $this->get_rows();
        $values = array();
		if ( ! $this->diafan->addnew)
        {
            $values = unserialize(DB::query_result("SELECT params FROM {" . $this->table . "} WHERE id='%d'", $this->diafan->edit));
		}
        echo '
	    <script type="text/javascript">
	    $(document).ready(function(){
			$("select[name=payment]").change(function(){
				$(".tr_payment").hide();
				$(".tr_payment[payment="+$(this).val()+"]").show();
			});
			$(".tr_payment[payment="+$("select[name=payment]").val()+"]").show();
		});
		</script>
		<tr>
			<td class="td_first">
				' . $this->variable_names() . '
			</td>
			<td><select name="payment"><option value="">-</option>';
		foreach($rows as $row)
		{
			echo '<option value="'.$row["name"].'"'.($this->value == $row["name"] ? ' selected' : '').'>'.$row["config"]["name"].'</option>';
		}
        echo '</select></td>
		</tr>';

        foreach ($rows as $row)
        {
            foreach ($row["config"]["params"] as $key => $name)
            {
                echo '
				<tr class="tr_payment" payment="'.$row["name"].'" style="display:none">
					<td class="td_first">' . $name . '</td>
					<td><input type="text" value="'.(! empty($values[$key]) ? $values[$key] : '').'" size="40" name="'.$key.'"></td>
				</tr>';
            }
        }

        return true;
    }

    protected function save_payment_module()
    {
        if ( empty($_POST['payment']))
            return false;

        $payment = $this->diafan->get_param($_POST, "payment", '', 1);
		if (! file_exists(ABSOLUTE_PATH.'modules/cart/payment/'.$payment.'/cart.payment.'.$payment.'.admin.php'))
		{
			return false;
		}
		Customization::inc('modules/cart/payment/'.$payment.'/cart.payment.'.$payment.'.admin.php');
		$config_class = 'Cart_payment_'.$payment.'_admin';
		$class = new $config_class($this->diafan);

        $values = array();
        foreach ($class->config["params"] as $key => $name)
        {
            if ( ! empty($_POST[$key]))
            {
                $values[$key] = $this->diafan->get_param($_POST, $key, '', 1);
            }
        }
        $this->query[] = "payment='%s'";
        $this->value[] = $payment;

        $this->query[] = "params='%s'";
        $this->value[] = serialize($values);
        return true;
    }

	/**
	 * Получает список всех платежных систем
	 *
	 * @return array
	 */
	private function get_rows()
	{
		$rows = array();
		if (! $dirr = @opendir(ABSOLUTE_PATH.'modules/cart/payment'))
		{
			return $rows;
		}
		while (($row = readdir($dirr)) !== false)
		{
			if (file_exists(ABSOLUTE_PATH.'modules/cart/payment/'.$row.'/cart.payment.'.$row.'.admin.php'))
			{
				Customization::inc('modules/cart/payment/'.$row.'/cart.payment.'.$row.'.admin.php');
				$config_class = 'Cart_payment_'.$row.'_admin';
				$class = new $config_class();
				$rows[] = array("name" => $row, "config" => $class->config);
			}
		}
		return $rows;
	}
}
