<?php

/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */
if ( ! defined('DIAFAN'))
{
    include dirname(dirname(dirname(__FILE__))) . '/includes/404.php';
}

/**
 * Shop_admin
 *
 * Редактирование администраторов сайта
 */
class Shop_admin extends Frame_admin
{

    /**
     * @var string название файла. используется в имени констант, определяющих названия полей
     */
    public $file = 'shopelement';

    /**
     * @var string таблица в базе данных
     */
    public $table = 'shop';

    /**
     * @var array валюты
     */
    private $currency;

    /**
     * Конструктор класса
     * 
     * @return void
     */
    public function __construct($diafan)
    {
        $this->diafan = $diafan;

        //поля в базе данных для редактирования
        $this->variable_table = array(
			'main'=>
			array (
				'name' => 'text',
				'price' => 'floattext',
				'article' => 'text',
				'act' => 'checkbox',
				'no_buy' => 'checkbox',
				'hr1' => 'hr',
				'statistics' => 'function',
				'rating' => 'module',
				'comments' => 'module',
				'hr2' => 'hr',
				'hit' => 'checkbox',
				'new' => 'checkbox',
				'action' => 'checkbox',
				'hr3'=>'hr',
				'files' => 'function',
				'images' => 'module',
				'hr4' => 'hr',
				'param' => 'function',
				'hr5' => 'hr',
				'rel_goods' => 'function',
				'hr6' => 'hr',
				'cat_id' => 'function',
				'site_id' => 'function',
				'anons' => 'editor',
				'text' => 'editor',
				'clone' => 'function',
				'search' => 'module',

			),
			'other_rows'=>
			array (

				'tags' => 'module',
				'hr7' => 'hr',
				'menu' => 'module',
				'number' => 'function',
				'timeedit' => 'text',
				'title_meta' => 'text',
				'keywords' => 'text',
				'descr' => 'textarea',
				'rewrite' => 'function',
				'access' => 'function',
				'view' => 'none',
				'map_no_show' => 'checkbox',
				'hr8' => 'hr',
				'yandex' => 'function',
				'hr9' => 'hr',
				'theme' => 'function',
			)
        );

        //переводимые поля
        $this->language_names = array(
            'name',
            'title_meta',
            'act',
            'keywords',
            'descr',
            'text',
            'anons'
        );

        $this->config_module = array(
            'act' => 1, //показать/скрыть
            'menu' => 1, //используется в меню
            'del' => 1, //удалить
            'order' => 1, //сортируется
            'element_site' => 1, //модуль может быть прикреплен к нескольким страницам
            'element' => $this->diafan->configmodules("cat", "shop", $this->diafan->site) ? 1 : 0, //используются группы
            'element_multiple' => $this->diafan->configmodules("cat", "shop", $this->diafan->site) ? 1 : 0, //модуль может быть прикреплен к нескольким группам
            'search_name' => 1, //искать по названию
            'trash' => 1, //использовать корзину
            'image' => 1  //показать фотографию в списке
        );

        //выводить в списке содержание полей:
        $this->config_other_row = array(
            'text'
        );

        $this->fast_edit_rows = array('price');

        if ( ! $this->diafan->configmodules('show_yandex_element', 'shop'))
        {
            unset($this->variable_table["show_yandex"]);
        }
        else
        {
            $this->show_tr_click_checkbox = array('show_yandex' => array('yandex'));
        }

        if ( ! extension_loaded('gd') && ! extension_loaded('gd2'))
        {
            $this->diafan->error = 7;
        }

        //высота поля для Визуального редактора
        $this->editor_height = array(
            'anons' => 200,
            'text' => 400
        );
    }

    /**
     * Выводит список товаров
     * @return boolean true
     */
    public function show_module()
    {
		echo '<script type="text/javascript" src="' . BASE_PATH . 'modules/shop/admin/shop.admin.js"></script>';

        if ($this->config_module['element'] && ! $this->not_empty_categories)
        {
            echo '<div class="error">' . sprintf(_ADMIN_SHOP_EMPTY_CATEGORIES,'<a href="'.BASE_PATH_HREF.'shop/config/">', '</a>', '<a href="' . BASE_PATH_HREF . 'shop/category/' . ($this->diafan->site ? 'site' . $this->diafan->site . '/' : '') . '">', '</a>') . '</div>';
        }
        else
        {
            $this->addnew_init(_ADMIN_SHOP_ADD_GOODS);
        }

        $this->list_row();

        return true;
    }

    protected function fast_row_price($item)
    {
		$rows = $this->diafan->_shop->price_get_base($item["id"]);

		echo '</td><td class="fast_edit fast_edit_price">';
		foreach($rows as $row)
		{
			echo '<input type="text" row_id="' . $row['id'] . '" name="price" value="' . $row["price"] . '" size="3"> '.$row['currency_name'];
			if(count($rows) > 1)
			{
				if($rows[0] == $row)
				{
					echo '<a href="#">↓</a><div>';
				}
				else
				{
					echo '<br>';
				}
			}
		}
		if(count($rows) > 1)
		{
			echo '</div>';
		}
    }

    protected function fast_save_price()
    {
		$price_id = intval($_POST['id']);
		if(! $price_id)
		{
			return false;
		}
		$good_id = DB::query_result("SELECT good_id FROM {shop_price} WHERE id=%d", $price_id);
		if(! $good_id)
		{
			return false;
		}
		DB::query("UPDATE {shop_price} SET price=%f WHERE id=%d LIMIT 1", $_POST['value'], $price_id);
		$this->diafan->_shop->price_calc($good_id);

		return true;
    }

    /**
     * Вывод кнопки "Клонировать товар"
     * @return boolean true
     */
    protected function edit_clone_module()
    {

        if ($this->diafan->addnew)
            return false;

        echo '
		<tr>
			<td class="td_first">
			
			</td>
			<td>
				<input type="button" value="' . $this->variable_names() . '" class="shop_clone button" rel="' . $this->diafan->edit . '">
			</td>
		</tr>';

        return true;
    }

    /**
     * Редактирование поля "Цена"
     * @return boolean true
     */
    protected function edit_price_module()
    {
        if ( ! $this->diafan->addnew)
        {
			$rows = $this->diafan->_shop->price_get_base($this->diafan->edit);
			if(! empty($rows[0]) && empty($rows[0]["param"]))
			{
				$this->values["price"] = $rows[0]["price"];
				$this->values["count"] = $rows[0]["count_goods"];
				$this->values["currency_id"] = $rows[0]["currency_id"];
			}
			else
			{
				$this->values["price_arr"] = $rows;
			}
        }
		$this->currency = array();
		$result = DB::query("SELECT * FROM {shop_currency} WHERE trash='0'");
		while($row = DB::fetch_array($result))
		{
			$this->currency[] = $row;
		}

        echo '
		<tr id="price">
			<td class="td_first">
				' . $this->variable_names() . '
			</td>
			<td>
				<input type="text" name="' . $this->key . '" size="20" value="' . ( ! empty($this->values["price"]) ? $this->values["price"] * 1 : '')
        . '" class="inpnum"> ';
        if ($this->diafan->configmodules("use_count_goods"))
        {
            echo _LANG_COUNT . '
				<input type="text" name="count" size="20" value="' . ( ! empty($this->values["count"]) ? $this->values["count"] : 0)
            . '" class="inpnum">';
        }
		if($this->currency)
		{
			echo ' '._ADMIN_SHOP_CURRENCY.': <input name="currency" type="radio" value="0"'.(empty($this->values["currency_id"]) ? ' checked' : '').'> '._ADMIN_SHOP_CURRENCY_BASE;
			foreach($this->currency as $c)
			{
				echo ' <input name="currency" type="radio" value="'.$c["id"].'"'.(! empty($this->values["currency_id"]) && $this->values["currency_id"] == $c["id"] ? ' checked' : '').'> '.$c["name"];
			}
		}
        echo $this->show_help_row() . '
			</td>
		</tr>';

        return true;
    }

    /**
     * Редактирование поля "Статистика"
     * @return boolean true
     */
    protected function edit_statistics_module()
    {
        if ($this->diafan->addnew)
            return false;

        echo '<tr><td class="td_first">'._ADMIN_SHOPELEMENT_COUNTER_VIEW.'</td><td>' . $this->values['counter_view'] . '</td></tr>
                    <tr><td class="td_first">'._ADMIN_SHOPELEMENT_COUNTER_BUY.'</td><td>' . $this->values['counter_buy'] . '</td></tr>';
        return true;
    }

    /**
     * Редактирование поля "Яндекс.Маркет"
     * @return boolean true
     */
    protected function edit_yandex_module()
    {
        if ( ! $this->diafan->configmodules("yandex"))
        {
            return;
        }

        $u = array();

        if ( ! $this->diafan->addnew)
        {
            if ($this->value)
            {
                $conf_arr = explode("\n", $this->value);
                foreach ($conf_arr as $c_a)
                {
                    list($k, $v) = explode("=", $c_a, 2);
                    $u[$k] = $v;
                }
            }
        }

        echo '
		<tr'  . ' valign="top">
			<td align="right">'
        . $this->variable_names() . $this->show_help_row() . '
			</td>
			<td>'
        . _ADMIN_SHOPELEMENT_YANDEX_CAT . ':<br>
		<input type="text" maxLength="70" name="typePrefix" size="40" class="inptext" value="' . ( ! empty($u["typePrefix"]) ? $u["typePrefix"] : '') . '"><br>'
        . '<br>' . _ADMIN_SHOPELEMENT_YANDEX_VENDOR . ':<br>
		<input type = "text" maxLength="70" name="vendor" size="40" class="inptext" value="' . ( ! empty($u["vendor"]) ? $u["vendor"] : '') . '"><br>'
        . _ADMIN_SHOPELEMENT_YANDEX_MODEL . ':<br>
		<input type = "text" maxLength="70" name="model" size="40" class="inptext" value="' . ( ! empty($u["model"]) ? $u["model"] : '') . '"><br>'
        . _ADMIN_SHOPELEMENT_YANDEX_VENDORCODE . ':<br>
		<input type = "text" maxLength="70" name="vendorCode" size="40" class="inptext" value="' . ( ! empty($u["vendorCode"]) ? $u["vendorCode"] : '') . '"><br>'
        . _ADMIN_SHOPELEMENT_YANDEX_SALES_NOTES . ':<br>
		<input type = "text" maxLength="50" name="sales_notes" size="40" class="inptext" value="' . ( ! empty($u["sales_notes"]) ? $u["sales_notes"] : '') . '"><br>'
        . _ADMIN_SHOPELEMENT_YANDEX_MANUFACTURER_WARRANTY . ': 
		<input type = "checkbox" name="manufacturer_warranty" value="1"' . ( ! empty($u["manufacturer_warranty"]) ? ' checked' : '') . '><br><br>'
        . _ADMIN_SHOPELEMENT_YANDEX_COUNTRY_OF_ORIGINAL . ':<br>
		<input type = "text" maxLength="70" name="country_of_origin" size="40" class="inptext" value="' . ( ! empty($u["country_of_origin"]) ? $u["country_of_origin"] : '') . '">
			</td>
		</tr>';

        return true;
    }

    /**
     * Редактирование поля "Дополнительные параметры"
     * 
     * @return boolean true
     */
    protected function edit_param_module()
    {
        //значения характеристик
        $values = array();
        $rvalues = array();
		if (! $this->diafan->addnew)
        {
            $result_el = DB::query("SELECT value as rv, [value], param_id FROM {shop_param_element} WHERE element_id=%d", $this->diafan->edit);
            while ($row_el = DB::fetch_array($result_el))
            {
                $values[$row_el["param_id"]][] = $row_el["value"];
                $rvalues[$row_el["param_id"]][] = $row_el["rv"];
            }
        }

		// выбирает все характеристики (при смене раздела/категории просто показываем или скрываем характеристики)
		$result = DB::query("SELECT id, [name], type, required, [measure_unit] FROM {shop_param} WHERE trash='0' ORDER BY sort ASC");

        $multiple_params = array();
        while ($row = DB::fetch_array($result))
        {
			// выбирает категории, к которым прикреплена характеристика
            $row["cats"] = array();
			$result_rel = DB::query("SELECT cat_id FROM {shop_param_category_rel} WHERE element_id=%d", $row["id"]);
			while ($row_rel = DB::fetch_array($result_rel))
			{
				$attr = 'cat'.$row_rel["cat_id"].'="true"';
				if(!in_array($attr, $row["cats"]))
				{
					$row["cats"][] = $attr;
				}
			}
			// значения списков
            $row["options"] = array();
            if (in_array($row["type"], array('select', 'multiple')))
            {
                $result_select = DB::query("SELECT [name], id FROM {shop_param_select} WHERE param_id=%d ORDER BY sort ASC", $row["id"]);
                while ($row_select = DB::fetch_array($result_select))
                {
                    $row["options"][] = $row_select;
                }
            }
			if ($row["type"] == 'multiple' && $row["required"])
            {
                $multiple_params[] = $row;
            }
			else
			{
				$params[] = $row;
			}
        }

        if ( ! empty($multiple_params))
        {
            echo '<tr id="price_arr"><td colspan="2">
			<table id="param_table"><tr>';
            foreach ($multiple_params as $row)
            {
                echo '<td class="shop_param_td" '.implode(" ", $row["cats"]).'>' . $row['name'] . '</td>';
            }

            echo '<td class="shop_price_td">' . _LANG_PRICE . '</td>';

            if ($this->diafan->configmodules("use_count_goods", "shop", $this->diafan->site))
            {
                echo '<td class="shop_price_td">' . _LANG_COUNT . '</td>';
            }
			if($this->currency)
			{
                echo '<td class="shop_price_td">' ._ADMIN_SHOP_CURRENCY. '</td>';
			}
            echo '<td></td></tr>';
			if(! empty($this->values["price_arr"]))
			{				
				foreach($this->values["price_arr"] as $price)
				{
					echo '<tr class="param">';

					foreach ($multiple_params as $row)
					{
						echo '<td class="shop_param_td" '.implode(" ", $row["cats"]).'><select name="param'.$row["id"].'[]">';
						foreach($row["options"] as $opt)
						{
							echo '<option value="'.$opt["id"].'"'.($price["param"][$row["id"]] == $opt["id"] ? ' selected' : '').'>'.$opt["name"].'</option>';
						}
						echo '</select></td>';
					}

					echo '<td class="shop_price_td"><input name="param_price[]" value="'.$price["price"].'" size="5" type="text" class="inpnum"></td>';

					if ($this->diafan->configmodules("use_count_goods", "shop", $this->diafan->site))
					{
						echo '<td class="shop_price_td"><input name="param_count[]" value="'.$price["count_goods"].'" size="5" type="text" class="inpnum"></td>';
					}
					if($this->currency)
					{
						echo '<td class="shop_price_td"><select name="param_currency[]">
						<option value="0">'._ADMIN_SHOP_CURRENCY_BASE.'</option>';
						foreach($this->currency as $c)
						{
							echo ' <option value="'.$c["id"].'"'.($price["currency_id"] == $c["id"] ? ' selected' : '').'>'.$c["name"].'</option>';
						}
						echo '</select></td>';
					}
					echo '<td><span class="param_actions" style="display: none;">
					<a confirm="' . _ADMIN_CONFIRM_DELETE . '" action="delete_param" href="javascript:void(0)">
						<img width="13" height="13" alt="' . _LANG_DELETE . '" src="' . BASE_PATH . 'adm/img/delete.png">
					</a>
					</span></td>';
					echo '</tr>';
				}
			}
			else
			{
				echo '<tr class="param">';

				foreach ($multiple_params as $row)
				{
					echo '<td class="shop_param_td" '.implode(" ", $row["cats"]).'><select name="param'.$row["id"].'[]">';
					foreach($row["options"] as $opt)
					{
						echo '<option value="'.$opt["value"].'">'.$opt["name"].'</option>';
					}
					echo '</select></td>';
				}

				echo '<td class="shop_price_td"><input name="param_price[]" size="5" value="" type="text" class="inpnum"></td>';

				if ($this->diafan->configmodules("use_count_goods", "shop", $this->diafan->site))
				{
					echo '<td class="shop_price_td"><input name="param_count[]" size="5" value="" type="text" class="inpnum"></td>';
				}
				if($this->currency)
				{
					echo '<td class="shop_price_td"><select name="param_currency[]">
					<option value="0">'._ADMIN_SHOP_CURRENCY_BASE.'</option>';
					foreach($this->currency as $c)
					{
						echo ' <option value="'.$c["id"].'">'.$c["name"].'</option>';
					}
					echo '</select></td>';
				}
				echo '<td><span class="param_actions" style="display: none;">
				<a confirm="' . _ADMIN_CONFIRM_DELETE . '" action="delete_param" href="javascript:void(0)">
					<img width="13" height="13" alt="' . _LANG_DELETE . '" src="' . BASE_PATH . 'adm/img/delete.png">
				</a>
				</span></td>';
				echo '</tr>';
			}
			echo '</table>
				<a href="javascript:void(0)" class="param_plus" title="' . _LANG_ADD . '"><img src="' . BASE_PATH . 'adm/img/add_new.png" width="14" height="14" alt="' . _LANG_ADD . '"></a>
            <hr></td></tr>';
        }

        foreach ($params as $row)
        {
			echo '<tr class="shop_param" '.implode(" ", $row["cats"]).'>';
            if ($row["type"] == 'text')
            {
                echo '<td align="right">' . $row["name"] . '</td>
				<td>
					<input type="text" name="param' . $row["id"] . '" size="40" value="' . ( ! empty($values[$row["id"]]) ? str_replace('"', '&quot;', $values[$row["id"]][0]) : '') . '">
				</td>';
            }
            elseif ($row["type"] == 'title')
            {
                echo '<td align="right"><b>' . $row["name"] . '</b></td>
				<td></td>';
            }
            elseif ($row["type"] == 'date')
            {

                echo '<td align="right">' . $row["name"] . '</td>
				<td>
					<input type="text" id="param' . $row["id"] . '" name="param' . $row["id"] . '" size="20" value="'
					. ( ! empty($rvalues[$row["id"]]) ? $this->diafan->formate_from_date($rvalues[$row["id"]][0]) : '')
					. '" class="timecalendar" showTime="false">
				</td>';
            }
            elseif ($row["type"] == 'datetime')
            {
                echo '<td align="right">' . $row["name"] . '</td>
				<td>
					<input type="text" id="param' . $row["id"] . '" name="param' . $row["id"] . '" size="20" value="'
					. ( ! empty($rvalues[$row["id"]]) ? $this->diafan->formate_from_datetime($rvalues[$row["id"]][0]) : '')
					. '" class="timecalendar" showTime="true">
				</td>';
            }
            elseif ($row["type"] == 'numtext')
            {
                echo '<td align="right">' . $row["name"] . '</td>
				<td>
					<input type="text" name="param' . $row["id"] . '" size="20" value="' . ( ! empty($rvalues[$row["id"]]) ? str_replace('"', '&quot;', $rvalues[$row["id"]][0]) : '') . '" class="inpnum"> '.$row["measure_unit"].'
				</td>';
            }
            elseif ($row["type"] == 'textarea')
            {
                echo '<td align="right">' . $row["name"] . '</td>
				<td>
					<textarea name="param' . $row["id"] . '" cols="60" rows="5">' . ( ! empty($values[$row["id"]]) ? str_replace('"', '&quot;', $values[$row["id"]][0]) : '') . '</textarea>
				</td>';
            }
            elseif ($row["type"] == 'checkbox')
            {
                echo '<td align="right">' . $row["name"] . '</td>
				<td>
					<input type="checkbox" name="param' . $row["id"] . '" value="1"' . ( ! $this->diafan->addnew && ! empty($rvalues[$row["id"]][0]) ? " checked" : '') . '>
				</td>';
            }
            elseif ($row["type"] == 'select')
            {
                $value = ( ! empty($rvalues[$row["id"]][0]) ? $rvalues[$row["id"]][0] : '');
                echo '<td align="right">' . $row["name"] . '</td>
				<td>
					<select name="param' . $row["id"] . '">
					<option value="">-</option>';
                foreach ($row["options"] as $k => $v)
                {
                    echo '<option value="' . $v["id"] . '"' . ($value == $v["id"] ? ' selected' : '') . '>' . $v["name"] . '</option>';
                }
                echo '</select>
				</td>';
            }
            elseif ($row["type"] == 'multiple')
            {
                echo '<td align="right">' . $row["name"] . '</td>
				<td>
					<select name="param' . $row["id"] . '" multiple="multiple">
					<option value="">-</option>';
                foreach ($row["options"] as $k => $v)
                {
                    echo '<option value="' . $v["id"] . '"' . (in_array($v["id"], $rvalues[$row["id"]]) ? ' selected' : '') . '>' . $v["name"] . '</option>';
                }
                echo '</select>
				</td>';
            }
            elseif ($row["type"] == 'editor')
            {
                echo '<td colspan="2">' . $row["name"]
				.'<br><input type="checkbox" name="param' . $row["id"] . '_typograf" value="1"> '._ADMIN_TYPOGRAF
                . '<textarea name="param' . $row["id"] . '" style="width:100%;height:200px"' . ($this->diafan->_user->htmleditor ? ' class="htmleditor"' : '') . '>'
                . ( ! $this->diafan->addnew && ! empty($values[$row["id"]]) ? $values[$row["id"]][0] : '')
                . '</textarea>
				</td>';
            }
			echo '</tr>';
        }

        return true;
    }

    /**
     * Редактирование поля "Похожие товары"
     * 
     * @return boolean true
     */
    protected function edit_rel_goods_module()
    {
        Customization::inc('modules/shop/admin/shop.admin.view.php');
        echo '
		<script type="text/javascript" src="' . BASE_PATH . 'modules/shop/admin/shop.admin.js"></script>
		<tr valign="top">
			<td class="td_first">' . $this->variable_names() . '</td>
			<td>
				<div class="rel_goods">';
        if ( ! $this->diafan->addnew)
        {
            echo Shop_admin_view::rel_goods($this, $this->diafan->edit);
        }
        echo '</div>
				<a href="javascript:void(0)" class="rel_shop_plus" title="' . _LANG_ADD . '"><img src="' . BASE_PATH . 'adm/img/add_new.png" width="14" height="14" alt="' . _LANG_ADD . '"></a>
				<div class="hide" id="rel_shop_container"></div>
				' . $this->show_help_row() . '
			</td>
		</tr>';
        return true;
    }

    /**
     * Редактирование поля "Файлы"
     * @return boolean true
     */
    protected function edit_files_module()
    {
        if ( ! $this->diafan->configmodules("use_non_material_goods", "shop", $this->diafan->site))
        {
            return FALSE;
        }

        if ($this->diafan->configmodules("use_count_goods", "shop", $this->diafan->site))
        {
            echo '<tr>
			<td align="right"><td><div class="error">'
            . sprintf(_ADMIN_SHOP_CONFIG_USE_NON_MATERIAL_GOODS_ERROR, _ADMIN_SHOP_CONFIG_USE_COUNT_GOODS)
            . '</div></td></tr>';
            return FALSE;
        }

        $file_type = 1;
        echo '
		<tr>
			<td align="right">' . _ADMIN_FILES_UPLOAD . '</td>
			<td>';
        if ( ! empty($this->values["link"]))
        {
            $file_type = 2;
        }
        else
        {
            $this->values["link"] = '';
            $result = DB::query("SELECT id, name FROM {attachments} WHERE module_name='" . $this->table . "' AND element_id='%d'", $this->diafan->edit);
            while ($row = DB::fetch_array($result))
            {
                echo '<input type="hidden" name="delete_attachment" value="0"><div class="attachment">
				<a href="' . BASE_PATH . 'attachments/get/' . $row["id"] . "/" . $row["name"] . '">' . $row["name"] . '</a>
				<a href="javascript:void(0)" class="delete_file"><img src="' . BASE_PATH . 'adm/img/delete.png" width="13" height="13" alt="' . _LANG_DELETE . '"></a></div>';
            }
        }
        echo '<div class="file_type1' . ($file_type == 2 ? ' hide' : '')
        . '"><input type="file" name="attachment" size="40">' . $this->show_help_row() . '</div></td>
        </tr>';

        return true;
    }

    /**
     * Сохранение поля "Дополнительные параметры"
     * 
     * @return boolean true
     */
    protected function save_param_module()
    {
        if ( ! $this->site_id)
        {
            $this->get_site_id();
        }
        $ids = array();
		$cats = array(0);
		if($_POST["cat_id"])
		{
			$cats[] = intval($_POST["cat_id"]);
		}
		if(! empty($_POST["cat_ids"]))
		{
			foreach($_POST["cat_ids"] as $id)
			{
				$cats[] = intval($id);
			}
		}
		$result = DB::query("SELECT p.id, p.name, p.type, p.required FROM {shop_param} as p "
						. " INNER JOIN {shop_param_category_rel} as cp ON cp.element_id=p.id "
						. ($this->diafan->configmodules("cat", "shop", $this->site_id) && ! empty($cats) ?
							" AND  cp.cat_id IN (".implode(",", $cats).") " : "")
						. " WHERE p.trash='0' GROUP BY p.id ORDER BY p.sort ASC");
        $multiple_param_ids = array();

        while ($row = DB::fetch_array($result))
        {
            DB::query("DELETE FROM {shop_param_element} WHERE param_id=%d AND element_id=%d", $row["id"], $this->diafan->save);

            if ($row["type"] == "multiple" && $row["required"])
            {
                $multiple_param_ids[] = $row['id'];
            }
            elseif ( ! empty($_POST['param' . $row["id"]]))
            {
                if ($row["type"] == "date")
                {
                    $_POST['param' . $row["id"]] = $this->diafan->formate_in_date($_POST['param' . $row["id"]]);
                }
                if ($row["type"] == "datetime")
                {
                    $_POST['param' . $row["id"]] = $this->diafan->formate_in_datetime($_POST['param' . $row["id"]]);
                }
                if ($row["type"] == "editor" && ! empty($_POST['param' . $row["id"]."_typograf"]))
                {
					include_once(ABSOLUTE_PATH."plugins/remotetypograf.php");

					$remoteTypograf = new RemoteTypograf();

					$remoteTypograf->htmlEntities();
					$remoteTypograf->br (false);
					$remoteTypograf->p (true);
					$remoteTypograf->nobr (3);
					$remoteTypograf->quotA ('laquo raquo');
					$remoteTypograf->quotB ('bdquo ldquo');

					$_POST['param' . $row["id"]] = $remoteTypograf->processText ($_POST['param' . $row["id"]]);
                }

                DB::query(
                        "INSERT INTO {shop_param_element} (" . (in_array($row["type"], array("text", "editor", "textarea")) ?
                                '[value]' : 'value')
                        . ", param_id, element_id) VALUES ('%s', %d, %d)", $_POST['param' . $row["id"]], $row["id"], $this->diafan->save
                );
            }

            $ids[] = $row["id"];
        }

        if($ids)
		{
			DB::query("DELETE FROM {shop_param_element} WHERE param_id NOT IN (" . implode(", ", $ids) . ") AND element_id=%d", $this->diafan->save);
		}

        if (! $this->diafan->savenew)
        {
			// удаляет все цены
            DB::query("DELETE FROM {shop_price_param} WHERE price_id IN (SELECT id FROM {shop_price} WHERE good_id=%d)", $this->diafan->save);
            DB::query("DELETE FROM {shop_price} WHERE good_id=%d", $this->diafan->save);
        }

        // несколько вариантов цены и количества
		if ($multiple_param_ids && ! empty($_POST["param_price"]))
        {
			$selected_param_combinations = array();
            for ($k = 0; $k < count($_POST['param_price']); $k ++ )
            {
                if (empty($_POST['param_price'][$k]))
                {
                    continue;
                }
                
                $price = TRUE;
                
                $param_combination = array();
                foreach ($multiple_param_ids as $id)
                {
                    $param_combination[] = $_POST['param' . $id][$k];
                }

                //комбинация значений парамертов уже встречалась
                if (in_array(implode('_', $param_combination), $selected_param_combinations))
                {
                    continue;
                }

                $selected_param_combinations[] = implode('_', $param_combination);
				$params = array();
				foreach ($multiple_param_ids as $id)
				{
					$value = $_POST['param' . $id][$k];
					$params[$id] = $value;
				}

				$this->diafan->_shop->price_insert(
						$this->diafan->save, 
						$_POST['param_price'][$k],
						! empty($_POST['param_count'][$k]) ? $_POST['param_count'][$k] : 0,
						$params,
						! empty($_POST['param_currency'][$k]) ? $_POST['param_currency'][$k] : 0
					);
            }
        }
		// простые цена и количество
		elseif(! $multiple_param_ids && ! empty($_POST["price"]))
		{

				$this->diafan->_shop->price_insert(
						$this->diafan->save, 
						$_POST['price'],
						! empty($_POST['count']) ? $_POST['count'] : 0,
						array(),
						! empty($_POST['currency']) ? $_POST['currency'] : 0
					);
		}
		$this->diafan->_shop->price_calc($this->diafan->save);
        return true;
    }

    /**
     * Сохранение поля "Цена"
     * @return boolean true
     */
    protected function save_price_module()
    {
        return true;
    }

    /**
     * Сохранение поля "Статистика"
     * @return boolean true
     */
    protected function save_statistics_module()
    {
        return true;
    }

    /**
     * Сохранение поля "Похожие товары"
     * @return boolean true
     */
    protected function save_rel_goods_module()
    {
        return true;
    }

    /**
     * Сохранение поля "Яндекс.Маркет"
     * @return boolean true
     */
    protected function save_yandex_module()
    {
        if ( ! $this->diafan->configmodules("yandex"))
        {
            return false;
        }

        $this->query[] = "yandex='%s'";
        $this->value[] =
                'typePrefix=' . str_replace("\n", '', $this->diafan->get_param($_POST, "typePrefix", '', 1)) . "\n"
                . 'vendor=' . str_replace("\n", '', $this->diafan->get_param($_POST, "vendor", '', 1)) . "\n"
                . 'model=' . str_replace("\n", '', $this->diafan->get_param($_POST, "model", '', 1)) . "\n"
                . 'vendorCode=' . str_replace("\n", '', $this->diafan->get_param($_POST, "vendorCode", '', 1)) . "\n"
                . 'sales_notes=' . str_replace("\n", '', $this->diafan->get_param($_POST, "sales_notes", '', 1)) . "\n"
                . 'manufacturer_warranty=' . str_replace("\n", '', $this->diafan->get_param($_POST, "manufacturer_warranty", '', 1)) . "\n"
                . 'country_of_origin=' . str_replace("\n", '', $this->diafan->get_param($_POST, "country_of_origin", '', 1));

        return true;
    }

    /**
     * Сохранение поля "Файлы"
     * @return boolean true
     */
    protected function save_files_module()
    {
        if ( ! $this->diafan->configmodules("use_non_material_goods", "shop", $this->diafan->site)
                || $this->diafan->configmodules("use_count_goods", "shop", $this->diafan->site))
        {
            return FALSE;
        }
        $altname = str_replace('/', '_', strtolower(substr($this->diafan->translit($_POST["name"]), 0, 40)));
		if ( ! empty($_POST["delete_attachment"]))
		{
			$result = DB::query("SELECT id FROM {attachments} WHERE module_name='" . $this->table . "' AND element_id='%d'", $this->diafan->save);
			while ($row = DB::fetch_array($result))
			{
				DB::query("DELETE FROM {attachments} WHERE id='%d'", $row["id"]);
				unlink(ABSOLUTE_PATH . USERFILES . '/' . $this->table . '/files/' . $row["id"]);
			}
		}

        if ( ! empty($file_deleted))
        {
            $this->query[] = "is_file='%s'";
            $this->value[] = "0";
        }

        if (isset($_FILES["attachment"]) && is_array($_FILES["attachment"]) && $_FILES["attachment"]['name'] != '')
        {
			if(empty($_POST["delete_attachment"]))
			{
				$oldid = DB::query_result("SELECT id FROM {attachments} WHERE module_name='%s' AND element_id='%d'", $this->table, $this->diafan->save);
				if ($oldid)
				{
					unlink(ABSOLUTE_PATH . USERFILES . '/' . $this->table . '/files/' . $oldid);
					DB::query("DELETE FROM {attachments} WHERE module_name='%s' AND element_id='%d'", $this->table, $this->diafan->save);
				}
			}

            Customization::inc("modules/attachments/attachments.inc.php");

            $err = $this->diafan->_attachments->upload($_FILES['attachment'], $this->table, $this->diafan->save);

            if ( ! empty($err))
            {
                echo '
				<script language="javascript" type="text/javascript">
					alert(\'' . strip_tags($err) . '\');
					window.location="' . BASE_PATH_HREF . $this->diafan->rewrite . '/'
                . ($this->diafan->cat ? 'cat' . $this->diafan->cat . '/' : '')
                . ($_POST["id"] ? 'edit' . $_POST["id"] . '/' : 'addnew1/')
                . '";
				</script>';
                exit;
                echo '<script language="javascript" type="text/javascript">alert(\'' . strip_tags($err) . '\');history.go(-1);</script>';
                exit;
            }
            $this->query[] = "is_file='%s'";
            $this->value[] = "1";
        }

        return true;
    }

    /**
     * Сохранение кнопки "Клонировать товар"
     * @return boolean true
     */
    protected function save_clone_module()
    {
        return true;
    }

    /**
     * Сопутствующие действия при удалении элемента модуля
     * @return boolean true
     */
    protected function delete($del_id, $trash_id)
    {
        $this->del_or_trash_where("shop_price_param", "price_id IN (SELECT id FROM {shop_price} WHERE good_id=".$del_id.")", $trash_id);
        $this->del_or_trash_where("shop_price", "good_id=" . $del_id, $trash_id);
        $this->del_or_trash_where("shop_rel", "good_id=" . $del_id . " OR rel_good_id=" . $del_id, $trash_id);
        $this->del_or_trash_where("shop_discount_object", "good_id=" . $del_id, $trash_id);
        $this->del_or_trash_where("shop_param_element", "element_id=" . $del_id, $trash_id);

        return true;
    }
}
