<?php

/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */
if ( ! defined('DIAFAN'))
{
    include dirname(dirname(dirname(__FILE__))) . '/includes/404.php';
}

/**
 * Подключение модуля "Магазин"
 */
class Shop_inc
{
    /**
     * @var object основной объект системы
     */
    public $diafan;

    /**
     * Конструктор класса
     * 
     * @return void
     */
    public function __construct(&$diafan)
    {
        $this->diafan = &$diafan;
    }

	/**
	 * Подключает расширения для подключения
	 * 
	 * @return boolean TRUE
	 */
	public function __call($name, $args)
	{
		list($prefix, $method) = explode('_', $name, 2);
		switch($prefix)
		{
			case 'price':
				Customization::inc('modules/shop/inc/shop.inc.price.php');
				$shop = new Shop_inc_price($this->diafan);
				break;

			case 'order':
				Customization::inc('modules/shop/inc/shop.inc.order.php');
				$shop = new Shop_inc_order($this->diafan);
				break;

			default:
				return false;
		}
		return call_user_func_array(array($shop, $method), $args);
	}
}