<?php

/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */
if (!defined('DIAFAN'))
{
    include dirname(dirname(dirname(__FILE__))) . '/includes/404.php';
}

/**
 * Функция вывода списка товаров 
 * в группе товаров, в результатах поиска или если группировка не используется
 */

echo '<div class="shop_list">';



//вывод описания текущей категории
if (!empty($result["text"]))
{
	echo '<div class="shop_cat_text">' . $result["text"] . '</div>';
}

//вывод изображений текущей категории
if (!empty($result["img"]))
{
	echo '<div class="shop_cat_all_img">';
	foreach ($result["img"] as $img)
	{
		switch ($img["type"])
		{
			case 'animation':
				echo '<a href="' . BASE_PATH . $img["link"] . '" rel="prettyPhoto[gallery' . $result["id"] . 'shop]">';
				break;
			case 'big_image':
				echo '<a href="' . BASE_PATH . $img["link"] . '" rel="big_image" width="' . $img["link_width"] . '" height="' . $img["link_height"] . '">';
				break;
			default:
				echo '<a href="' . BASE_PATH_HREF . $img["link"] . '">';
				break;
		}
		echo '<img src="' . $img["src"] . '" width="' . $img["width"] . '" height="' . $img["height"] . '" alt="' . $img["alt"] . '" title="' . $img["title"] . '">'
		. '</a> ';
	}
	echo '</div>';
}

//вывод подкатегории
if (!empty($result["children"]))
{
	foreach ($result["children"] as $child)
	{
		echo '<div class="shop_cat_link">';

		//вывод изображений подкатегории
		if (!empty($child["img"]))
		{
			echo '<div class="shop_cat_img">';
			foreach ($child["img"] as $img)
			{
				switch ($img["type"])
				{
					case 'animation':
						echo '<a href="' . BASE_PATH . $img["link"] . '" rel="prettyPhoto[gallery' . $child["id"] . 'shop]">';
						break;
					case 'big_image':
						echo '<a href="' . BASE_PATH . $img["link"] . '" rel="big_image" width="' . $img["link_width"] . '" height="' . $img["link_height"] . '">';
						break;
					default:
						echo '<a href="' . BASE_PATH_HREF . $img["link"] . '">';
						break;
				}
				echo '<img src="' . $img["src"] . '" width="' . $img["width"] . '" height="' . $img["height"] . '" alt="' . $img["alt"] . '" title="' . $img["title"] . '">'
				. '</a> ';
			}
			echo '</div>';
		}

		//название и ссылка подкатегории
		echo '<a href="' . BASE_PATH_HREF . $child["link"] . '">' . $child["name"] . '</a>';

		//краткое описание подкатегории
		if ($child["anons"])
		{
			echo '<div class="shop_cat_anons">' . $child["anons"] . '</div>';
		}
		echo '</div>';
	}
}

//вывод списка товаров
if (!empty($result["rows"]))
{
	//вывод сортировки товаров
	if(! empty($result["link_sort"]))
	{
		$this->get('sort_block', 'shop', $result);
	}

	foreach ($result["rows"] as $row)
	{
		echo '<table class="shop"><tr><td colspan=2 valign=top>';

		//вывод названия и ссылки на товара
		echo '<div class="shop_name">';
		echo '<a href="' . BASE_PATH_HREF . $row["link"] . '">' . $row["name"] . '</a>';
		//рейтинг товара
		if (!empty($row["show_rating"]))
			echo ' ' . $row["show_rating"];
		echo '</div>';

		//вывод артикула
		if (!empty($row["article"]))
		{
			echo '<div class="shop_article">';
			echo $this->_('ARTICLE') . ':'; //вывод слова "Артикул" из языковой переменной
			echo '<span class="shop_article_value">' . $row["article"] . '</span>';
			echo '</div>';
		}

		echo '</td></tr><tr><td valign=top width=5%>';

		//вывод изображений товара
		if (!empty($row["img"]))
		{
			echo '<div class="shop_img">';
			foreach ($row["img"] as $img)
			{
				switch ($img["type"])
				{
					case 'animation':
						echo '<a href="' . BASE_PATH . $img["link"] . '" rel="prettyPhoto[gallery' . $row["id"] . 'shop]">';
						break;
					case 'big_image':
						echo '<a href="' . BASE_PATH . $img["link"] . '" rel="big_image" width="' . $img["link_width"] . '" height="' . $img["link_height"] . '">';
						break;
					default:
						echo '<a href="' . BASE_PATH_HREF . $img["link"] . '">';
						break;
				}
				echo '<img src="' . $img["src"] . '" width="' . $img["width"] . '" height="' . $img["height"] . '" alt="' . $img["alt"] . '" title="' . $img["title"] . '">'
				. '</a> ';
			}
			echo '</div>';
		}

		echo '</td>';
		echo '<td valign=top>';

		if (!empty($row['hit']))
		{
			echo '<div class="shop_hit">' . $this->_('SHOP_HIT') . '</div>';
		}
		if (!empty($row['action']))
		{
			echo '<div class="shop_action">' . $this->_('SHOP_ACTION') . '</div>';
		}
		if (!empty($row['new']))
		{
			echo '<div class="shop_new">' . $this->_('SHOP_NEW') . '</div>';
		}

		//вывод параметров товара
		if (!empty($row["param"]))
		{
			$this->get('param', 'shop', $row["param"]);
		}

		//вывод скидки на товар
		if (!empty($row["discount"]))
		{
			echo '<div class="shop_discount">' . $this->_('DISCOUNT') . ': <span class="shop_discount_value">' . $row["discount"] . ' %' . ($row["discount_finish"] ? ' (' . $this->_('TO') . ' ' . $row["discount_finish"] . ')' : '') . '</span></div>';
		}

		//вывод краткого описания товара
		if (!empty($row["anons"]))
		{
			echo '<div class="shop_anons">' . $row["anons"] . '</div>';
		}

		//цена на товар
		if (!empty($row["price"]))
		{
			echo '<div class="shop_price">' . $this->_('PRICE') . ': <span class="shop_price_value">' . $row["price"] . '</span> <span class="shop_price_currency">' . $result["currency"] . '</span></div>';
			if (!empty($row["old_price"]))
			{
				echo '<div class="shop_old_price">' . $this->_('OLD_PRICE') . ': <span class="shop_price_value">' . $row["old_price"] . '</span>'
				. ' <span class="shop_price_currency">' . $result["currency"] . '</span></div>';
			}
		}

		//вывод кнопки "Купить"
		$this->get('form', 'shop', array("row" => $row, "result" => $result));

		$this->get('compare_form', 'shop', $row);
		echo '</td></tr></table>';
	}
	echo '<div class="clear"></div>';
}

if (!empty($result["rows"]) && ! empty($result['shop_link']))
{
	$this->get('compared_goods_list', 'shop', array("site_id" => $this->diafan->cid, "shop_link" => $result['shop_link']));
}

//постраничная навигация
if (!empty($result["paginator"]))
{
	echo $result["paginator"];
}

//вывод комментариев ко всей категории товаров (комментарии к конкретному товару в функции id())
if (!empty($result["comments"]))
{
	echo $result["comments"];
}

//ссылки на предыдущую и последующую категории
if (!empty($result["previous"]) || !empty($result["next"]))
{
	echo '<div class="previous_next_links">';
	if (!empty($result["previous"]))
	{
		echo '<div class="previous_link"><a href="' . BASE_PATH_HREF . $result["previous"]["link"] . '">&larr; ' . $result["previous"]["text"] . '</a></div>';
	}
	if (!empty($result["next"]))
	{
		echo '<div class="next_link"><a href="' . BASE_PATH_HREF . $result["next"]["link"] . '">' . $result["next"]["text"] . ' &rarr;</a></div>';
	}
	echo '</div>';
}



echo '</div>';