<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Update_admin_repair
 *
 * Восстановление базы данных
 */
class Update_admin_repair extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file = 'repair';

	/**
	 * @var string таблица в базе данных
	 */
	public $table = 'repair';

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		// 0 - выключить восстановление
		// 1 - включить восстановление, лог восстановления
		// 2 - включить восстановление, полный лог
		define('REPAIR', 1);

		$this->diafan = $diafan;
	}

	/**
	 * Выводит контент модуля
	 * @return boolean true
	 */
	public function show_module()
	{
		if (! empty($_GET["repair"]) && REPAIR)
		{
			$this->repair();
			return true;
		}
		echo '<p><a href="'.URL.'?repair=1">'._ADMIN_REPAIR.'</a></p>';
		return true;
	}

	/**
	 * Восстановление базы данных
	 * @return boolean true
	 */
	public function repair()
	{
		define('IS_INSTALL', 1);

		global $language;
		$language = array();
		$result = DB::query("SELECT id FROM {language}");
		while ($row = DB::fetch_array($result))
		{
			$language[] = $row["id"] != 1 ? $row["id"] : '';
		}

		$url = parse_url(DB_URL);
		$result = DB::query("SHOW TABLES FROM ".substr($url['path'], 1));
		while ($row = DB::fetch_array($result))
		{
			$tables[] = str_replace(DB_PREFIX, '', $row[0]);
		}
		if (file_exists(ABSOLUTE_PATH.'installation/core.php'))
		{
			include_once ABSOLUTE_PATH.'installation/core.php';
			$this->check_file($sql, $tables);
			$error = false;
		}
		else
		{
			echo '<p>Ошибка: файл installation/core.php не существует.</p><hr>';
			$error = true;
		}

		$result = DB::query("SELECT rewrite FROM {adminsite}");
		while ($row = DB::fetch_array($result))
		{
			if (file_exists(ABSOLUTE_PATH."modules/".$row["rewrite"]."/".$row["rewrite"].".install.php"))
			{
				include_once ABSOLUTE_PATH."modules/".$row["rewrite"]."/".$row["rewrite"].".install.php";
				$this->check_file($sql, $tables);
				$func = 'module_basic_'.$row["rewrite"];
				if (function_exists($func))
				{
					$func();
				}
			}
		}
		echo '<p><font color="red">'._ADMIN_REPAIR_SUCCESS.'</font></p>';

		exit;
	}

	/**
	 * Восстановление базы данных из файла
	 * @return boolean true
	 */
	private function check_file($sql, $tables)
	{	
		foreach ($sql as $query)
		{
			if (preg_match('/CREATE TABLE \{(.*)\} \(([\w\W]*)PRIMARY KEY/', $query, $m))
			{
				$table = $m[1];
				if (REPAIR == 2)
				{
					echo '<p>Таблица: <b>'.DB_PREFIX.$table.'</b>';
				}
				if (in_array($table, $tables))
				{
					if (REPAIR == 2)
					{
						echo ' существует';
					}
					$fields = explode('
	', $m[2]);
					$table_fileds = array();
					$result = DB::query("DESCRIBE {".$table."}");
					while ($row = DB::fetch_array($result))
					{
						$table_fileds[] = $row[0];
					}
					foreach ($fields as $f)
					{
						$f = trim($f);
						if (preg_match('/([^ ]*) (.*),/', $f, $fm))
						{
							$fm[1] = str_replace('`', '', $fm[1]);
							if (! in_array($fm[1], $table_fileds))
							{
								if (REPAIR == 2)
								{
									echo '<br>добавлено поле <b>'.$fm[1].'</b>:<pre>ALTER TABLE {'.$table."} ADD `".$fm[1]."` ".$fm[2].'</pre>';
									DB::query("ALTER TABLE {".$table."} ADD `".$fm[1]."` ".$fm[2]);
								}
								else
								{
									echo '<p>Добавлено поле <b>'.$fm[1].'</b> в таблицу <b>'.DB_PREFIX.$table.'</b>:
									<pre>ALTER TABLE {'.$table."} ADD `".$fm[1]."` ".$fm[2].'</pre></p><hr>';
									DB::query("ALTER TABLE {".$table."} ADD `".$fm[1]."` ".$fm[2]);
								}
							}
							else
							{
								if (REPAIR == 2)
								{
									echo '<br>поле <b>'.$fm[1].'</b> существует';
								}
							}
						}
						elseif ($f && REPAIR == 2)
						{
							echo '<br>не обработано поле <b>'.$fm[1].'</b>';
						}
					}
					$this->update_table_parents($table);
				}
				else
				{
					if (REPAIR == 2)
					{
						echo ' добавлена:<br><pre>'.$query.'</pre>';
					}
					else
					{
						echo '<p>Таблица: <b>'.DB_PREFIX.$table.'</b> добавлена:<br><pre>'.$query.'</pre></p><hr>';
					}
					DB::query($query);
				}
				if (REPAIR == 2)
				{
					echo '</p><hr>';
				}
			}
			elseif (preg_match('/INSERT INTO \{(.*)\} \(([\w\W]*)\) VALUES \(([\w\W]*)\)/', $query, $m))
			{
				$id = 0;
				$table  = $m[1];
				if (in_array($table, array('config', 'site', 'rewrite')))
					continue;

				$names  = explode(',', $m[2]);
				$values = explode(',', $m[3]);
				$where = array();
		
				for ($i = 0; $i < count($names); $i++)
				{
					$names[$i]  = str_replace('`', '', trim($names[$i]));
					$values[$i] = trim($values[$i]);
					if ($names[$i] == 'id')
					{
						$id = $values[$i];
					}
					$where[] = $names[$i]."=".$values[$i];
				}
				if (! empty($id))
				{
					if (! DB::query_result("SELECT COUNT(*) FROM {".$table."} WHERE id='%d'", $id))
					{
						echo '<p>Добавлена запись:<pre>'.htmlspecialchars($query).'</pre></p><hr>';
						DB::query($query);
					}
					elseif (REPAIR == 2)
					{
						echo '<p>Запись существует:<pre>'.htmlspecialchars($query).'</pre></p><hr>';
					}
				}
				else
				{
					if (! DB::query_result("SELECT COUNT(*) FROM {".$table."} WHERE ".implode(' AND ', $where)))
					{
						echo '<p>Добавлена запись:<pre>'.htmlspecialchars($query).'</pre></p><hr>';
						DB::query($query);
					}
					elseif (REPAIR == 2)
					{
						echo '<p>Запись существует:<pre>'.htmlspecialchars($query).'</pre></p><hr>';
					}
				}
			}
			elseif (! strstr($query, 'ALTER') && REPAIR == 2)
			{
				echo '<p>Не обработано:<pre>'.htmlspecialchars($query).'</pre></p><hr>';
			}
		}
		return true;
	}

	/**
	 * Обновление таблицы родительских связей
	 * @return boolean true
	 */
	private function update_table_parents($table)
	{
		if (strstr('_parents', $table))
		{
			DB::query("TRUNCATE TABLE {".$table."}");
			$table_parent = str_replace('_parents', '', $table);
			
			$result = DB::query("SELECT parent_id, id FROM {".$table_parent."}");
			while ($row = DB::fetch_array($result))
			{
				if ($row["parent_id"])
				{
					$parents = array();
					while ($parent_id > 0 && ! in_array($parent_id, $parents))
					{
						$parents[] = $parent_id;
						DB::query("INSERT INTO {".$table."} (`element_id`, `parent_id`) VALUES (%d, %d)", $row["id"], $parent_id);
						$parent_id = DB::query_result("SELECT parent_id FROM {".$table_parent."} WHERE id=%d", $parent_id);
					}
				}
			}
			$result = DB::query("SELECT id FROM {".$table_parent."}"); 
			while ($row = DB::fetch_array($result))
			{
				$count = DB::query_result("SELECT COUNT(*) FROM  {".$table."} WHERE parent_id=%d", $row["id"]);
				DB::query("UPDATE {".$table_parent."} SET count_children=%d WHERE id=%d", $count, $row["id"]);
			}
		}
		return true;
	}
}

function multilang($str)
{
	global $language;
	$result = '';

	$arg = func_get_args();
	$i = 0;

	foreach ($language as $lang)
	{
		if (isset($arg[$i]))
		{
			$str = $arg[$i];
		}
		$result .= str_replace('LANG', $lang, $str).' ';
		$i ++;
	}
	if (! $result)
	{
		$result = str_replace('LANG', '', $str);
	}
	return $result;
}