<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Useradmin_admin_ajax
 *
 * Обработка запроса на редактирование данных из пользовательской части
 */
class Useradmin_admin_ajax
{
	/**
	 * @var object основной объект системы
	 */
	private $diafan;

	/**
	 * @var array результат выполенения
	 */
	private $result;

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($frame)
	{
		$this->diafan = $frame->diafan;

		if (! empty($_POST['module']) && $_POST['module'] == 'useradmin')
		{
			if (empty($_POST["module_name"]) || empty($_POST["name"]))
			{
				$this->result["errors"][0] = 'ERROR';
				return $this->send_errors(true);
			}
			if ($_POST["module_name"] != "language_file" && empty($_POST["element_id"]))
			{
				$this->result["errors"][0] = 'ERROR';
				return $this->send_errors(true);
			}
			if (! $this->diafan->_user->checked)
			{
				$this->result["errors"][0] = 'ERROR';
				return $this->send_errors(true);
			}
			if ($_POST["module_name"] != "language_file" && $this->diafan->admin_roles('save', $_POST["module_name"]) || $_POST["module_name"] == "language_file" && $this->diafan->admin_roles('save', "language"))
			{
				$this->result["errors"][0] = 'ERROR';
				return $this->send_errors(true);
			}
			include_once ABSOLUTE_PATH.'includes/model.php';
			if ($_POST["module_name"] == "language_file")
			{
				$lang = (int)$this->diafan->get_param($_POST, "lang_id", "", 2);
				$shortname = ! $lang || $lang == 1 ? LANGUAGE_BASE : DB::title("language", $lang, "shortname");
				$name = $this->diafan->get_param($_POST, "name", "", 1);
				$shortname;
				$string = file_get_contents(ABSOLUTE_PATH.'language/'.$shortname.'.php');
				$string = preg_replace("/define\('_LANG_".$name."', '[^']+'\);/", "define('_LANG_".$name."', '".str_replace(array("\n", "'"), array('', '&#39;'), $_POST["value"])."');", $string);
				$fp = fopen(ABSOLUTE_PATH.'language/'.$shortname.'.php', "w");
				fwrite($fp, $string);
				fclose($fp);
			}
			else
			{
				$type = ! empty($_POST["type"]) ? $_POST["type"] : $this->diafan->_useradmin->type($_POST["name"]);
				switch($type)
				{
					case 'editor':
						if(! empty($_POST["typograf"]))
						{
							include_once(ABSOLUTE_PATH."plugins/remotetypograf.php");

							$remoteTypograf = new RemoteTypograf();

							$remoteTypograf->htmlEntities();
							$remoteTypograf->br (false);
							$remoteTypograf->p (true);
							$remoteTypograf->nobr (3);
							$remoteTypograf->quotA ('laquo raquo');
							$remoteTypograf->quotB ('bdquo ldquo');

							$_POST["value"] = $remoteTypograf->processText ($_POST["value"]);
						}
						$mask = "'%s'";
						break;
					case 'date':
						$_POST["value"] = $this->diafan->unixdate($_POST["value"]);
						$mask = "'%d'";
						break;
					case 'text':
					case 'textarea':
						$mask = "'%h'";
						break;
					case 'numtext':
						$mask = "'%d'";
						break;
				}
				$lang = (!empty($_POST['lang_id'])?(int)$this->diafan->get_param($_POST, "lang_id", "", 2):'');
	
				DB::query("UPDATE {%h} SET %h".$lang."=".$mask." WHERE id=%d",$_POST["module_name"],  $_POST["name"], $_POST["value"], $_POST["element_id"]);
				$module = explode('_', $_POST["module_name"]);
				$this->diafan->_cache->delete("", $module[0]);
			}

			$this->result["success"] = true;

			return $this->send_errors();
		}
		return false;
	}

	/**
	 * Отправляет результат
	 *
	 * @return boolean
	 */
	private function send_errors()
	{
		if (! empty($this->result["errors"]) || ! empty($this->result["success"]))
		{
			include_once ABSOLUTE_PATH.'plugins/json.php';
			echo to_json($this->result);
			return true;
		}
		return false;
	}
}