<?php
/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */

if (! defined('DIAFAN'))
{
	include dirname(dirname(dirname(__FILE__))).'/includes/404.php';
}

/**
 * Votes_admin_category
 *
 * Редактирование вопросов для голосования
 */
class Votes_admin_category extends Frame_admin
{
	/**
	 * @var string название файла. используется в имени констант, определяющих названия полей
	 */
	public $file = 'votesquest';

	/**
	 * @var string таблица в базе данных
	 */
	public $table = 'votes_category';

	/**
	 * Конструктор класса
	 * 
	 * @return void
	 */
	public function __construct($diafan)
	{
		$this->diafan = $diafan;

		//поля в базе данных для редактирования
		$this->variable_table = array(
			'main'=>
			array (
				'name' => 'text',
				'act' => 'checkbox',
				'site_id' => 'select',
			)
		);

		//переводимые поля
		$this->language_names = array(
			'name',
			'act'
		);

		$this->config_module = array(
			'del'             => 1, //удалить
			'act'             => 1, //показать/скрыть
			'category'        => 1, //часть модуля - категории
			'link_to_element' => 1, //основная ссылка ведет к списку элементов, принадлежащих категории
			'order'           => 1, //сортируется
			'trash'           => 1  //использовать корзину
		);

		//выводить в списке содержание полей:
		$this->config_other_row = array(
			'site_id'
		);
	}

	/**
	 * Выводит список вопросов
	 * @return boolean true
	 */
	public function show_module()
	{
		$this->addnew_init(_ADMIN_VOTESQUEST_ADD);
		
		$this->list_row();
		

		return true;
	}

	/**
	 * Выводит количество ответов на вопрос
	 * @return string
	 */
	protected function other_row_site_id($row)
	{
		$text = '</td><td class="module_name">';
		if ($row["site_id"])
		{
			if (! isset($this->cache["site"][$row["site_id"]]["name"]))
			{
				$this->cache["site"][$row["site_id"]]["name"] = DB::query_result("SELECT name FROM {site} WHERE id=%d AND trash='0'", $row["site_id"]);
			}
			$text .= $this->cache["site"][$row["site_id"]]["name"];
		}
		else
		{
			$text .= _ADMIN_VOTESQUEST_PREVAILING;
		}
		return $text;
	}

	/**
	 * Редактирование поля "Расположение"
	 * 
	 * @return boolean
	 */
	protected function edit_site_id_module()
	{
		echo '
		<tr valign="top">
			<td align="right">'.$this->variable_names().'</td>
			<td>
				<select name="'.$this->key.'">
					<option value="">'._ADMIN_VOTESQUEST_PREVAILING.'</option>';

		$marker = "&nbsp;&nbsp;";
		$result = DB::query("SELECT id, name, parent_id FROM {site} WHERE trash='0' AND act='1' AND block='0' ORDER BY id ASC");
		while ($row = DB::fetch_array($result))
		{
			$cats[$row["parent_id"]][] = $row;
		}
		echo $this->get_options($cats, $cats[0], array($this->value)).'
				</select>
				'.$this->show_help_row().'
			</td>
		</tr>';
		return true;
	}
}