<?php

/**
 * Diafan.CMS
 *
 * @author     diafan.ru
 * @version    5.0
 * @license http://cms.diafan.ru/license.html
 * @copyright  Copyright (c) 2003-2012 OOO "Диафан". (http://diafan.ru)
 */
if (!defined('DIAFAN'))
{
    include dirname(dirname(dirname(__FILE__))) . '/includes/404.php';
}

/**
 * Wishlist_ajax
 *
 * Обработка запроса при пересчете суммы покупки в списке желаний
 */
class Wishlist_ajax extends Ajax 
{
    /**
     * Обрабатывает полученные данные из формы
     * 
     * @return boolean
     */
    public function ajax_request()
    {
        if (! empty($_POST['module']) && $_POST['module'] == 'wishlist' && (! $this->diafan->configmodules('security_user', 'shop') || $this->diafan->_user->id) || empty($_POST["action"]))
        {
			switch($_POST["action"])
			{
				case 'recalc':
					return $this->recalc();

				case 'buy':
					return $this->buy();

				default :
					return false;
			}
		}
		return false;
	}

    /**
     * Пересчет суммы заказа
     * 
     * @return boolean
     */
	private function recalc()
	{
		$summ  = 0;
		$count = 0;
		if (!empty($_SESSION["wishlist"]))
		{
			foreach ($_SESSION["wishlist"] as $good_id => $array)
			{
				foreach ($array as $param => $c)
				{
					if (!empty($_POST['del' . $good_id . '_' . $param]) || empty($_POST['editshop' . $good_id . '_' . $param]))
					{
						unset($_SESSION["wishlist"][$good_id][$param]);
					}
					elseif($_POST['editshop' . $good_id . '_' . $param] != $_SESSION["wishlist"][$good_id][$param]["count"])
					{
						$_SESSION["wishlist"][$good_id][$param]["count"] = $this->diafan->get_param($_POST, 'editshop' . $good_id . '_' . $param, 0, 2);
					}
				}
			}
		}
		$json["error"] = _LANG_CHANGES_SAVED;

		if (!empty($_POST['ajax']))
		{
			Customization::inc('modules/wishlist/wishlist.model.php');
			$model  = new Wishlist_model($this->diafan);
			$result = $model->form();

			$json["table"] = $this->diafan->_tpl->get('table', 'wishlist', $result);

			echo $this->to_json($json);
		}
		else
		{
			$this->diafan->redirect($this->diafan->_route->current_link() . '?error=wishlist&mess=' . $json["error"]);
		}
		return true;
    }

	/**
	 * Добавляет товар в корзину
	 * 
	 * @return boolean
	 */
	private function buy()
	{
		if (! empty($_POST['good_id']) && (! $this->diafan->configmodules('security_user') || $this->diafan->_user->id))
		{
			$count = $this->diafan->get_param($_POST, "count", 1, 2);
			$count = $count > 0 ? $count : 1;

			if (!empty($_SESSION["wishlist"]))
			{
				foreach ($_SESSION["wishlist"] as $good_id => $array)
				{
					foreach ($array as $param => $c)
					{
						if($good_id . '_' . $param == $_POST['good_id'])
						{
							if(! empty($_SESSION["cart"][$good_id][$param]["count"]))
							{
								$count += $_SESSION["cart"][$good_id][$param]["count"];
							}
							$price = $this->diafan->_shop->price_get($good_id, $c["param"], $this->diafan->_user->id);
							if ($this->diafan->configmodules('use_count_goods', 'shop'))
							{
								if ($count > $price["count_goods"])
								{
									$this->result["error"] = sprintf(_LANG_NOT_GOOD, $price["count_goods"]);
									echo $this->to_json($this->result);
									return true;
								}
							}
							$_SESSION["cart"][$good_id][$param]["count"] = $count;
							$_SESSION["cart"][$good_id][$param]["param"] = $c["param"];
							unset($_SESSION["wishlist"][$good_id][$param]);

							$_SESSION["cart_summ"]     = ! empty($_SESSION["cart_summ"]) ? $_SESSION["cart_summ"] : 0;
							$_SESSION["cart_count"]    = ! empty($_SESSION["cart_count"]) ? $_SESSION["cart_count"] : 0;

							$_SESSION["cart_summ"]  += $c["count"] * $price["price"];
							$_SESSION["cart_count"] += $c["count"];

							DB::query("UPDATE {shop} SET counter_buy=counter_buy+1 WHERE id='%d'", $good_id);

							$cart_tpl = array("count" => $_SESSION["cart_count"], "summ" => $this->diafan->format_price($_SESSION["cart_summ"]), "currency" => $this->diafan->configmodules("currency", "shop"));

							$this->result["target"] = "#show_cart";
							$this->result["data"]   = $this->diafan->_tpl->get('info', 'cart', $cart_tpl);

							$cart_link = BASE_PATH_HREF.$this->diafan->_route->module("cart",true);
							$this->result["error"] = sprintf(_LANG_GOODS_ADDED, $cart_link);
							$this->result["success"] = true;

							Customization::inc('modules/wishlist/wishlist.model.php');
							$model  = new Wishlist_model($this->diafan);
							$result = $model->form();

							$this->result["table"] = $this->diafan->_tpl->get('table', 'wishlist', $result);

							echo $this->to_json($this->result);
							return true;
						}
					}
				}
			}
			$this->result["error"] = 'ERROR';
			echo $this->to_json($this->result);
			return true;
		}
		return false;
	}
}